((

        CODE2010.FTH

        Author: S Pelc, P Galliene

        Date started:   02/08/89
        Last modified:  14/08/91

        'Primitive' definitions, including processor specific detail.

))


only forth definitions




\ >>n <<n >>8 <<8 arsn lsrn lsln
\

: >>n           \ 16b n -- 16b
  1 - for  U2/  next  ;			\ Shift Right n Bits

: <<n           \ 16b n -- 16b
  1 - for  2*  next  ;			\ Shift Left n Bits

: >>8           \ n1 -- n2
  u2/ u2/ u2/ u2/  u2/ u2/ u2/ u2/  ;

: <<8           \ n1 -- n2
  2* 2* 2* 2*  2* 2* 2* 2*  ;

: arsn          \ n1 n2 -- n3
  ?dup
  if  1 - for  2/ next  endif  ;	\ Arithmetic Shift Right n Bits

: lsrn           \ 16b n -- 16b
  ?dup
  if  1 - for  U2/  next  endif  ;	\ Shift Right n Bits

: lsln           \ 16b n -- 16b
  ?dup
  if  1 - for  2*  next  endif  ;	\ Shift Left n Bits




\ ?dup rot -rot 2swap 2over pick roll
\

: ?Dup		                \ n -- n n | n -- n
  Dup					\
  if
    Dup Exit
  endif
;

: Rot           \ n1 n2 n3 -- n2 n3 n1
  >R Swap R> Swap  ;

: -rot          \ n3 n2 n1 -- n1 n3 n2
  swap >r swap r>  ;

: 2swap         \ n1 n2 n3 n4 -- n3 n4 n1 n2
  rot >r  rot r>  ;

: 2over         \ n1 n2 n3 n4 -- n1 n2 n3 n4 n1 n2
  >r >r  2dup  r> -rot  r> -rot  ;

: pick          \ n1 -- n2 ; only for the sake of compatibility
  dup
  if  md@ >r  sr@ >r
      dup md!
      begin  swap >r 1- dup  while  repeat  
      drop
      dup sr!
      md@
      begin  r>  swap 1- dup  while  repeat
      drop
      sr@
      r> sr!  r> md!
  else  drop  dup
  endif  ;

: roll          \ n1 -- n2 ; only for the sake of compatibility
  dup
  if  md@ >r  sr@ >r
      dup md!
      begin  swap >r 1- dup  while  repeat
      drop
      sr!
      md@
      begin  r>  swap 1- dup  while  repeat
      drop
      sr@
      r> sr!  r> md!
  else  drop  dup
  endif  ;




\ sp@ sp! rp@ rp! depth
\

hex

: sp@           \ -- n ; get parameter stack pointer
  9 g@ 0FF and  ;                      \ some oddities

: sp!           \ n -- ; set parameter stack pointer
  0FF and  9 g@  0FF00 and  or  9 g!  ;


: rp@           \ -- n ; get return stack pointer
  9 g@ 0100 - >>8  ;                    \ 1 for RP@

: rp!           \ n -- ; set return stack pointer
  1+ <<8                                \ allow for return popping r. stack
  9 g@ 1-  0FF and  or  9 g!  ;		\ 1 already on data stack to discard

: depth         \ -- n ; return the depth of the parameter stack
  sp@  ;




\ +! c+! 2@ 2! incr decr
\

: +!            \ n a --
  >R R@ @
  + R> ! 
;

: c+!		\ b addr -- ; increment byte at addr by b
  >R  R@ c@ +  R> c!  ;

: 2@            \ a -- d
  @++ @ swap
;

: 2!               \ d a --
  !++ !
;

: Incr          \ addr --
  >r  r@ @  1+  r> !  ;

: Decr          \ addr --
  >r  r@ @  1-  r> !  ;




\ um* * m* um/mod m/mod /mod mod */mod */ mu/mod
\

: UM*           \ u1 u2 -- ud
  mulu mlr@ mhr@  ;                     \ see RTX Prog Ref

: *             \ n1 n2 -- n3
  muls mlr@ nip  ;                      \ see RTX Prog Ref

: m*            \ n1 n2 -- d
  muls mlr@ mhr@  ;                     \ see RTX Prog Ref

decimal

: um/mod        \ ud u -- urem uquot
  md!  0+ d2*
  u/1' u/' u/' u/'  u/' u/' u/' u/'	\ step of u/1' then 14 steps of u/'
  u/' u/' u/' u/'  u/' u/' u/' u/"	\ and 1 step of u/"
  swap  ;

: m/mod         \ d1 n2 -- rem quot
  ?dup
  if  dup >r 2dup xor >r >r dabs r@ abs um/mod
      swap r> 0< ?negate
      swap r> 0<
      if  negate over
          if  1- r@ rot - swap  endif
      endif
      r> drop
  endif   ;

: /mod          \ n1 n2 -- rem quot
  >r s>d r> m/mod   ;

: mod           \ n1 n2 -- rem
  /mod drop  ;

: /             \ n1 n2 -- quot
  /mod nip ;

: */mod         \ n1 n2 n3 -- r q
  >r  m*  r> m/mod  ;

: */            \ n1 n2 n3 -- q
  */mod nip  ;

: Mu/Mod        \ ud1 ud2 -- u3 ud4
  >r 0 r@ um/mod r> swap >r um/mod r> ;




\ dsqrt sqrt
\

hex

: dsqrt         \ ud -- u               ; returns the square root of a double number
  0000 md!  08000 sr!
  d2*  s1'  s' s' s' s'  s' s' s' s'  s' s' s' s'  s' s' s' s"
  d2/ drop  ;

: sqrt          \ u1 -- u2
  0 dsqrt  ;




\ ?negate abs dnegate ?dnegate dabs
\

: ?Negate       \ n1 n2 -- -n1|n1
  0<
  IF  Negate Exit  THEN  ;

: Abs           \ n1 -- |n1|
  Dup 0<
  if  Negate Exit  endif  ;


: DNegate       \ d1 -- -d1
  swap 0 swap -  swap 0 swap -c  ;

: ?DNegate      \ d n -- -d|d
  0<
  IF  DNegate  THEN  ;

: DAbs          \ d -- +d
  Dup ?DNegate ;




\ 0> 0= 0<> = <> u< u> < > <= >=
\

: 0>            \ n -- t|f
  dup 0= swap 0< or not
\  negate 0<				\ faster... but works for range
					\ -32767..32768 not -32768 to 32767
;

: 0<>           \ n -- t|f
  IF  -1 Exit  THEN                     \ get true (-1) & 2leave
  0  ;


: =             \ w1 w2 -- t|f
  XOR
  IF  0 Exit  THEN                      \
  -1  ;                                 \ get true

: <>            \ w1 w2 -- t|f
  XOR
  IF  -1 Exit  THEN                     \ get true and leave
  0  ;

: U<            \ u1 u2 -- t|f
  - c2/ 0<
  IF  0 Exit  THEN
  -1  ;

: U>            \ u1 u2 -- t|f
  Swap - c2/ 0<
  IF  0 Exit  THEN
  -1  ;

: <		\ n1 n2 -- t/f
  [ $0AAC1 ,Code ]
  if  [ $0AE61 ,Code ]  endif
  [ $0AC41 ,Code ]  ;

: >		\ n1 n2 -- t/f
  [ $0AAC1 ,Code ]
  if  [ $0AF61 ,Code ]  endif
  [ $0A441 ,Code ]  ;

: <=               \ n1 n2 -- t/f
  > not  ;

: >=               \ n1 n2 -- t/f
  < not  ;




\ set-bit reset-bit toggle-bit test-bit
\

: Set-Bit       \ mask addr --
  >r  r@ C@  Or  r> C!  ;

: Reset-Bit     \ mask addr --
  >r  Not  r@ C@ And  r> C!  ;

: Toggle-Bit    \ mask addr --
  >r  r@ C@  Xor  r> C!  ;

: Test-Bit      \ mask addr -- n
  C@ And  ;




\ on off bounds cmove cmove> move
\

: ON            \ a --
  -1 Swap !  ;

: OFF           \ a --
  0 Swap !  ;

: Bounds        \ a len --
  Over + Swap ;

: CMove         \ a1 a2 n --
  ?Dup                                  \ if something
  IF  1-
      FOR  Over C@ Over C!              \ copy a byte
           Swap 1+  Swap 1+             \ step on
      NEXT                              \ till done
  ENDIF                                 \
  2Drop ;                               \ lose addresses

: CMove>        \ a1 a2 n --
  ?Dup                                  \ if something
  IF  >r r@ + swap r@ + swap r>
      1-
      FOR  Swap 1-  Swap 1-             \ step back
           Over C@ Over C!              \ copy a byte
      NEXT                              \ till done
  ENDIF                                 \
  2Drop ;                               \ lose addresses

: move          \ a1 a2 n --
  >r  2dup u<
  if   r> cmove>
  else r> cmove
  endif  ;




\ crash (defer) (to-do)
\

Hex

\ here is-action-of User
\  ]  r> @ User-base @ +  Exit  [

hex

: Crash         \ --
  ." Unitialised deferred word" 0 execute  ;

here is-action-of Defer
 ]  r> @ Execute  Exit  [

decimal


: (To-Do)       \ Exec-Code --
  r> dup 2+ >r  @ 2+ @ dup >r !  $a020 r> 2+ !  ;




\ max min
\

: max           \ n1 n2 -- n1|n2
  2dup <
  if  nip  exit  endif
  drop  ;

: min           \ n1 n2 -- n1|n2
  2dup <
  if  drop  exit  endif
  nip  ;




\ bl space spaces d. u. .hex n. .reg
\

decimal

32 constant bl

: Space         \ --
  Bl Emit  ; 
                                        
: Spaces	\ n --
  0 Max 0
  ?DO  Space  LOOP  ;


decimal

: d.            \ d1 --                 ; displays double number in decimal
  dup 0<
  if  0, 2swap d-
      ascii - emit 
  endif
  0
  begin
    1+ >r               \ count character converted
    10 mu/mod           \ convert the next one
    2dup d0=            \ until nothing left to do
    r> swap             \ get the count back
  until
  -rot 2drop            \ discard the zero quotient
  0
  do
    48 + emit
  loop
;


: u.            \ u --
  0 d.
;


hex

: .hex          \ n -- ; print n in hex
  4 0
  do  dup 0C 0 do 2/ loop               \ top 4 bits to bottom
      0F and  dup 9 >                   \ mask, check 0..9,A..F
      if  7 +  endif                    \  was A..F
      030 + emit                        \ convert to ASCII
      2* 2* 2* 2*                       \ get next 4 bits
  loop                                  \
  drop  ;                               \ drop n


: N.            \ n --
  .hex
  space space space
;

decimal
: .reg          \ --
  spr@ >r 2dup r> r@ rot >r rot >r >r >r 
  md@ sr@ sur@ r> sq@  ivr@ ipr@ r> tc2@ 0 swap mlr@ imr@ dpr@ cr@ tc1@
  0 swap mhr@ ibc@ cpr@ r> tc0@ mxr@ ubr@ upr@ r> 
  cr 16 spaces ." *** RTX Machine Registers ***" cr
  ." T   = " n. ." UPR = " n. ." UBR = " n. ." MXR = " n. ." TC0 = " n. cr  
  ." N   = " n. ." CPR = " n. ." IBC = " n. ." MHR = " n. ." TC1 = " n. cr  
  ." CR  = " n. ." DPR = " n. ." IMR = " n. ." MLR = " n. ." TC2 = " n. cr  
  ." PC  = " n. ." IPR = " n. ." IVR = " n. ." SQ  = " n.               cr  
  13 spaces     ." SPR = " n. ." SUR = " n. ." SR  = " n.               cr  
  13 spaces     13 spaces      13 spaces    ." MD  = " n.               cr
;



((
  Harris interrupt code - replace ours with this
  if you need backward compatibility
))

((
\ >level >vector !interrupt @interrupt disable enable mask unmask masked?
\

hex
0002 constant EI1
0004 constant psu
0008 constant rsu
0010 constant psv
0020 constant rsv
0040 constant EI2
0080 constant timer0
0100 constant timer1
0200 constant timer2
0400 constant EI3
0800 constant EI4
1000 constant EI5
2000 constant swi

hex
: >level        \ mask -- level ; convert interrupt mask to interrupt level
  -1 swap
  begin  swap 1+ swap
         u2/ dup
    while
  repeat
  drop  ;


: >VECTOR       \ level -- addr ; convert interrupt level to address   
  0F SWAP-  2* 2* 2* 2* 2*  		\ generate offset in table
  ibc@ 0FC00 and  +  ;			\ add interrupt base offset

: !INTERRUPT    \ addr mask -- ;
                \ stores ISR address in table referenced by mask value
  >level >VECTOR >r			
  u2/ r@ !  0A020 r> 2+ !  ;

: @interrupt    \ mask -- a             ; return ISR address for given mask value
  >level >vector @
;


HEX
: DISABLE ( interrupts )    \ --
  0010 CR@ OR CR!
;

: ENABLE ( interrupts )     \ --
  CR@ CR!
;

: MASK          \ n --
  IMR@ OR IMR!
;

: UNMASK        \ n --
  -1 XOR
  IMR@ AND IMR!
;

: MASKED?       \ n -- n'
  IMR@ AND 
;
))
  

\ within?
\

hex

: within?       \ n1 n2 n3 -- t/f ; true if n2 <= n1 <= n3
  >r over > swap r> >  or 0=  ;




\ fill erase
\

: fill          \ addr len 8b --
  -rot  ?dup
  if  1-
      for  2dup c! 1+  next
  endif
  2drop  ;

: Erase         \ addr len --
  0 Fill  ;




\ !+ !- c!+ c!- @+ @- c@+ c@-
\

: !+            \ n1 n2 a -- a+n1       ; stores value and increments address
  dup >r                                \ stash copy of address on return stack
  !                                     \ store n2 at address
  r> +                                  \ get address and add to offset
;

: !-            \ n1 n2 a -- a+n1       ; stores value and decrements address
  dup >r                                \ stash copy of address on return stack
  !                                     \ store n2 at address
  r> swap-                              \ get address and subtract the offset
;

: c!+           \ n1 n2 a -- a+n1       ; stores 8-bit value and increments address
  dup >r                                \ stash copy of address on return stack
  c!                                    \ store n2 at address
  r> +                                  \ get address and add to offset
;

: c!-           \ n1 n2 a -- a+n1       ; stores value and increments address
  dup >r                                \ stash copy of address on return stack
  c!                                    \ store n2 at address
  r> swap-                              \ get address and add to offset
;

: @+            \ n1 a -- a+n1 n2       ; returns value at address and address incremented
  dup >r
  @ swap
  r> +
  swap
;

: @-            \ n1 a -- a+n1 n2       ; returns value at address and address incremented
  dup >r
  @ swap
  r> swap-
  swap
;

: c@+           \ n1 a -- a+n1 n2       ; returns value at address and address incremented
  dup >r
  c@ swap
  r> +
  swap
;

: c@-           \ n1 a -- a+n1 n2       ; returns value at address and address incremented
  dup >r
  c@ swap
  r> swap-
  swap
;




\ double number operations

: d0=           \ d1 -- t/f
  or
 if  0 Exit  endif
 -1  ;

: d+           \ d1 d2 -- d1+d2
  >r swap >r +
  r> r> +c
;
  
: d-           \ d1 d2 -- d1-d2
  >r swap >r -
  r> r> -c
;

: d=            \ d1 d2 -- t/f
  rot xor				\ compare high words
  if  2drop  0 exit  endif		\ different, so false
  xor					\ compare low words
  if  0 exit  endif			\ different, so flase
  -1  ;

: d<            \ d1 d2 -- t/f
  d- nip 0<  ;

: d>            \ d1 d2 -- t/f
  d- dup 0<				\ if d1 > d2 then d1-d2>0
  if  2drop  0 exit  endif		\ <0, so false
  or					\ non-zero = +ve, zero == d1=d2
  if  -1  exit  endif			\ return true
  0  ;

: dmax          \ d1 d2 -- d1|d2
  2over 2over d<
  if  2swap  endif
  2drop  ;

: dmin          \ d1 d2 -- d1|d2
  2over 2over d< not
  if  2swap  endif
  2drop  ;

