((

        MONIO.FTH

        Author: J Lee

        Date started:   12/04/90
        Last modified:  14/08/91

        Application I/O harness. Calls I/O code in Monitor.
 
        Copyright (c) 1989, 1990, 1991
 
        MicroProcessor Engineering Ltd.
        133 Hill Lane
        Southampton SO1 5AF
        England
        tel: (+44) 703 631441

))


only forth definitions



\ Example file code for inclusion in application .. J Lee 13/12/89
\ I/O service equates

hex

: i/o-service  ( .. -- .. ; a vectored execution has variable stack effect )
  0210 execute  ;


\
\ Function numbers for Monitor I/O services
\
0 equ key?-service
1 equ key-service
2 equ emit-service
3 equ .-service
4 equ type-service



\ Application I/O Definitions .. sfp 12/04/90
\ These definitions can be used to provide, via the Monitor, the Forth words:
\ EMIT, KEY, KEY?, . and TYPE

: Emit  ( c -- )
  emit-service  i/o-service  ;

: Key  ( -- c )
  key-service  i/o-service  ;

: Key?  ( -- t/f )
  key?-service  i/o-service  ;

: .  ( n -- )
   .-service  i/o-service  ;

: Type  ( addr len -- )
  type-service  i/o-service  ;



\
\ Additional I/O and related words not provided by the Monitor 
\

: Count   ( addr -- addr' # )
  dup 1+ swap c@  ;


: (.")  ( -- ; displays in-line data )
  dpr@				\ preserve data page
  ibc@  			\ preserve flags
  ipr@ dup 0f and		\ get callers page
  dpr!  seldpr		        \ and set as new data page, data page access
  r> count  over over +  1+ 0fffe and >r  rot ipr!	\ restore IPR
  type                          \
  ibc!				\ restore flags
  dpr!  ;			\ restore original data page


: Cr   ( -- )
  0a emit  0d emit  ;

