((

        KERNEL.FTH

        Author: J Lee

        Date started:   01/08/89
        Last modified:  27/08/93


        MPE RTX Umbilical Forth, Application 'high level' code.

))



only forth definitions
decimal



\ TRUE FALSE .. J Lee 13/08/91
\

-1 constant TRUE
 0 constant FALSE




\ (case) (of) .. J Lee 13/08/91
\

: (Case)  ( -- )  ;


: (of)  ( n n' -- TRUE | n FALSE )
  over = dup            \ Equal?
  If  nip  Endif  ;     \ y:  TRUE for ?BRANCH
                        \ n:  'n' FALSE for ?BRANCH



\ (+Loop) (Loop) (Leave) (?Leave) (Do) (?Do) I J .. J Lee 13/08/91
\

: (+Loop)  ( n -- t/f )
  ipr@ r>                             \ preserve Page,Address
  rot  r> dup md!  r> dup sr!         \ get loop parameters
  swap -  over over  + 
  xor 0<			      \ end of loop? *** see note in glossary
  If                                  \ y:  discard, return to Page,Address
    drop  >r ipr!  TRUE  EXIT         \     leaving TRUE for ?BRANCH
  Endif                               \  
  sr@ + >r  md@ >r  >r ipr!           \ n:  return loop parameters
  FALSE  ;                            \     leaving FALSE for ?BRANCH


: (Loop)  ( -- t/f )
  ipr@ r>                             \ preserve Page,Address
  1  r> dup md!  r> dup sr!           \ get loop parameters
  swap -  over over  + 
  over xor and 0<                     \ end of loop?  
  If                                  \ y:  discard, return to Page,Address  
    drop  >r ipr!  TRUE  EXIT         \     leaving TRUE for ?BRANCH  
  Endif                               \  
  sr@ + >r  md@ >r  >r ipr!           \ n:  return loop parameters
  FALSE  ;                            \     leaving FALSE for ?BRANCH
  

: (Leave)  ( -- )
  ipr@ r>                             \ preserve page,address
  r> drop  r> drop                    \ discard loop values
  >r  ipr!  ;                         \ restore page,address
 

: (?Leave)  ( t|f -- t/f )
  If                                  \
    ipr@ r>                           \ preserve page,address
    r> drop  r> drop                  \ discard loop values
    >r ipr!                           \ restore page,address
    FALSE  EXIT                       \  
  Endif                               \
  TRUE  ;                             \


: (Do)  ( n1 n2 -- True )
  ipr@ sr!  R> MD!                    \ preserve Return page,address
  >r >r                               \ place loop values on return stack
  md@ >r  sr@ ipr!  TRUE  ;           \ restore Return page,address


: (?Do)  ( n1 n2 -- t/f )
  Over Over =                         \ loop values the same?
  If                                  \ y:
    drop drop  FALSE                  \   don't do loop
    EXIT                              \  
  Endif                               \ n:
  ipr@ sr!  r> md!                    \   preserve Return page,address
  >r >r                               \   place loop values on return stack
  md@ >r  sr@ ipr!  TRUE  ;           \   restore Return page,address


: I  ( -- n )
  ipr@ r>               \ preserve Page,Address
  r> r@ md! >r          \ get 'I'
  >r ipr!               \ restore Page,Address
  md@  ;                \ return 'I'


: J  ( -- n )
  ipr@ r>               \ preserve page,Address
  r> r>  r>             \
  r@ md!                \ get 'J'
  >r  >r >r             \
  >r ipr!               \ restore Page,Address
  md@  ;                \ return 'J'


