((
	CHUNKS.FTH

	J Lee :- 22/6/90

	Copyright (C) 1983-1991

	MicroProcessor Engineering Ltd
	133/133a Hill Lane
	Southampton
	SO1 5AF

	tel:		(0703) 631441
	inter:	+44 703 631441

	This file contains code to create and add chunks to a page's
	linked list of chunks

))



only forth also c-c definitions



\ constants .. J Lee -- 22/06/90
\


hex

\ Set size of chunks
01000 constant /Chunk	\ bytes per chunk
/Chunk
010					\ bytes per paragraph
/
constant Paras/Chunk	\ size of chunk


\ Set boundaries of symbols within chunk
}Page-Management 1+ constant {Symbol-Space
/Chunk {Symbol-Space - 1- constant }Symbol-Space




\ Chunk-Space? .. J Lee -- 26/06/90
\

decimal

256 constant Chunk-Gap

: Chunk-Space?	( -- t/f ; return true if enough space in chunk )
	dp(s) @(c)
	}Symbol-Space Chunk-Gap -
	u<  ;




\ Claim-Chunk Release-Chunk Erase-Chunk .. J Lee -- 22/06/90
\


: Claim-Chunk	( -- segment )
	Paras/Chunk alloc-mem
	abort" Can't claim memory for chunk"  ;


: Release-Chunk	( segment -- )
	free-mem
	abort" Can't release memory for chunk"  ;


: Erase-Chunk	( segment -- )
	0			\ offset
	/Chunk		\ len
	0
	fill(s)l  ;



\ >Chunk-Link <Chunk-Link .. J Lee -- 25/06/90
\


\ Offset into Header (See HEADER.FTH)
: <Chunk-Link	( -- offset )
	[ Chunk-Link ] literal  ;


\ Offset into Header (See HEADER.FTH)
: >Chunk-Link	( -- offset )
	[ <Chunk-Link cell + ] literal  ;



\ Init-Chunk Get-Chunk Link-Chunk .. J Lee -- 25/06/90
\


: Get-Chunk-Segment	( -- segment )
	claim-chunk  dup erase-chunk  ;


: Set-Chunk	( segment -- )
	{Symbol-Space swap Dp(s) !(p)l  ;	\ set pointer to start of symbol space


: Get-Chunk	( -- segment )
	get-chunk-segment  dup set-chunk  ;	\ used in chunk linking


: Init-Chunk	( -- segment ; used when building first chunk in a page )
	get-chunk-segment
	dup voc-seg!			\ set segment as current segment
	dup set-chunk  ;


: Link-Chunk	( new-chunk -- )
	Latest-Chunk @(v)	    	\ backward link
	over <Chunk-Link !(s)l

	dup
	Latest-Chunk @(v) 		\ forward link
	>Chunk-Link !(s)l

	Latest-Chunk !(v)  ; 	\ update latest chunk
 




\ Test code .. J Lee -- 24/06/90
\


\ : .Symbols	( -- )
\	voc-seg@ >es
\	{symbol-space
\	}symbol-space over - 1-
\	edump  ;


