((

	S-PRIM1.FTH

	J Lee :- 25/1/91

        6/9/91  JL:
                Split SYM-PRIM.FTH into S-PRIM1.FTH, symbol low-level
                primitives.

	Copyright (C) 1983-1991

	MicroProcessor Engineering Ltd
	133/133a Hill Lane
	Southampton
	SO1 5AF

	tele:	(0703) 631441
	inter:	+44 703 631441


	This code performs primitive operations.

	All of the '(s)' memory operators use an implicit segment in their
	operation. This segment is know as the 'CURRENT-CHUNK' and can be found
	by inspecting the 'LATEST-CHUNK' of the 'DEFINITIONS(S)' vocabulary.

))




only forth also c-c definitions
decimal




(( **********************************************************
   ***                                                    ***
   ***  These values are faked for V-FIND(S).             ***
   ***  They MUST match the actual values in PAGEVAR.FTH  ***
   ***                                                    ***
   **********************************************************
))

16 constant #THREADS(S)
 0 constant CHUNK-LINK
 6 constant CHUNK-THREADS




\ Erase(s)l Cmove(s)l Cmove>(s)l .. J Lee -- 02/07/90
\


Code Cmove(s)l	( seg source destination len -- )
\	bx pop			        \ get length
	cx, bx mov		        \ set length
	ax, si mov   dx, di mov	        \ save Forth registers
	di pop   si pop   es pop        \ get parameters
	l$2 jcxz

l$1:
	rep es: movsb

l$2:
	si, ax mov   di, dx mov		\ restore Forth registers
	bx pop
	next,
End-Code


Code Cmove>(s)l	( segment source destination len -- )
\	bx pop			        \ get length
	cx, bx mov		        \ set length
	ax, si mov   dx, di mov	        \ save Forth registers
	di pop   si pop   es pop	\ get parameters
	l$2 jcxz
	cx dec   di, cx add   si, cx add        \ High > Low move
	cx inc   std

l$1:
	rep es: movsb   cld

l$2:
	si, ax mov   di, dx mov
	bx pop
	next,
End-Code




\ V-Find(s) .. J Lee -- 26/6/90
\

hex



\ temporary variable
variable Thread-Hash	\ Thread-Hash remains same, since all chunks
			\ have the same header format and same #Threads(s).



Code V-Find(s)                        \ $addr voc-chunk --
      				      \ seg cfa 1 | seg cfa -1 | $addr 0
\  bx pop                              
  es, bx mov			      \ get voc-chunk into ES	
  dx pop       		              \ get parameters
  ax pop  ds, ax mov                  \ set data segment of string
  si push  di push                    \ save Forth registers
  bx, bx or   l$5 jz		      \ leave if chunk segment == 0
  si, dx mov  	                      \ initialise pointers
  bh, bh sub                          \ accumulate into BX
  bl, 0 [si] mov  bl, 1 [si] add      \ add count & first byte
  bh, # 0 adc                         \ into BX
  cx, # #Threads(s) 1- mov            \ get #threads
  bx, cx and   bx, # 1 shl     	      \ mask, form thread offset
  di, # Chunk-Threads mov             \ point to first thread
  bx, di add                          \ point to correct thread
  cs: Thread-Hash bx mov              \ preserve table thread
 
l$6:
  es: di, 0 [bx] mov                  \ get top nfa,
  di, di or   l$3 jz		      \ leave if end of thread chain
  ch, ch sub                          \ zero high part of count
                                      \
l$1:
  si, dx mov  bx, di mov              \ text, nfa saved
  lodsw  cl, al mov                   \ get text,
  es: ax, 0 [di] xor                  \ and mask
  ax, # 07f3f and  l$2 jnz            \ remove bits, fail nz
  di inc  di inc                      \ step over count & first
  cx dec  l$4 jz                      \ success of 1-char name
  repz cmpsb  l$4 jz                  \ compare rest of name
                                      \
l$2:
  es: di, -2 [bx] mov  di, di or      \ pick up thread link
  l$1 jnz
                                      \
l$3:
  bx, # Chunk-Link mov		      \ set offset to <Chunk-Link (=Chunk-Link)
  es: bx, 0 [bx] mov		      \ get previous chunk's segment
  bx, bx or   l$5 jz		      \ leave if end of backward chunk chain
  es, bx mov			      \ set new chunk segment to search
  cs: bx, Thread-Hash mov	      \ reload thread table hash code address
  l$6 jmp			      \ go back and search new chunk

l$4:
  di inc  di inc  dx, di mov          \ point past status word
  es: 0 [bx], # 040 byte test         \ test for immediate word
  bx, # 1 mov                         \ assume normal word
  nz, If,  bx neg Endif,              \ if immediate then -1
  di pop   si pop		      \ restore Forth registers
  es push   dx push		      \ -- Seg, Symbol, Flag
  ax, cs mov  ds, ax mov              \ reset DS
\  bx push
  next,

l$5:
  di pop  si pop                      \ restore Forth registers
  dx push			      \ -- $addr flag
  ax, cs mov  ds, ax mov              \ reset DS
\  bx push
  next,                               \

End-Code




\ ?Symbol-Space .. J Lee -- 01/08/90
\


hex

\ Only here because it is a code definition	(form over function)
\
Code ?Symbol-Space	( -- memsize ; in paragraphs )
	bx push
	bx, # -1 mov
	ah, # 048 mov
	021 int
	next,
End-Code
