((
MPE  Modular Forth software floating point package sfp 07/04/90

Revision 3.0 August 86          Conversion to Modular Forth
Revision 3.1 January 1987       Speed and code improvements
Revision 3.2 February 1988      Trig bug fixes in SINFN
Revision 3.3 November 1989      Conversion to PF3.x
Revision 3.4 April 1990         Conversion to MF3.x

Copyright (C) 1983-1990
MicroProcessor Engineering Ltd.
133 Hill Lane
Southampton SO1 5AF
England
tel: 0703 631441
))

\ 02/10/91

decimal
cr  .( compiling floating point pack )

\ Load screen for floating point package........... \  20/11/89

(     Welcome to MPE's floating point package                 )
(       For full details see your manual !                    )
(          2 -> 22 floating point primitives                  )
(         23 -> 24 fconstants & fvariables                    )
(         25 -> 29 floating point output                      )
(         30 -> 34 floating point input                       )
(         35 -> 51 floating point trig, logs, powers          )

DECIMAL
only forth also c-c definitions

\ VOCABULARY F-PACK
\ ALSO F-PACK DEFINITIONS

\ fvariable fconstant .............................sfp 20/11/89


( f -- )
: F,            HERE  6 ALLOT  F!  ;

: Fvariable ( -- addr)
  Create				\
    0 , 0 , 0 ,				\
  Does>					\
;

: Fconstant ( -- fn)
  Create				\
    , , ,				\
  Does>					\
    f@					\
;

: Farray ( -- fn)
  Create				\
    0 Do , , , Loop			\
  Does>					\
    6 * swap + f@			\
;


\ variables .......................................sfp 07/04/90

( -- addr )
VARIABLE EXP
VARIABLE LO1    VARIABLE LO2
VARIABLE HI1    VARIABLE HI2
VARIABLE *SN
VARIABLE /SN
VARIABLE +SN1
VARIABLE +SN2
VARIABLE EXP1


FVARIABLE DUM


\ d>>n norm-r norm-l ..........................................

: d>>n                                  \ d1 n -- d1>>n
  0 ?do  d>>1  loop  ;

: norm-r                                \ mant -- mant'
  1 exp +!  d>>1  ;

: norm-l                                \ mant -- mant'
  -1 exp +!  d<<1  ;

\ dnorm - normalise d-word ........................sfp 07/04/90

: DNORM         \ dn exp -- fn
        EXP !  2DUP OR                  ( check zero )
          IF  DUP 0< >r  DABS           ( save sign )
              BEGIN  norm-l dup         ( shift until -ve )
              0< UNTIL
              norm-r
              r> ?dnegate
              EXP @                     ( recover sign & exp )
          ELSE  0
          ENDIF  ;

\ d>f s>d s>f .................................................

: D>F           \ d -- fn
  31 DNORM  ;

: S>F           \ s -- fn
  S>D  D>F  ;

\ fnegate ?fnegate fabs fsign .................................

( fn -- -fn )
: fnegate       >R DNEGATE R>  ;

( fn n -- fn/-fn )
: ?fnegate      0< if fnegate endif  ;

( fn -- |fn| )
: FABS          >R DABS R>  ;

( fn -- |fn| flag ; true if negative )
: FSIGN         over 0< >r  fabs  r>  ;

\ double integer multiply .........................sfp 07/04/90

( d1 d2 -- q1 )
: D*    HI2 ! LO2 !  HI1 ! LO1 !
        LO1 @ LO2 @               UM*
         0    LO2 @ HI1 @         UM* D+
              LO1 @ HI2 @         UM* D+
               0    HI1 @ HI2 @   UM* D+  ;
( d -- )
: D!    DUM 2!  ;
( -- d )
: D@    DUM 2@  ;

\ f* ..............................................sfp 21/11/89
( f1 f2 -- f3 )
: F*    FSIGN *SN !  1+ EXP !  D!       \ save sign & exp 1
        FSIGN *SN +!  EXP +!  D@        \ save sign & exp 2
        D* 2DUP OR                      \ 64 bit multply = 0 ?
          IF  BEGIN
                DUP 16384 AND 0=
                WHILE  -1 EXP +!  q<<1
              REPEAT
              D!  NIP  D@ ROT 0< NEGATE 0 D+  ( round up )
              DUP 0<
                IF  norm-r  ENDIF
              *SN @ -1 =
                IF  DNEGATE  ENDIF       ( recover sign )
              EXP @                     ( recover exponent )
          ELSE  FDROP DROP  0 0 0  ENDIF  ; public

\ f/ .............................................. \  20/11/89
( f1 f2 -- f3 )
: F/  FSIGN /SN !  NEGATE EXP !         \ Negate divisor & save
      2DUP OR 0= ABORT" Divide by 0 error"   \ Check mantissa
      DNEGATE D!  FSIGN /SN +!  EXP +!             \ make +ve
      >R >R 0 0 R> R>                   \ 0 quotient to stack
      31 0                              \ shift 31 times
      do  D@ D+ DUP 0<
          IF    >R >R  d<<1  R> R> D@ d-
          ELSE  >R >R  1 <-S DROP  R> R>  ENDIF
          d<<1
      loop
      2DROP  EXP @ 1+ DNORM  /SN @ -1 = IF  Fnegate  ENDIF  ; public

\ f+ ..............................................sfp 23/02/88
: F+  ( f1 f2 -- f3 )  2 PICK 2 PICK OR         ( F1 non zero )
        IF  FSIGN +SN1 !  EXP !  >r >r  2 PICK 2 PICK OR
          IF  FSIGN +SN2 !  EXP1 !  EXP @  EXP1 @ - DUP
              IF  DUP 0> IF  d>>n
                         ELSE  r> r>  ROT ABS d>>n  >r >r
                         ENDIF
              ELSE  DROP  ENDIF
              EXP @ EXP1 @ MAX EXP !  r> r>  +sn1 @ +sn2 @ -
              IF  d-
              ELSE  D+  1 EXP +!  0 S-> 0 D+  DUP 0<
                    IF  norm-r  ENDIF
              ENDIF
              +SN2 @ ?dnegate  EXP @ DNORM
          ELSE  FDROP  r> r>  +SN1 @ ?dnegate  EXP @  ENDIF
        ELSE  FDROP  ENDIF   ; public
\ f- ..........................................................

( f1 f2 -- f3 )
: F-    Fnegate  F+  ; public

( fn -- d )
: DINT  FSIGN >r  DUP 0<
          IF  FDROP  0 0  r> drop
          ELSE  31 SWAP - DUP 0>
                  IF  d>>n
                  ELSE
                    abort" Number too large in DINT"
                  ENDIF
                r> ?dnegate
          ENDIF  ;

\ fint sint ...................................................

( f1 -- f2 )
: FINT  DUP 32 <
        IF  DINT 31 DNORM  ENDIF  ;

( fn -- n )
: SINT  DINT ?DUP
        IF  1+ ABORT" Number too large in SINT"  ENDIF  ;

\ f-compares ........................................

( f1 -- flag )
: F<0   DROP NIP 0<  ;
: F>0   DROP NIP 0>  ;
: F=0   DROP OR 0=  ;
: F<>0  DROP OR 0<>  ;

( f1 f2 -- flag )
: F=    F- F=0  ;
: F<    F- F<0  ;
: F>    F- F>0  ;

\ fmax fmin fliteral f/mod fmod ...............................
: FMAX                  \ f1 f2 -- f3
  FOVER FOVER F<  IF  FSWAP FDROP   ELSE  FDROP  ENDIF  ;
: FMIN                  \ f1 f2 -- f3
  FOVER FOVER F>  IF  FSWAP FDROP   ELSE  FDROP  ENDIF  ;

: FLITERAL              \ fn --
  3 #LITERAL  ;  immediate

: FSEPARATE             \ f1 f2 -- rem(f1/f2) quot(f1/f2)
  FOVER FOVER F/  FROT FROT FABS FSWAP FSIGN >R FSWAP
  8 PICK 8 PICK 8 PICK FABS FINT F* F-
  r> ?fnegate  FSWAP  ;

: FFRAC                 \ f1 f2 -- rem(f1/f2)
  FSEPARATE FDROP  ;
\ fconstants ......................................sfp 21/11/89


( -- fn )
 -8192 25735 18 FCONSTANT %SINMAX
 15402 27213  2 FCONSTANT %1/LG2
 19775 19728 -1 FCONSTANT %LG2
 7572  23637  1 FCONSTANT %1/LN2
  3068 22713  0 FCONSTANT %LN2
 -4780 25735  2 FCONSTANT PI
 -4781 25735  1 FCONSTANT PI/2
 -4780 25735  0 FCONSTANT PI/4
-15946 20860 -1 FCONSTANT 1/PI
-15946 20860  0 FCONSTANT 2/PI

\ fconstants ......................................sfp 21/11/89


( -- fn )
 26214 26214 -3 FCONSTANT %.1
     0     0  0 FCONSTANT %0
     0 16384  1 FCONSTANT %1
     0 20480  4 FCONSTANT %10
     0 23040  8 FCONSTANT %180

\ fconstants ......................................sfp 07/04/90


( -- fn )
   0  25600   8 FCONSTANT %ALNMAX
 31129 23170  0 FCONSTANT %SQR.5
 23781 19338  0 FCONSTANT %S1
-11264 27348 -1 FCONSTANT %S2
 31872 19073 34 FCONSTANT %10^10
     0 25344  7 FCONSTANT %ALGMAX
 32611 28147 -33 FCONSTANT %10^-10
  3066 22713  0 FCONSTANT %D8
 -5035 28461 -1 FCONSTANT %D9

\ fvariables & variables ..........................sfp 21/11/89.


( -- addr )
VARIABLE %EXP
VARIABLE %SGN
VARIABLE %N

FVARIABLE %STK1

\ round .......................................................
( rounds least significant eight bits to 0 if higher 8 bits )
( are all 0s or all 1s                                      )
( f1 -- f2 )
: ROUND   FSIGN >R >R  SWAP DUP 224 AND 0=
            IF  -256 AND  ENDIF
          DUP 224 AND  224 - 0=
            IF  -256 AND 256 + DUP 0=
              IF  SWAP 1+  ELSE  SWAP  ENDIF
            ELSE  SWAP  ENDIF
          R> OVER 0<  IF  SWAP 0 2 UM/MOD NIP SWAP 1+
                      ENDIF
          R> ?fnegate  ;

\ finvert ?finvert                                 sfp 21/11/89

: finvert                               \ f1 -- 1/f1
  %1 fswap f/  ;                        \ invert input

: ?finvert              \ f1 n -- f1 | 1/f1 ; invert if n <> 0
  if  finvert  endif  ;

\ places n#                                        sfp 07/04/90

variable places         \ holds max number digits after d.p.
  8 places !            \ default to 8 digits

: n#                    \ d1 n -- d2 ; converts n digits
  0 ?do  #  loop  ;

\ ?10pwr oprep ................................................

\ exp(2) -- exp(2) exp(10)
: ?10pwr        dup 0< >r  dup abs 301 1000 */mod nip
                r> if  negate 1- endif ;

( fn -- d )
: OPREP FSIGN %SGN !
        ?10PWR  DUP %EXP !  8 SWAP -  ?DUP
          IF    DUP 0<
                  IF  ABS 0 DO  %.1 F* LOOP
                  ELSE  0 DO  %10 F* LOOP  ENDIF
          ENDIF
        ROUND  fdup 4096 24414 27 f<
        if  %10 f*  -1 %exp +!  endif
        DINT  ;

\ print the fp no. on the stack ...................sfp 07/04/90
( -- )
: .EXP    ( if -10<e<10 then print a "0" in front of exponent  )
                ASCII e EMIT   %EXP @  DUP 0<
                  IF  ASCII -  ELSE  ASCII +  ENDIF  EMIT
                ABS  0 <# # #S #> TYPE  ;

( dn exp -- )
: E.            OPREP
                <#  8 n#   ASCII . HOLD   #
                    %SGN @
                    IF  ASCII -  ELSE  BL  ENDIF  HOLD
                #>
                8 places @ min  0 max +  8 -  type
                .EXP   ;

\ print the fp no. on the stack ...............................
( fn -- )
: F.  DUP -10 27 WITHIN?
        IF  OPREP
            <#  8 %EXP @ -  0 max  dup >r  ?dup
            IF  n#  ASCII . HOLD  ENDIF
            #S  %SGN @ IF  ASCII -  ELSE  BL  ENDIF  HOLD
            #>
            r> places @ - 0 max -
            DUP 0  DO  2DUP + 1- C@  ASCII 0 <> ?leave
                       1-
                   LOOP
            2DUP + 1- C@  ASCII . = IF  1-  ENDIF
            TYPE
        ELSE  E.  ENDIF  ; public

\ fcheck ..........................................sfp 07/04/90

: FCHECK        \ -- am lm ae le flag ; true if f.p. number
  pad count 2dup ascii E scan dup >r    \ ap lp ae le --
  tuck >r >r - r> r>                    \ am lm ae le --
  dup if 1 /string endif                \ am lm ae' le' --
  pad count ascii . scan  dup >r
  if  ascii , swap c!  else  drop  endif
  r> r> or  ;

\ mnum enum........................................... July 86

: MNUM          ( -- d 2 | 0 ; uses fchecked str in pad   )
    (INTEGER?) DUP
    1 =  IF  DROP S>D 2
         ENDIF  ;

: ENUM          ( -- n 1 | 0 ; str as above  )
    DUP  IF  (INTEGER?)  DUP 2 =
             IF  2DROP DROP 0  ENDIF
         ELSE  2DROP  0 1
         ENDIF  ;

\ fixexp ..........................................sfp 07/04/90

: FIXEXP     ( mant exp -- mant' exp' )
  >R D>F R>  10 /MOD  SWAP >R  ?DUP
  IF  DUP 0<  IF  ABS 0 DO %10^-10 F*  LOOP
              ELSE 0 DO %10^10 F*  LOOP
              ENDIF
  ENDIF
  R> ?DUP  IF  DUP 0<  IF  ABS 0 DO  %.1 F*  LOOP
                       ELSE  0 DO  %10 F*  LOOP
                       ENDIF
           ENDIF  ;

\ fnumber? ........................................... July 86
: FNUMBER?      ( addr -- 0/.../mant exp 3 )
  PAD OVER C@ 1+ CMOVE			\ copy string to pad
  PAD COUNT UPPER  FCHECK		\ is it floating point?
  IF  ENUM				\ yes, find exponent
    IF  -ROT MNUM			\ ok, find mantissa
      IF  ROT DPL @  DUP 0>		\ ok, allow for DPL
        IF -  ELSE  DROP  ENDIF		\
        FIXEXP  3			\ fix exponent, done
      ELSE				\
        DROP 0				\
      ENDIF				\
    ELSE				\
       2DROP 0 				\
    ENDIF				\
    DUP #L !				\
  else					\
    2drop 2drop	0			\
  ENDIF					\
;

\ 02/10/91
decimal
: ($Fnumber?)		\ seg off base -- 0 | n 1 | n1 n2 2 | n1 n2 n3 3 
  base @ >r				\ stash base
  base !				\
  cs> here 2over c@l 1+ cmovel		\ get copy of string
  here integer?				\ is it an integer?
  ?dup 0=				\
  if  10 base ! here fnumber?  endif	\ try and convert
  r> base !				\ restore base
; public

\ floats integers .................................sfp 23/02/88

\ also forth definitions

: integers                              \ -- ; no f.p. input
  assign integer? to-do number?  ;      \ switch in integer?
  public

\ previous definitions

\ (f#) f#-in f# ....................................... July 86

: (F#)     ( addr -- fn 3 )
  FNUMBER? CASE
              0  OF  0  ENDOF
              1  OF  S>F 3  ENDOF
              2  OF  D>F 3  ENDOF
           END-CASE  ;

: F#IN     ( -- fn t/f )
  QUERY BL WORD (F#)  ;

: F#       ( -- f or compiles it [ state smart ] )
  BL WORD (F#)  
  0= 0 ?ERROR  STATE @
  IF  [compile] FLITERAL  ENDIF  ;  IMMEDIATE

\ FSQR by Heron's Formula .........................sfp 07/04/90

( f1 -- f2 )
: FSQR  2 PICK 2 PICK OR                 ( check 0 )
          IF  OVER 0<                             ( check -ve )
              ABORT" Square root of negative no.!"
              >R 0                                ( .5 <=f<=1 )
              FDUP %S1 F*  %S2 F+               ( HART est Y0 )
              FOVER FOVER F/ F+
              FSWAP FOVER F/ FSWAP 2-  F+
              R@ 1 AND  DUP R> + >R
              IF  %SQR.5 F*  ENDIF
              R> 2/ +
          ENDIF  ; Public

: fsqrt fsqr  ;
\ [sin] ...........................................sfp 21/11/89


\ n -- fn
F# -1.6666666E-1                F# 8.3333315E-3
F# -1.98409E-4                  F# 2.7526E-6
F# -2.39E-8
5 FARRAY SINARRAY

\ f1 -- f2
: (SIN)         FDUP FDUP F* FDUP 0 SINARRAY F*
                4 1  DO
                  I SINARRAY F+ FOVER F*
                LOOP
                4 SINARRAY F+ F* %1 F+ F*  ;

\ sine functions ..................................sfp 23/02/88


( -- )
: ?TR-ERR       ABORT" Overflow in trig. function"  ;

( f1 -- f2 )
: SINFN         FDUP 1/PI F*            ( ang ang/pi --- )
                FINT FDUP SINT %N !     ( ang int[ang/pi] --- )
                PI F* F-                ( ang-pi*int[ang/pi] - )
                FDUP PI/2 F>
                  IF  PI fswap F-  ENDIF
                (SIN)
                %N @ 1 AND
                  IF  FNEGATE  ENDIF
                ;

\ deg>rad rad>deg                                  sfp 23/02/88


\ n1 -- n2
: DEG>RAD       %180 F/ PI F*  ;
\ n1 -- n2
: RAD>DEG       %180 F* PI F/  ;

\ sine cosine .....................................sfp 23/02/88


: (FSIN)        \ f1 -- f2
        FSIGN >r
        FDUP %SINMAX F> ?TR-ERR
        SINFN
        r> ?fnegate   ;

( f1 -- f2 )
: FSIN  DEG>RAD (FSIN)  ;

( f1 f2 )
: FCOS  DEG>RAD  PI/2 F+  (FSIN)  ;

\ (tan) ...........................................sfp 21/11/89


\ n -- fn
F# 3.3333140E-1                 F# 1.3339240E-1
F# 5.3374060E-2                 F# 2.4565089E-2
F# 2.9005250E-3                 F# 9.5168091E-3
6 FARRAY TANARRAY

\ f1 -- f2
: (TAN)         FDUP FDUP F* FDUP 0 TANARRAY F*
                5 1  DO
                  I TANARRAY F+ FOVER F*
                LOOP 5 TANARRAY F+ F* %1 F+ F*  ;

\ tan .........................................................


\ f1 -- f2
: FTAN          DEG>RAD  FSIGN >r
                FDUP %SINMAX F> ?TR-ERR
                FDUP 2/PI F* FINT FSWAP FOVER PI/2 F* F-
                FDUP PI/4 F>
                  IF  PI/2 F- (TAN) FSWAP %1 F+
                  ELSE  (TAN) FSWAP
                  ENDIF
                SINT 1 AND
                  IF  finvert  Fnegate  ENDIF
                r> ?fnegate  ;

\ arcfn........................................................

\ n -- fn
F# 1.5707963E0                  F# -2.1459880E-1
F# 8.8978987E-2                 F# -5.0174305E-2
F# 3.0891881E-2                 F# -1.7088126E-2
F# 6.6700901E-3                 F# -1.2624911E-3
8 FARRAY ASINARRAY
( f1 -- f2 )
: ARCFN         FDUP 0 ASINARRAY F*
                7 1  DO
                  I ASINARRAY F+ FOVER F*
                LOOP
                7 ASINARRAY F+
                FSWAP %1 FSWAP F- FSQR F*  ;

\ atfn .......................................................

\ n -- fn
F# -3.3333145E-1                F# 1.9993551E-1
F# -1.4208899E-1                F# 1.0656264E-1
F# -7.5289640E-2                F# 4.2909614E-2
F# -1.6165737E-2                F# 2.8662257E-3
8 FARRAY ATANARRAY
( f1 -- f2 )
: ATFN          FDUP FDUP F* FDUP 0 ATANARRAY F*
                7 1  DO
                  I ATANARRAY F+ FOVER F*
                LOOP
                7 ATANARRAY F+ F* %1 F+ F*  ;

\ fasin facos fatan ...........................................

\ f1 -- f2
: FASIN FSIGN >r  ARCFN PI/2 FSWAP F-
        r> ?fnegate  RAD>DEG  ;

\ f1 -- f2
: FACOS FSIGN >r  ARCFN
        r> IF  PI FSWAP F-  ENDIF
        RAD>DEG  ;

\ f1 -- f2
: FATAN FSIGN >r  FDUP %1 F>
          IF  finvert  ATFN PI/2 FSWAP F-
          ELSE  ATFN  ENDIF
        r> ?fnegate  RAD>DEG  ;

\ ln log ......................................................

F# 9.9999642E-1                 F# -4.9987412E-1
F# 3.3179903E-1                 F# -2.4073381E-1
F# 1.6765407E-1                 F# -9.5329390E-2
F# 3.6088494E-2                 F# -6.4535442E-3
8 FARRAY LOGARRAY       \ n -- fn
\ f1 -- f2
: FLN   fdup f>0 not
          ABORT" Invalid argument to LOG function"
        1 SWAP 1- %N !  %1 F-
        FDUP 0 LOGARRAY F*
        7 1  DO
          I LOGARRAY F+ FOVER F*
        LOOP
        7 LOGARRAY F+ F* %N @ S>F  %D8 F* F+  ;
: FLOG  FLN %D9 F*  ;

\ (10^x) ......................................................

\ n -- fn
F# 1.1512928E0                  F# 6.6273088E-1
F# 2.5439357E-1                 F# 7.2951737E-2
F# 1.7421120E-2                 F# 2.5549180E-3
F# 9.3264267E-4
7 FARRAY 10ARRAY
\ f1 -- f2
: (10^X)        FDUP 0 10ARRAY F*
                6 1  DO
                  I 10ARRAY F+ FOVER F*
                LOOP
                6 10ARRAY F+ F*
                %1 F+  FDUP F*  ;

\ (e^x) .......................................................

\ n -- fn
F# -1.0000000E0                 F# 4.9999992E-1
F# -1.6666530E-1                F# 4.1657348E-2
F# -8.3013598E-3                F# 1.3298820E-3
F# -1.4131610E-4
7 FARRAY E-ARRAY
\ f1 -- f2
: (E^X)         FDUP 0 E-ARRAY F*
                6 1  DO
                  I E-ARRAY F+ FOVER F*
                LOOP
                6 E-ARRAY F+ F*
                %1 F+  finvert  ;

\ fe^x f10^x ..................................................


\ f1 -- f2
: FE^X  FSIGN >r
        FDUP %ALNMAX F> ABORT" Overflow in FE^X"
        FDUP  %1/LN2 F*  FDUP SINT %N !  FINT %LN2 F* F-
        (E^X)  %N @ +
        r> ?finvert  ;

\ f1 -- f2
: F10^X FSIGN >r
        FDUP %ALGMAX F> ABORT" Overflow in F10^X"
        FDUP %1/LG2 F*  FDUP SINT %N !  FINT %LG2 F* F-
        (10^X)  %N @ +
        r> ?finvert  ;

\ fx^n ........................................................


( x-real n-integer --- fn )
: FX^N  ?dup
          IF  DUP 0< >r  ABS >R  %1 FSWAP  R>
              BEGIN  DUP 0>
                WHILE  DUP 2 / DUP 2* ROT -
                         IF  >R FSWAP FOVER F* FSWAP R>  ENDIF
                       >R FDUP F* R>
              REPEAT
              DROP FDROP  r> ?finvert
          ELSE  FDROP  %1  ENDIF  ;

\ fx^y ........................................................

( x-real y-real --- fn )
: FX^Y  fdup f<>0
          IF  FDUP FDUP FINT F- %STK1 F!
              SINT >R FDUP R>  FX^N FSWAP
              %STK1 F@ fdup f<>0
              IF  fover f<0 ABORT" Result of FX^Y is complex"
                  FSWAP  fsign >r
                  FLOG F* F10^X
                  r> ?finvert
                  F*
              ELSE  FDROP FDROP
              ENDIF
          ELSE  FDROP FDROP  %1  ENDIF  ;

\ floating point goodbye!!.........................sfp 07/04/90

cr .( floating point pack generated )
only forth definitions

((

That's all, folks.
Our thanks go to all those who have contributed to this package
whose efforts have not been in vain. Any bugs are still our
fault, and if you find any please notify us.
))
