((

	INITIAL.FTH

	J Lee :- 22/6/90

        Copyright (C) 1983-91

	MicroProcessor Engineering Ltd
	133/133a Hill Lane
	Southampton
	SO1 5AF

	tele:	(0703) 631441
	inter:	+44 703 631441


	This code initialises the cross compiler.

))



only forth also c-c definitions




\ Unhook-Forth .. Jon 30/01/89
\


decimal

((
\ ***************************
	reset-heads	headerless
\ ***************************
))


\ Init-Vars .. Jon 30/01/89
\


: Init-vars	( -- )
	?log on(g)  0 dp(t) !(p)			\ generate log table
	31 width(t) !(g)				\ target header size
	-1 the-equate HEADS? !(s)l		\ lay target heads?
	do-build on(g)					\ build host analogues
	code-page-open off(g)			\ no code page open
	data-search off(g)				\ data pages not normally searched
	log/line #logged !(g)			\ symbol table format
	latest-chunk @(v) last'(s)@ 'latest(s) 2!(v)  ;	\ set up symbol table




\ @Voc-Link(s)s !Voc-Link(s)s .. J Lee -- 6/7/90
\


: @Voc-Link(s)s	(( -- <voc-link(s) >voc-link(s) curr->voc-link(s) ))
	<Voc-Link(s) 2@(p)
	>Voc-Link(s) 2@(p)
	Curr->Voc-Link(s) 2@(p)  ;


: !Voc-Link(s)s	(( <voc-link(s) >voc-link(s) curr->voc-link(s) -- ))
	Curr->Voc-Link(s) 2!(p)
	>Voc-Link(s) 2!(p)
	<Voc-Link(s) 2!(p)  ;




\ Build-Equates Build-Labels Build-Forth .. J Lee -- 06/07/90
\


: Build-Equates	( -- ; build equates vocabulary )
	cs> "" EQUATES" $build-voc
	curr-page-chunk last'(s)@ 'equates(s) 2!(g)		\ save EQUATES	
	;


: Build-Labels	( -- ; build labels vocabulary )
	cs> "" LABELS" $build-voc
	curr-page-chunk last'(s)@ 'labels(s) 2!(g)		\ save LABELS
	;


: Reset->Voc-Link(s)s	(( -- ; reset >voc-link(s) for EQUATES & LABELS ))
	0 0 'equates(s) 2@(g) >voc-link(s)+ 2!(s)l
	0 0 'labels(s) 2@(g) >voc-link(s)+ 2!(s)l  ;


: Build-Forth	( -- ; builds Forth vocabulary )
	cs> "" FORTH" $make-voc		\ build vocabulary symbol
	curr-page-chunk last'(s)@	\ get 32-bit addr of forth symbol
	2dup voc-chunk+ !(p)  		\ set pointer to own chunk
	'forth(s) 2!(g)  ;		\ set forth pointer


: Build-Root	( -- ; build Root vocabulary )
	cs> "" ROOT" $build-voc
	curr-page-chunk last'(s)@ 'root(s) 2!(g)	\ save pointer to ROOT
	;


: Build-vocs	( -- ; build vocabularies )
	@voc-link(s)s
	build-equates
	build-labels
	reset-threads(s)
	reset->voc-link(s)s
	!voc-link(s)s
	build-forth
	only(s) 'forth(s) 2@(g) 2dup context(s) 2!(p)	\ force CONTEXT(S)
	set-definitions(s)		\ set FORTH voc as DEFINITIONS(S)
	build-root  ;			\ build root vocabulary


: Init-Vocs	( -- ; initialise vocabularies )
	curr-page-chunk latest-chunk voc-chunk-		\ force current(s) voc
	current(s) 2!(p)						\ set Current(s)
	build-vocs  ;


((
\ *********
	headers	
\ *********
))

: Init	( -- ; initialise the cross compiler )
	0 init-page							\ create page 0
	init-vocs
	init-vars
        -emulator                       \ default to disk output
        op-handle @ init-aux1  ;        \ initialise xc module

((
\ ********
	behead
\ ********
))









