((

	MEMDRVH.FTH
	Memory driver for big-endian targets

	MPE Forth Cross Compiler v5.00

	J Lee - 10/7/90


	Copyright (c) 1983-1990

	MicroProcessor Engineering
	133 Hill Lane
	Southampton
	SO1 5AF
	England

	tel: (+44) 703 631441   (international)
	tel: 0703-631441        (domestic)
	fax: (+44) 703 339691

))



only forth also c-c definitions
decimal



\ Memory drivers .. J Lee -- 10/08/90
\

	defer @(T)	\ fetch from target
	defer !(T)	\ store to target
	defer ,(T)	\ comma into target dictionary
	defer ,(R)	\ comma into target RAM
	defer w@(t)	\ word (16-bit) fetch
	defer w!(t)	\ word (16-bit) store
	defer W@(O)	\ word (16-bit) fetch
	defer W!(O)	\ word (16-bit) store
	defer L@(O)	\ long word (32-bit) fetch
	defer L!(O)	\ long word (32-bit) store





\ Memory reference - 8086 > big-endian .. sfp 24/11/87
\

\
\ The 6809 uses high-byte first (high byte at low address)
\
create split-buff  4 allot


: w@(d)	( addr -- n )
	dup c@(d) split-buff 1+ c!
	1+ c@(d) split-buff c!
	split-buff @  ;


: w!(d)	( n addr -- )
	swap split-buff !
	split-buff c@ over 1+ c!(d)
	split-buff 1+ c@ swap c!(d)  ;




\ Memory reference - 8086 > big-endian .. sfp 24/11/87
\

\
\ long addresses are meaningless on an 6809, but these are
\ implemented for 2@ and 2!
\


: l@(d)	( addr -- d )
	dup 2+ w@(d)  swap w@(d)  ;


: l!(d)	( d addr -- )
	>r  r@ w!(d)  r@ 2+ w!(d)  ;




\ Memory Reference - 8086 > big-endian .. sfp 24/11/87
\


\ Assume that double words are stored in memory order,
\ EXCEPT that the byte order in each 16-bit word is exchanged

: 2flip                                 \ d1 -- d1'
  flip swap flip swap  ;





\ Memory Reference - 8086 > big-endian .. Jon 15/02/89
\

: (W!(T))	( n addr -- )
	?inram
	If
		swap flip swap !
	Else
		 w!(o)
	Endif ;


: L!(T)	( d addr -- )
	?inram
	If
		>r  2flip  r> 2!
	Else
		l!(o)
	Endif  ;

: (W@(T))	( addr -- n )
	?inram
	If
		@ flip
	Else
		w@(o)
	Endif  ;


: L@(t)	( addr -- d )
	?inram
	If
		2@ 2flip
	Else
		L@(o)
	Endif  ;


: +!(t)	( n addr -- )
	>r  r@ w@(t) +  r> w!(t)  ;



\ Memory reference - 8086 > big-endian                   sfp 24/11/87
\

: L,(T)	( d -- )
	here(t) l!(t)  4 dp(t) +!(p)  ;


: W,(T)
  here(t) w!(t)  2 dp(t) +!(p)  ;


: C,(T)
  here(t) c!(t)  1 dp(t) +!(p)  ;




\ Memory reference - 8086 > 6809                   sfp 24/11/87
\


: W,(R)	( n -- )
	flip ita !  2 allot-ram  ;


: L,(R)	( d -- )
	2flip ita 2!  4 allot-ram  ;




\ Memory reference - 8086 > 6809                   Jon 21/05/90
\


assign w@(d) to-do w@(o)        \ disk is output device
assign w!(d) to-do w!(o)        \
assign (w@(t)) to-do w@(t)
assign (w!(t)) to-do w!(t)
assign w@(t) to-do @(t)
assign w!(t) to-do !(t)
assign w,(t) to-do ,(t)
assign w,(r) to-do ,(r)



\ memory reference - 8086 > big-endian .. J Lee -- 10/08/90
\

2 constant cell(t)

: >body(t)	( cfa -- pfa )
	3 + ;


\ >CA(T) converts a target CFA to the number that is compiled.
\ For most processors the compilation address is the CFA itself,
\ but on an RTX it is CFA >>1

: >ca(t)	( cfa -- compilation address )
        >>1  ;





















