(

	MEMDRVL.FTH
	Memory driver for little-endian targets

	MPE Forth Cross Compiler v5.00

	J Lee - 10/7/90


	Copyright (c) 1983-1990

	MicroProcessor Engineering
	133 Hill Lane
	Southampton
	SO1 5AF
	England

	tel: (+44) 703 631441   (international)
	tel: 0703-631441        (domestic)
	fax: (+44) 703 339691

)



only forth also c-c definitions
decimal




\ Memory drivers .. sfp 18/01/90
\


	defer @(T)	\ fetch from target
	defer !(T)	\ store to target
	defer ,(T)	\ comma into target dictionary
	defer ,(R)	\ comma into target RAM
	defer W@(T)	\ word (16-bit) fetch
	defer W!(T)	\ word (16-bit) store
	defer W@(O)	\ word (16-bit) fetch
	defer W!(O)	\ word (16-bit) store
	defer L@(O)	\ long word (32-bit) fetch
	defer L!(O)	\ long word (32-bit) store




\ Memory reference - 8086 > little-endian .. sfp 18/01/90
\


\
\ The 65xx family uses lo-byte first (lo. byte at lo. address)
\

create split-buff	4 allot


: w@(d)	( addr -- n )
	dup c@(d)  split-buff c!
	1+ c@(d)  split-buff 1+ c!
	split-buff @  ;


: w!(d)	( n addr -- )
	swap split-buff !
	split-buff c@  over c!(d)
	split-buff 1+ c@  swap 1+ c!(d)  ;




\ Memory reference - 8086 > little-endian .. sfp 18/01/90
\


\
\ long linear addresses are meaningless on a 8086, but they are
\ implemented for 2@ and 2!
\


: l@(d)	( addr -- d ; fetch double number )
	dup 2+ w@(d)  swap w@(d)  ;


: l!(d)	( d addr -- ; store double number )
	>r  r@ w!(d)  r> 2+ w!(d)  ;




\ Memory reference - 8086 > little-endian .. sfp 18/01/90
\


(

\ Assume that double words are stored in memory order,
\ EXCEPT that the byte order in each 16-bit word is exchanged

: 2flip         \ n1 n2 -- n1' n2' ; byte reverse both words
  flip swap flip swap  ;

)




\ Memory Reference - 8086 > little-endian .. sfp 18/01/90
\


: (W!(t))	( n addr -- )
	?inram
	If
		!
	Else
		w!(o)
	Endif  ;


: L!(t)	( d addr -- )
	?inram
	If
		2!
	Else
		l!(o)
	Endif  ;


: (W@(t))	( addr -- n )
	?inram
	If
		@
	Else
		w@(o)
	Endif  ;


: L@(t)	( addr -- d )
	?inram
	If
		2@
	Else
		l@(o)
	Endif  ;


: +!(t)	( n addr -- )
	>r  r@ w@(t) +  r> w!(t)  ;




\ Memory reference - 8086 > little-endian .. sfp 18/01/90
\


: L,(t)	( d -- )
	here(t) l!(t)  4 Dp(t) +!(p)  ;


: W,(t)	( n -- )
	here(t) w!(t)  2 Dp(t) +!(p)  ;


: C,(t)	( b -- )
	here(t) c!(t)  1 Dp(t) +!(p)  ;




\ Memory reference - 8086 > little-endian .. sfp 18/01/90
\


: W,(r)	( n -- ; comma into initialised RAM area )
	ita !  2 allot-ram  ;


: L,(r)	( d -- ; comma into initialised RAM area )
	ita 2!  4 allot-ram  ;




\ Memory reference - 8086 > little-endian .. sfp 18/01/90
\


	assign w@(d) to-do w@(o)	\ disk is output device
	assign w!(d) to-do w!(o)	\  "	"   "	   "
	assign (w!(t)) to-do w!(t)
	assign (w@(t)) to-do w@(t)
	assign w@(t) to-do @(t)
	assign w!(t) to-do !(t)
	assign w,(t) to-do ,(t)
	assign w,(r) to-do ,(r)




\ Memory reference - 8086 > 8086 .. sfp 18/01/90
\


2 constant cell(t)	\ size of 8086 cell

: >body(t)	( cfa -- pfa ; add size of call xxxx )
	3 +  ;		\ JUMP/CALL is 3 bytes


\ >CA(T) converts a target CFA to the number that is compiled.
\ For most processors the compilation address is the CFA itself,
\ but on an RTX it is CFA >>1

: >ca(t)	( cfa -- compilation-address )
  ;



















