((

	RTXASM Opcode generator for RTX Cross Compiler
	
	RTXASM Opcode Generator For
	RTX Cross Compiler

	Modifications:
	9/19/91, J Lee
		Fixed UBR! opcode.
	
	Copyright (C) 1988, 1989, 1990, 1991
	MicroProcessor Engineering Ltd.
	133 Hill Lane
	Southampton SO1 5AF
	England

	tel: (+44) 703 631441
	fax: (+44) 703 339691


))




only forth  also c-c  definitions
decimal




\ variables                                        sfp 11/10/90
\


\ -- addr
variable ?optimise      \ true if optimisation permitted
  ?optimise on

variable -opt           \ 0 when optimising
  1 -opt !              \ 1 = chain broken
                        \ -1 = none except EXIT permitted
variable -end-jumps     \ true if tail jump optimiser disabled
  -end-jumps on         \ default to disabled

Variable 1past          \ Contains address of last opcode
  -1 1past !

variable 2past          \ address of last but one opcode
  -1 1past !

variable 3past          \ address of last but two opcodes
  -1 1past !




\ misc support                                     sfp 16/10/90
\

: d=            \ d1 d2 -- t/f
  rot = -rot = and  ;

: compile-only  \ -- ; error if not compiling
  Compil? 0= 024 ?error  ;              \ cannot interpret




\ optimize nooptimize tail-jumps no-tail-jumps        \  16/10/90
\

also cc/i

: optimize      cc/i    \ -- ; enable optimisation
  ?optimise on  ;

: no-optimize	cc/i    \ -- ; disable optimisation
  ?optimise off  ;

: tail-opt      cc/i    \ -- ; enable tail jump optimiser
  -end-jumps off  ;

: no-tail-opt	cc/i    \ -- ; disable tail jump optimiser
  -end-jumps on  ;

previous definitions




\ \\ Break-Opt ,code                               sfp 11/10/90
\


: \\            \ -- ; break optimising chain completely
  1 -opt !                              \ flag
  -1 3past !  -1 2past !  -1 1past !  ; \ reset


: Break-Opt     \ -- ; break chain, but permit EXIT opt.
  -1 -opt !  ;


: ,Code         \ inst -- ; lays down code
  2past @ 3past !  1past @ 2past !      \ shuffle up old values
  Here(t) 1past !                       \ store address
  ,(T)  -Opt Off  ;                     \ lay opcode




\ exec-opcode interp-opcode                        sfp 09/10/90
\


Hex

Defer Exec-Opcode               \ cfa -- ; Execute opcode

: Interp-Opcode \ opcode --
  In-Umbilical @(g) 0= 023 ?Error       \ must be in umbilical
  Exec-Opcode  ;                        \ execute opcode




\ opcode opcode/ni                                 sfp 16/10/90
\


Hex

: OpCode        \ n -- ; -- [child] ; Opcode defining word
  Create  ,                             \ n -- ; <name>
  Does> @  Compil?                      \ compiling ?
  If  ,Code                             \ y: lay opcode
  Else  Interp-Opcode                   \ execute opcode
  Endif  ;


: OpCode/ni     \ n -- ; -- [child] ; Opcode defining word
  Create  ,                             \ n -- ; <name>
  Does> @  compile-only                 \ Error if not compiling
  ,Code  ;                              \ y: lay opcode




\ Last@ 2last@ Last! Set-In-Last                   sfp 10/10/90
\

: Last@         \ -- opcode ; returns last opcode laid
  1past @ @(t)  ;


: 2Last@        \ -- opcode ; returns 2nd last opcode laid
  1past @ @(t)  ;


: Last!         \ n -- ; rewrites last opcode
  1past @ !(t)  ;


: Set-In-Last   \ n -- ; sets bits in last opcode
  Last@ or Last!  ;




\ 1past@ 2past@ 3past@                             sfp 11/10/90
\


\ Return -1 if no instruction at marked location
: PAST@         \ addr -- ins|-1 ; return opcode
  @ DUP -1 <>
  IF  @(t)  endif  ;


: 1PAST@        \ -- ins|-1
  1PAST PAST@  ;


: 2PAST@        \ -- ins|-1
  2PAST PAST@ ;


: 3PAST@        \ -- ins|-1
  3PAST PAST@ ;


\ @last-ins                                        sfp 10/10/90
\

: @last-ins     \ -- addr opcode
  1past @ dup @(t)  ;




\ optimise? opt-allowed?                           sfp 11/10/90
\


Hex

: Optimise?     \ -- t/f ; true if optimising enabled
  ?optimise @
  if  -Opt @ 0=
      if  Last@ dup 09FFF u>  swap -1 <> and  0<>
      else  0
      endif
  else  0  
  endif  ;


: opt-allowed?  \ -- t/f ; True = optimization is turned on
  ?optimise @
  if  -opt @ 0=
  else  0
  endif  ;




\ optimise-exit?                                   sfp 11/10/90
\


Hex

: Optimise-Exit?        \ -- t/f ; true if optimising enabled
  -Opt @ -1 =                           \ temporarily disabled?
  if  -Opt Off  Endif                   \ yes, reset it
  ?optimise @                           \ optimisation permitted
  if  -Opt @ 0=                         \ and
      if  1past@ dup -1 <>
          if  0E000 and  08000 <>
          else  drop 0
          endif
      else  0
      endif
  else  0
  endif  ;

\ reg... user.. long...                            sfp 09/10/90
\

hex

\ : Register|Short-Literal-Op?           \ inst -- t|f
\   0F000 AND  0B000 =  ;

: Long-Literal-Op?      \ inst -- t|f
  0F000 AND  0D000 =  ;

: memory-op?            \ opcode -- t/f
  0E000 and  0E000 =  ;




\ back-patch remove-prev                           sfp 11/10/90
\

hex

: back-patch    \ opcode address -- ; replace last instruction
  2dup !(t)                             \ perform the store
  swap long-literal-op?                 \ long literal?
  if  4  else  2  endif                 \ 4 or 2 byte ins.
  + dp(t) !(p)  ;


: remove_prev   \ -- ; discards previous instruction
  -2 dp(t) +!(p)                           \ adjust DP
  2past @ 1past !  3past @ 2past !      \ shuffle down
  -1 3past !  ;                         \ mark last unused




\ alu-free? step-math? (>lsbs) >lsbs               sfp 09/10/90
\


hex

: alu-free?     \ opcode -- t/f ; true if ALU/inv free
  0F00 and                              \ extract ALU field
  dup 0000 =  swap 0E00 = or  ;


: step-math?    \ opcode -- t/f ; true if step maths ins.
  0F010 and  0A010 =  ;                 \ 1010 xxxx xxx1 xxxx


\ Extracts 5 lsb's from old instruction
: (>LSBS)       \ instr -- mask
  001F AND ;

: >LSBS         \ addr  -- mask
  @(t) (>LSBS)  ;




\ (not)                                            sfp 10/10/90
\

hex

: (not)         \ -- ; process NOT opcode
  optimise?                             \ permitted
  if  last@                             \ yes, fetch last ins
      dup alu-free?                     \ ALU unused
      swap step-math? 0=  and           \ and not step math op
      if  last@ 0100 or dup last!       \ optimise last instr.
          0F000 and  0A000 <>           \ inhibit if non-math
          if  break-opt  endif          \ for next instruction
      else  0A100 ,code                 \ lay straight code
      endif                             \
  else  0A100 ,Code
  endif  ;




\ is_lit? sh_lit                                   sfp 09/10/90
\

hex

: is_lit?       \ opcode -- t/f ; true if literal needed
  0F000 and                             \ mask class
  dup 0B000 =  swap 0C000 =  or  ;      \ B or C


: sh_lit        \ -- opcode ; look at past two instructions
  2past@ dup is_lit?                    \ second back ?
  if  exit  then                        \ yes
  drop                                  \ no, discard opcode
  1past@ dup is_lit?                    \ first back
  if  exit  then                        \ yes
  drop  0  ;                            \ no, discard op, fail




\ memory_instruction word/byte?                    sfp 09/10/90
\

hex

\ locates memory instruction being replaced
: memory_instruction    \ standalone -- mask
  dup memory-op?                        \ standalone is mem-op?
  if  exit  then                        \ yes
  drop  1past@ dup memory-op?           \ no, try one back
  if  exit  then                        \ yes
  drop  2past@  ;                       \ no, nust be two back


: WORD/BYTE?  ( instr standalone -- instr')
  MEMORY_INSTRUCTION     \ Locate the memory instruction
  0F000 AND              \ word\byte status from memory instr
  SWAP 0FFF AND  OR  ;




\ 2BACKABLE?                                     14sfp 11/10/90
\

HEX
\ Verifies that two previous instructions may be optimized.
\   Checks for non-zero table address, valid 2back instruction,
\   and ALU+shift instruction which the table-driven optimizer
\   would improperly combine.
: 2BACKABLE?    ( table -- table t | f)
  DUP 0=  2PAST @ -1 =  OR      \ No table or 2back instruc
  IF  DROP  0  EXIT  THEN
  2PAST@  DUP 0F000 AND  0A000 =
  SWAP 000F AND 0<>  AND        \ ALU+shift
  IF  DROP  FALSE  EXIT  THEN
  TRUE  ;




\ 2BACK?                                         08sfp 09/10/90
\

\ Attempts to match 2 previous instructions against patterns
\  from table. Returns address of 2 instructions back and
\  mask for optimized instruction  if found.
: 2BACK?        \ m2 m1 table -- adr ins t | f
  2BACKABLE? NOT IF  2DROP  FALSE  EXIT  THEN
  >R                                    \ save table address
  2PAST@ AND ( m1)  SWAP 1PAST@ AND ( m2)
  BEGIN  R@ @                           \ 0 marks end of table
    WHILE  2DUP  R@ @  R@ 2+ @  D=      \ test ops against tabl
    IF  2DROP  2PAST @ SH_LIT (>LSBS)  R> 4 + @  OR TRUE EXIT
    THEN
    R>  6 +  >R
  REPEAT
  2DROP  R> DROP   FALSE   ;            \ No match




\ 1BACK?                                         14sfp 10/10/90
\

\ Attempts to match previous instruction against pattern
\  from table. Returns address of previous instruction and
\  mask for optimized instruction if found.
: 1BACK?        ( m1 table -- adr ins t | f)
  DUP 0=  1PAST @ -1 =  OR
  IF  2DROP  FALSE  EXIT  THEN
  ( table) >R  1PAST@ ( m1) AND
  BEGIN  R@ @                   \ 0 marks end of table
    WHILE  DUP  R@ @ =          \ test instructions against tabl
           IF  DROP  1PAST @  DUP >LSBS  R> 2+ @ OR  TRUE  EXIT
           THEN
           R> 4 + >R
    REPEAT
  DROP  R> DROP   FALSE    ;     \ No match




\ BACK-COMPILE                                   08sfp 10/10/90
\

HEX

: BACK-COMPILE   ( standalone literal m1 table1 m2 table2 -- )
  optimise? not if  2drop 2drop  or ,code  exit  endif
  3 PICK ( m1)  SWAP            \ -- sa lit m1 t1 m2 m1 t2
  2BACK?                        \ -- sa lit m1 t1 ad ins t
  IF  ( instr) dup memory-op?
      IF  5 PICK  WORD/BYTE?  THEN  4 ROLL OR  \ merge literal
      SWAP BACK-PATCH  2PAST @ 1PAST !  3PAST @ 2PAST !
      -1 3past !  2DROP DROP  EXIT
  THEN
  ( m1 table1)  1BACK?
  IF  0FFF AND  last@ 0F000 AND  OR
      ( literal) ROT OR   SWAP  BACK-PATCH  DROP EXIT
  THEN
  ( standalone literal ) OR ,code  ;




\ d-TABLE                                          sfp 10/10/90
\

HEX

CREATE d1-TABLE
  EE00 , EF40 ,      \           @  ->  @ d
  E080 , EEC0 ,      \ OVER SWAP !  ->  OVER SWAP ! d
  EE80 , EFC0 ,      \           !  ->  ! d
  0000 ,             \ end of table

CREATE  d2-TABLE
  A040 , EE00 ,  EE40 ,   \ SWAP DROP @  -> SWAP DROP @ d
  0000 ,





\ SHORT-LITERAL                                  12sfp 10/10/90
\


HEX

: SHORT-LITERAL   ( d -- )
  BE40            \ Standalone short literal
  SWAP            \ Literal value
  EFE0            \ Mask for 1 previous instruction
  d1-TABLE        \ Patterns for single previous instruction
  EFE0            \ Mask for two previous instructions
  d2-TABLE        \ Patterns for two previous instructions
  BACK-COMPILE ;





\ literal(a)                                       sfp 11/10/90
\


hex
\ Determines whether a value should be a short or long literal
\  and compiles the appropriate instruction.  Values between
\  -32 and -1 are generated as short literals with the NOT bit
\  set.
: LITERAL(a)    \ n --
  DUP  0 01F within?                    \ 0..31 ?
  IF  SHORT-LITERAL  EXIT  THEN         \ y: lay short literal
  ?optimise @                           \ more permitted?
  if  dup -020 -1 within?               \ y: -32..-1 ?
      IF  break-opt  NOT SHORT-LITERAL  \ lay inverted number
          (NOT)  exit                   \ invert it again
      THEN
  endif
  0DE00 ,Code ,(t)  ;                   \ otherwise lay long lit




\ MINUS1-TABLE                                   07sfp 10/10/90
\


HEX
CREATE MINUS2-TABLE
  BE00 , AE80 ,      \ G@   SWAP   -> G@   SWAP -
  BE40 , AE80 ,      \ d    SWAP   -> d    SWAP -
  0000 ,             \ end of table

CREATE MINUS1-TABLE
  BE00 ,             \ G@        -> G@ SWAP -
  BE40 ,             \ d         -> d  SWAP -
  CE00 ,             \ U@        -> U@ SWAP  SWAP-
  DE00 ,             \ D         -> D  SWAP  SWAP-
  EE00 ,             \ @         -> @  SWAP  SWAP-
  FE00 ,             \ C@        -> C@ SWAP  SWAP-
  0000 ,             \ end of table
DECIMAL




\ MINUS-2BACK?                                   08sfp 10/10/90
\

HEX

\ Attempts to match 2 previous instructions against patterns
\  from table.
: MINUS-2BACK?  \ -- f
  2PAST@ dup -1 =
  IF  drop  FALSE  EXIT  THEN
  0FFE0 AND  last@
  MINUS2-TABLE >R
  BEGIN  R@ @                           \ 0 marks end of table
    while  2DUP  R@ @  R@ 2+ @  d=      \ test ins. against tabl
           IF  R> DROP 2DROP  TRUE EXIT  THEN
           R> 4 + >R
  REPEAT
  2DROP  R> DROP  FALSE  ;              \ No match




\ MINUS-1BACK?                                   08sfp 10/10/90
\

HEX

\ Attempts to match previous instruction against pattern
\  from table.
: MINUS-1BACK?  \ -- f
  1PAST@ dup -1 =
  IF  drop  FALSE  EXIT  THEN
  0FFE0 AND
  MINUS1-TABLE >R
  BEGIN  R@ @                   \ 0 marks end of table
    while  DUP  R@ @ =          \ test ins. against table
           IF  DROP R> DROP  TRUE  EXIT THEN
           R> 2+ >R
  REPEAT
  DROP  R> DROP  FALSE  ;        \ No match




\ MINUS_OP?                                      09sfp 10/10/90
\

HEX
: MINUS_OP?  ( alu_code -- f)
  DUP  0400 =    OVER 0500 =  OR        \ SWAP-  SWAP-c
  OVER 0C00 = OR SWAP 0D00 =  OR  ;     \  -       -c

: INVERT_MINUS ( alu -- alu')
  DUP MINUS_OP?
  IF  0800 XOR  THEN  ;                 \ Invert SWAP bit

: FIX_MINUS   ( alu_code -- alu_code')
  opt-allowed?  NOT IF  EXIT  THEN
  DUP MINUS_OP? NOT IF  EXIT  THEN
  MINUS-2BACK?      IF  INVERT_MINUS  EXIT  THEN
  MINUS-1BACK?      IF  INVERT_MINUS        THEN  ;




\ ALU2-TABLE                                     13sfp 10/10/90
\

HEX
CREATE ALU2-TABLE
 AE80 , AEC0 ,  A080 ,  \ SWAP OVER    -> SWAP OVER alu
 AEC0 , AEC0 ,  A0C0 ,  \ OVER OVER    -> OVER OVER alu (2DUP)
 BE00 , AEC0 ,  B000 ,  \ G@   OVER    -> G@   OVER alu
 BE00 , AE80 ,  B080 ,  \ G@   SWAP    -> G@   SWAP alu
 BE40 , AEC0 ,  B040 ,  \  d   OVER    -> d    OVER alu
 BE40 , AE80 ,  B0C0 ,  \  d   SWAP    -> d    SWAP alu
 CE00 , AEC0 ,  C000 ,  \ U@   OVER    -> U@   OVER alu
 EE00 , AEC0 ,  E000 ,  \  @   OVER    -> @    OVER alu
 FE00 , AEC0 ,  F000 ,  \ C@   OVER    -> C@   OVER alu
 DE00 , AEC0 ,  D000 ,  \  D   OVER    -> D    OVER alu
 E0C0 , BE40 ,  E0C0 ,  \ UNDER TUCK ! -> UNDER TUCK ! alu
 E1C0 , BE40 ,  E1C0 ,  \       TUCK ! ->       TUCK ! alu




\ ALU2-TABLE, cont'd                             13sfp 10/10/90
\

hex

 F0C0 , BE40 ,  F0C0 ,  \ UNDER TUCK C! -> UNDER TUCK C! alu
 F1C0 , BE40 ,  F1C0 ,  \       TUCK C! ->       TUCK C! alu
 E040 , BE40 ,  E040 ,  \ DUP @ SWAP d  -> DUP @ SWAP d SWAP alu
 F040 , BE40 ,  F040 ,  \ DUP C@ SWAP d -> DUP C@ SWAP d SWAP a
 E140 , BE40 ,  E140 ,  \ NIP DUP @ SWAP d -> + alu
 F140 , BE40 ,  F140 ,  \ NIP DUP C@ SWAP d -> + alu
 AEC0 , AE80 ,  A000 ,  \ OVER SWAP    -> OVER SWAP alu
 0000 ,                 \ end of table





\ ALU1-TABLE                                     11sfp 11/10/90
\

hex

CREATE ALU1-TABLE
  BE00 , B080 ,      \ G@        -> G@ SWAP alu
  BE40 , B0C0 ,      \ d         -> d  SWAP alu
  C000 , C080 ,      \ U@ SWAP   -> U@ SWAP alu
  CE00 , C080 ,      \ U@        -> U@ SWAP alu
  D000 , D080 ,      \ D  SWAP   -> D  SWAP alu
  DE00 , D080 ,      \ D         -> D  SWAP alu
  E000 , E080 ,      \ @  SWAP   -> @  SWAP alu
  EE00 , E080 ,      \ @         -> @  SWAP alu
  F000 , F080 ,      \ C@ SWAP   -> C@ SWAP alu
  FE00 , F080 ,      \ C@        -> C@ SWAP alu
  0000 ,             \ end of table




\ remove_swap?                                     sfp 10/10/90
\

HEX
\ If the instruction preceding the ALU instruction is a
\  standalone SWAP, it can be eliminated. An OVER SWAP
\  sequence, however, must be preserved.
: REMOVE_SWAP?  ( alu  -- alu' )
  1PAST@ 0AE80 <>  IF  EXIT  THEN       \ SWAP
  2PAST@ 0AEC0  =  IF  EXIT  THEN       \ OVER SWAP
  INVERT_MINUS                          \ Convert - to swapped
  REMOVE_PREV ;                         \ Remove SWAP instr





\ BACK-COMPILE-ALU                               08sfp 10/10/90
\

HEX

: BACK-COMPILE-ALU      \ alu_code --
  0A040 SWAP              \ Standalone ALU instruction
  FIX_MINUS               \ Invert Minus operator?
  REMOVE_SWAP?            \ Eliminate preceding SWAP instruction
  FFE0                    \ Mask for 1 previous instruction
  ALU1-TABLE              \ Patterns for single previous instr
  FFE0                    \ Mask for two previous instrs
  ALU2-TABLE              \ Patterns for two previous instrs
  BACK-COMPILE ;




\ alu                                            15sfp 10/10/90
\

\ Creates an instruction code which attempts to back compile
\ an ALU operation into the previous instruction.
: alu-op        \ opcode --
  CREATE  ,  DOES> @
  compil?
  if  BACK-COMPILE-ALU
  else  0A040 + Interp-Opcode
  endif  ;





\ SWAP1-TABLE                                      sfp 10/10/90
\

HEX

CREATE SWAP1-TABLE
  CE00 , C000 ,      \ U@      -> U@  SWAP
  C000 , CE00 ,      \ U@ SWAP -> U@  SWAP SWAP
  EE00 , E000 ,      \ @       ->  @  SWAP
  E000 , EE00 ,      \ @  SWAP ->  @  SWAP SWAP
  FE00 , F000 ,      \ C@      -> C@  SWAP
  F000 , FE00 ,      \ C@ SWAP -> C@  SWAP SWAP
  DE00 , D000 ,      \ D       ->  D  SWAP
  D000 , DE00 ,      \ D  SWAP ->  D  SWAP SWAP
  0000 ,             \ end of table




\ SWAP2-TABLE                                    07sfp 10/10/90
\

hex

CREATE SWAP2-TABLE
  A0C0 , EE00 ,  E140 ,   \ DUP @      -> DUP @ SWAP
  A080 , EE00 ,  E040 ,   \ NIP DUP @  -> NIP DUP @ SWAP
  A0C0 , FE00 ,  E140 ,   \ DUP C@     -> DUP C@ SWAP
  A080 , FE00 ,  E040 ,   \ NIP DUP C@ -> NIP DUP C@ SWAP
  AEC0 , AE80 ,  AEC0 ,   \ OVER SWAP  -> OVER
  BE00 , AE80 ,  BE00 ,   \ G@ SWAP    -> G@
  BE40 , AE80 ,  BE40 ,   \ d  SWAP    -> d
  0000 ,



\ <SWAP>  smart SWAP                             07sfp 10/10/90
\

HEX

: <SWAP>
  AE80            \ Standalone SWAP
  0000            \ Literal value - N/A
  FFE0            \ Mask for 1 previous instruction
  SWAP1-TABLE     \ Patterns for single previous instruction
  FFE0            \ Mask for two previous instructions
  SWAP2-TABLE     \ Patterns for two previous instructions
  BACK-COMPILE ;




\ DROP-TABLE                                     17sfp 10/10/90
\

HEX

CREATE DROP1-TABLE
  AE80 , A040 ,         \ SWAP         -> SWAP DROP
  BE00 , B000 ,         \ G@           -> G@   DROP
  BE40 , B040 ,         \ d            -> d    DROP
  C080 , CE80 ,         \ DUP U!       -> DUP U! DROP
  E080 , EE80 ,         \ OVER SWAP !  -> OVER SWAP ! DROP
  F080 , FE80 ,         \ OVER SWAP C! -> OVER SWAP C! DROP
  D000 , DE80 ,         \ D            -> D DROP
  0000 ,                \ end of table

CREATE DROP2-TABLE
  BE40 , AE80 , BEC0 ,  \ d SWAP       -> d SWAP DROP
  0000 ,                \ end of table




\ <DROP>  smart DROP                             17sfp 10/10/90
\

HEX

: <DROP>
  AE40            \ Standalone DROP
  0000            \ Literal value - N/A
  FFE0            \ Mask for 1 previous instruction
  DROP1-TABLE     \ Patterns for single previous instruction
  FFE0            \ Mask for two previous instructions
  DROP2-TABLE     \ Patterns for two previous instructions
  BACK-COMPILE ;





\ DUP-TABLE                                      17sfp 10/10/90
\

HEX

CREATE DUP-TABLE
 AE40 , AE00 ,       \ DROP      -> DROP DUP
 A040 , A080 ,       \ SWAP DROP -> SWAP DROP DUP
 0000 ,




\ <DUP>  smart DUP                               17sfp 10/10/90
\

HEX

: <DUP>
  A0C0            \ Standalone DUP
  0000            \ Literal value - N/A
  FFFF            \ Mask for 1 previous instruction
  DUP-TABLE       \ Patterns for single previous instruction
  FFFF            \ Mask for two previous instructions
  0000            \ Patterns for two previous instructions-N/A
  BACK-COMPILE ;




\ !2-TABLE                                       12sfp 10/10/90
\


\ Pattern table for ! and C! instructions.

HEX

CREATE !2-TABLE
 AEC0 , AE80 ,  E080 ,  ( OVER SWAP)
 AE80 , AEC0 ,  E1C0 ,  ( SWAP OVER)
 AEC0 , AEC0 ,  E0C0 ,  ( OVER OVER)
 0000 ,                 ( end of table)




\ !-INSTR !-op                                     sfp 11/10/90
\

\ Attempts to back-compile ! or C! into previous instruction
HEX

: !-instr           \ opcode
  0000              \ Literal - N/A
  FFE0              \ Mask for single instruction
  0000              \ Pattern table for single instruction - N/A
  FFE0              \ Mask for two instructions
  !2-TABLE          \ Pattern table for two instructions
  BACK-COMPILE  ;


: !-op          \ opcode --
  create  ,  does> @  Compil?
  if  !-instr
  else  Interp-Opcode
  endif  ;




\ <@> <!> <c@> <c!> <over>                         sfp 11/10/90
\

hex

: <@>           \ -- ; lay @ opcode
  0EE00 ,Code  ;


: <c@>          \ -- ; lay c@ opcode
  0FE00 ,Code  ;


: <!>           \ -- ; lay ! opcode
  0EE80 !-instr  ;


: <C!>          \ -- ; lay ! opcode
  0FE80 !-instr  ;


: <over>        \ -- ; lay OVER opcode
  0AEC0 ,Code  ;




\ TEST-CORE-REGISTERS                            12sfp 11/10/90
\

\ Checks the previous instruction to see if it is a core
\   register access whose function would be drastically changed
\   by setting the return bit. Also tests for >R instruction
\   which must be converted to use Register 7 if the return
\   bit is to be set.

HEX

: TEST-CORE-REGISTERS   \ -- t/f true if safe to optimise
  1PAST@                      \ Last compiled opcode
  DUP F058 AND B000 <> IF DROP TRUE EXIT THEN  \ not G access
  DUP BE81 (     >R) = IF DROP BE87 last! TRUE EXIT THEN
  DUP B081 ( DUP >R) = IF DROP B087 last! TRUE EXIT THEN
  DUP (>LSBS) 1 = IF  DROP FALSE EXIT  THEN    \ any access to
  DUP BEC0 AND  DUP B080 =  SWAP BE80 =  OR    \ G! instruction
  SWAP (>LSBS)  2 <=  AND  NOT ;               \   to 0 1 or 2




\ bits9-0 bits15-10 big-jump?                      sfp 11/10/90
\

hex

: BITS9-0       \ addr -- addr' ; extracts lower 9 addr bits
  03FF AND  ;


: BITS15-10     \ a -- addr' ; extracts page addr bits
  0FC00 AND  ;


: BIG-JUMP?     \ addr-of-br-ins target -- t/f
  BITS15-10  SWAP 2+ BITS15-10 -  ABS   \ range of jump
  0400 U>  ;                            \ +/- one page check




\  Branches                                      13sfp 11/10/90
\

\ FIXUP takes the address of a branch instruction and the
\   address to branch to, then back patches the instruction. The
\   instr. addr. is incremented by 2 to handle cases when the
\   branch instr. is in the word immediately preceding a block
\   boundary. ( the pc is already pointing to the new block )

: FIXUP         \ addr-ins addr-target --
  2DUP BIG-JUMP? ABORT" Branch offset too large"
  DUP BITS9-0 >>1 >R                    \ branch offset >>1
  BITS15-10  OVER 2+ BITS15-10 - dup    \ extract page range
  IF  0>                                \ not current,
      IF  0200 R> OR                    \ +ve, so next block
      ELSE  0600 R> OR  THEN            \ -ve, so prev-block
  ELSE  ( ai n)  DROP 0000 R> OR        \ 0, so current block
  THEN                                  \ -- addr-ins mask
  over @(t)  0F800 and or  swap !(t) ;  \ replace instruction




\ >END_JUMP                                      09sfp 11/10/90
\

HEX

\ Attempts to convert a word's final Call ins to a branch
: >END_JUMP     \ -- f ; true if optimised
  -end-jumps @  ?optimise @ 0=  or      \ check permissions
  IF  FALSE EXIT  THEN                  \ invalid
  1past@ DUP 07FFF U>                   \ fail if primitive
  IF  DROP FALSE EXIT  THEN             \ failed
  2PAST@ 0BE8F =                        \ fail if long call
  IF  DROP FALSE EXIT  THEN             \ failed
  2*                                    \ convert to address
  1past @ over BIG-JUMP?                \ In jump range?
  IF  DROP  FALSE  EXIT  THEN           \ No
  09000 last!  1past @ swap fixup       \ install BRANCH
  true  ;                               \ optimisation ok!




\ <exit> - Harris exit optimiser                   sfp 11/10/90
\

hex

: <Exit>        \ -- ; deal with return bit or standalone return
  -Opt @ -1 =                           \ temporarily disabled?
  if  -Opt Off  Endif                   \ yes, reset it
  >END_JUMP IF  EXIT  THEN              \ tail optimiser done!
  optimise?
  if  TEST-CORE-REGISTERS               \ check return bit safe
      IF   0020 Set-In-Last  \\  Exit  THEN
  endif
  0A020 ,Code  \\  ;                    \ Standalone return




\ <exit> - MPE exit optimiser                      sfp 11/10/90
\


((
hex

: <Exit>        \ -- ; set Exit bit
  Optimise-Exit?
  If  Last@  0F000 And >R               \ extract opcode class
      R@ 0A000 =                        \ can only merge A
      R> 0C000 0F000 within? OR         \  C..F
      Last@ 0F040 And  0B040 =  OR      \ any short literal
      If  0020 Set-In-Last              \ so merge it
      Else  0A020 ,Code                 \ or compile opcode
      Endif
  Else  0A020 ,Code
  Endif
  \\  ;
))




\ BACKPATCH_MEMORY                               12sfp 11/10/90
\

HEX

\ Replaces optimized memory reference containing short literal
\  with appropriate individual instructions
: BACKPATCH_MEMORY      \ opcode --
  CASE  0FFC0 AND
    0EE40 OF <SWAP> <DROP> <@>  ENDOF
    0EF40 OF               <@>  ENDOF
    0EEC0 OF <OVER> <SWAP> <!>  ENDOF
    0EFC0 OF               <!>  ENDOF
    0FE40 OF <SWAP> <DROP> <C@> ENDOF
    0FF40 OF               <C@> ENDOF
    0FEC0 OF <OVER> <SWAP> <C!> ENDOF
    0FFC0 OF               <C!> ENDOF
  ENDCASE ;




\ EXTRACT_LITERAL                                12sfp 11/10/90
\

HEX

\ Attempts to extract short literal from preceding instruction.
\  Looks for Short literal, {SWAP DROP} @ d or {OVER SWAP} ! d
: EXTRACT_LITERAL       \ --  lit t | f
  1PAST@ DUP -1 =                       \ No previous instr?
  IF  DROP  FALSE  EXIT  THEN           \ y: so exit
  DUP 0FFE0 AND  0BE40 =                \ Short literal?
  IF  REMOVE_PREV  (>LSBS)  TRUE  EXIT  \ y: remove literal
  THEN
  DUP 0EE40 AND  0EE40 =                \ Memory reference?
  IF  REMOVE_PREV  DUP BACKPATCH_MEMORY \ remove and extract
      (>LSBS)  TRUE EXIT
  THEN
  DROP FALSE ;




\ Instructions w/literal data                    10sfp 11/10/90
\

HEX

\  Replaces preceeding short literal instruction with G-Space
\    or User space instruction. Tests for  DUP x! form.
: LIT->INST     \ opcode --
  EXTRACT_LITERAL 0= 025 ?error         \ check for literal
  OR                                    \ merge lit into instr
  DUP 0080 AND  0080 =                  \ G! or U! ?
  IF  1PAST@ 0A0C0 =                    \ preceded by DUP ?
      IF  0F1FF AND
          1PAST @ BACK-PATCH  EXIT
      THEN
  THEN
  ,Code  ;                              \ x@ or not DUP x!




\ slit-op                                          sfp 11/10/90
\

hex

: slit-op       \ [n] opcode --
  create  ,  does> @  compil?
  if  lit->inst
  else  depth 2 < 025 ?error            \ must have literal
        over 01F u> 025 ?error          \ in range 0..31
        or                              \ merge with opcode
        Interp-Opcode                   \ and execute it
  endif  ;




\ Shift-Op                                         sfp 09/10/90
\

Hex

: Shift-Op
  Create  ,  Does> @
  Compil?
  If  Optimise?
      if  last@  0F01F and  0A000 =     \ ALU op, no shift?
          if  000F And  Set-in-Last     \ yes, merge
              Break-Opt  Exit           \ no further opt.
          endif
      endif
      ,Code  Break-Opt
  Else  Interp-Opcode
  Endif  ;




\ Smart ?DUP                                       sfp 16/10/90
\

\ Compiles standalone ?DUP as DUP ?DUP_0BRANCH to next location.
\ IF will look for this pattern, eliminate the DUP and
\    readjust the branch address:
\ ?DUP
\  | DUP | ?DUP_0BRANCH |    |     |     |
\              |___________^
\
\ ?DUP IF
\  |     | ?DUP_0BRANCH |    |     |      | then |
\              |_____________________________^


: <?DUP>
  <DUP>  here(t)  08000 ,Code   here(t) FIXUP  ;




\ <IF>                                             sfp 16/10/90
\

HEX

: <IF>          \ -- ; compiles a conditional branch.
  2PAST@ 0A0C0 =                        \ previous is ?DUP
  1PAST@ 0F800 AND 08000 =  AND         \ as DUP IF
  if  REMOVE_PREV REMOVE_PREV           \ remove it
      08000                             \ ?dup_0branch
  else  08800                           \ 0branch
  endif
  ,Code  ;




\ <>r>                                             sfp 16/10/90
\

HEX

: <>R>          \ -- ; Checks for R> DROP >R sequence
  optimise?                             \ optimisation permitted
  if  case  last@
        0B001 of  0BE80 last!  endof    \ R> DROP >R = R!
        0A0C0 of  0B081 last!  endof    \ DUP >R
                  0BE81 ,Code           \ default opcode
      endcase                           \
  else  0BE81 ,Code                     \ standalone opcode
  endif  ;




\ <r@>                                             sfp 16/10/90
\

hex

: <r@>          \ -- ; process R@ opcode
  optimise?                             \ only if permitted
  if  last@ 0BE81 =                     \ previous is >R ?
      if  0B081 last!  exit  endif      \ y: replace by DUP >R
  endif
  0BE00 ,Code  ;                        \ standalone opcode




\ opcodes - not swap                               sfp 16/10/90
\

also asm-access definitions

Hex

: not            \ -- ; process NOT operation
  compil?
  if  (not)  else  0A100 Interp-opcode  endif  ;


: swap          \ -- ; process SWAP
  compil?
  if  <swap>  else  0AE80 Interp-Opcode  endif  ;




\ opcodes - drop dup >r r@                         sfp 16/10/90
\

: drop          \ -- ; process DROP operation
  compil?
  if  <drop>  else  0AE40 Interp-Opcode  endif  ;


: dup           \ -- ; process DUP operation
  compil?
  if  <dup>  else  0A0C0 Interp-Opcode  endif  ;


: >r            \ n -- ; process >R operation
  compile-only  <>r>  ;

: r@            \ n -- ; process R@ operation
  compile-only  <r@>  ;




\ opcodes                                          sfp 09/10/90
\

Hex

08800 OpCode/NI ?Branch
09000 OpCode/NI BRANCH
09800 OpCode/NI (NEXT)
0A000 OpCode NOOP
0A000 Opcode NOP

0B8C0 OpCode 0+
0B8C1 OpCode 1+
0B8C2 OpCode 2+
0B4C1 OpCode 1-
0B4C2 OpCode 2-




\ opcodes cont.                                    sfp 16/10/90y
\

hex

0A012 Opcode 2*'

0A040 OpCode NIP
0AEC0 OpCode OVER

0BCC0 OpCode Negate




\ internal register access 1                       sfp 16/10/90
\

hex

0BE01 OpCode/NI R>
0BE03 OpCode CR@
0BE04 OpCode MD@
0BE05 OpCode SQ@
0BE06 OpCode SR@
0BE07 OpCode PC@
0BE83 OpCode CR!
0BE84 OpCode MD!
0BE85 OpCode SQ!
0BE86 OpCode SR!




\ internal register access 2                       sfp 07/09/90
\

hex

0BE08 Opcode imr@               0BE88 Opcode imr!
0BE09 Opcode spr@               0BE89 Opcode spr!

0BE0B Opcode ivr@               0BE8B Opcode slr!
0BE0C Opcode ipr@               0BE8C Opcode ipr!
0BE0D Opcode dpr@               0BE8D Opcode dpr!
0BE0E Opcode upr@               0BE8E Opcode upr!
0BE0F Opcode cpr@               0BE8F Opcode cpr!




\ internal register access 3                       J Lee 9/10/91
\

hex

0BE10 Opcode ibc@               0BE90 Opcode ibc!
0BE11 Opcode ubr@               0BE91 Opcode ubr!

0BE13 Opcode tc0@               0BE93 Opcode tc0!
0BE14 Opcode tc1@               0BE94 Opcode tc1!
0BE15 Opcode tc2@               0BE95 Opcode tc2!




\ special register instructions                    sfp 07/09/90
\

hex

0B010 Opcode -softint
0B090 Opcode softint
0B00D Opcode SELCPR
0B08D Opcode SELDPR

0A096 Opcode RTR
0A09E Opcode RDR
0A196 Opcode R'
0AADE Opcode C'




\ opcodes cont.                                    sfp 10/10/90
\

hex

0DE00 OpCode/NI LIT

0EE00 OpCode @
0EE80 !-Op !
0FE00 OpCode C@
0FE80 !-Op C!

0E942 OpCode @++
0E9C2 OpCode !++
0F941 OpCode C@++
0F9C1 OpCode C!++




\ opcodes cont.                                    sfp 16/10/90
\

hex

0BE82 Opcode/NI Times           \ original NOVIX
0BE82 Opcode/NI Of(             \ Harris
0BE82 Opcode/NI EXTRA(          \ Silicon Composer's OF(
0BE87 Opcode Execute
0BEA7 Opcode/NI GOTO
0BEA0 Opcode/NI ;>R




\ step maths                                       sfp 07/09/90
\

hex

0A41A Opcode U/1'
0A45A Opcode U/'
0A458 Opcode U/"

0A49C Opcode U*"
0A89C Opcode U*'
0A89D Opcode *'
0A49D Opcode *"

0A55A Opcode S'
0A558 Opcode S"
0A51A Opcode S1'




\ g@ g! u@ u!                                      sfp 03/10/90
\

hex

0BE00 SLit-Op G@
0BE80 SLit-Op G!
0CE00 slit-op U@
0CE80 slit-op U!

0E9C0 slit-op !+                0E940 slit-op @+
0E5C0 slit-op !-                0E540 slit-op @-
0F9C0 slit-op C!+               0F940 slit-op C@+
0F5C0 slit-op C!-               0F540 slit-op C@-




\ Dyadic ALU Ops                                   sfp 16/10/90
\

hex

0200 ALU-Op AND
0300 ALU-Op NOR
0400 ALU-Op Swap-
0500 ALU-Op Swap-c
0600 ALU-Op OR
0700 ALU-Op NAND
0800 ALU-Op +
0900 ALU-Op +c
0A00 ALU-Op XOR
0B00 ALU-Op XNOR
0C00 ALU-Op -
0D00 ALU-Op -c




\ shift-ops                                        sfp 16/10/90
\

hex

                                0A008 Shift-Op N2*
0A001 Shift-Op 0<               0A009 Shift-Op N2*c
0A002 Shift-Op 2*               0A00A Shift-Op D2*
0A003 Shift-OP 2*c              0A00B Shift-Op D2*c
0A004 Shift-Op cU2/             0A00C Shift-Op cUD2/
0A005 Shift-Op c2/              0A00D Shift-Op cD2/
0A006 Shift-Op U2/              0A00E Shift-Op UD2/
0A007 Shift-Op 2/               0A00F Shift-Op D2/

previous definitions




\ Exit
\


only forth  also c-c  also cc/c

: Exit          cc/c                    \ -- ; set Exit bit
  <exit>  ;

only forth  also c-c definitions




\ macros                                           sfp 16/10/90
\

also asm-access definitions

: 2drop         drop drop  ;
: 2dup          over over  ;

: tuck          swap over  ;
: under         over swap  ;

: s>d           dup 0<  ;

: ?dup          compile-only <?dup>  ;

previous definitions




\ DoCreate, DoDoes,                                sfp 03/10/90
\

hex

: docreate,
  0BE27 ,Code  \\  ;

: doconstant,
  0DE20 ,Code  \\  ;

: do2constant,
  0DE00 ,Code swap ,(t)  0DE20 ,Code ,(t)  \\  ;

: doFconstant,
  0DE00 ,Code rot ,(t)
  0DE00 ,Code swap ,(t)
  0DE20 ,Code ,(t)  \\  ;

: doFarray,     \ f1 .. fn n -- ;
  0 ?Do
    ,(t) ,(t) ,(t)
  Loop
;

: Dodoes,
  [+asm-access] R> [previous]  ;

\ target memory reference                          sfp 31/08/90
\


 2 constant cell(t)



only forth also c-c definitions

