((
        UFORTH.FTH

	J Lee: February 1988

        6-12/90 JL:
                Upgraded for V5.xx cross compiler.

	Copyright (c) 1988-91
	MicroProcessor Engineering
 	133 Hill Lane
	Shirley
	Southampton SO1 5AF

	tel:	0703 631441        (inside UK)
		(+44) 703 631441   (international)

	Umbilical Interpreter/Compiler
))




decimal

only forth also c-c also umbilical definitions

cr cr .( Loading Umbilical Interpreter/Compiler .... )






\ ?Ram ..................................           \  16/10/90
\

Hex

: ?Ram          \ addr -- addr t/f
  Rom?                                  \ ROM system ?
  If  the-label RAM-START @(s)l         \ yes, check RAM range
      over u> not                       \ RAM-START /> addr
      over the-equate EM @(s)l u> not   \ addr /> EM
      And                               \ Both conditions
      over 0100 u> not                  \ or in range 0..0FF
      Or
  Else  -1                              \ in RAM always
  Endif  ;                              \



\ @(r>h)                                           sfp 01/10/90
\

\ These will become the actions of @(r) and c@(r) for RAM space

: @(ur)         \ addr -- n
  data-page@
  @-cmnd>t >target  ;                   \ target executes own @


: C@(ur)        \ addr -- b
  data-page@
  C@-cmnd>t >target  ;                  \ target executes own C@




\ !(ur) c!(ur)                                     sfp 01/10/90
\

\ These will become the actions of @(r) and c@(r) for RAM space

: !(ur)         \ n addr --
  data-page@
  !-cmnd>t >target  ;                   \ target executes own !


: c!(ur)        \ b addr --
  data-page@
  C!-cmnd>t >target  ;                  \ target executes own C!




\ @(uc) c@(uc)                                   sfp 01/10/90
\

\ These will become the actions of @c and c@c for code space

: @(uc)         \ addr -- n
  code-page@
  @-cmnd>t >target  ;                   \ target executes own @


: C@(uc)        \ addr -- b
  code-page@
  C@-cmnd>t >target  ;                  \ target executes own C@




\ !(uc) c!(uc)                                     sfp 01/10/90
\

\ These will become the actions of !c and c!c for code space

: !(uc)         \ n addr --
  code-page@
  !-cmnd>t >target  ;                   \ target executes own !


: c!(uc)        \ b addr --
  code-page@
  C!-cmnd>t >target  ;                  \ target executes own C!





\ c,(ur) ,(ur)                                     sfp 01/10/90
\

\ These will become the actions of c,(r) and ,(r)

: c,(ur)        \ b -- ; in target RAM
  there(t) c!(ur)                     \ address to be used
  1 allot-ram  ;                      \ reserve space

: ,(ur)         \ n -- ; in target RAM
  there(t) !(ur)                      \ address to be used
  2 allot-ram  ;                      \ reserve space




\ @c(u) !c(u) .............................           \  16/10/90
\

\ These will become the actions of @(t) and !(t) for CODE space

: @c(u)          \ addr -- n
  ?ram  curr-code-page @(g) in-emulator? 0=  or              \ If RAM or no emulator
  If  @(uc)                           \ do it down link
  Else  emu-@(u)                      \ or use LeProm emulator
  Endif  ;                            \


: !c(u)          \ n addr --
  ?ram  curr-code-page @(g) in-emulator? 0=  or              \ If RAM or no emulator
  If  !(uc)                           \ target executes own !
  Else  emu-!(u)                      \ use LeProm emulator
  Endif  ;                            \




\ c!c(u) c@c(u) ...........................           \  16/10/90
\

: c!c(u)         \ c addr --
  ?ram  curr-code-page @(g) in-emulator? 0=  or              \ If RAM or no emulator
  If  c!(uc)                          \ target executes own c!
  Else  emu-c!(u)                     \ use LeProm emulator
  Endif  ;                            \


: c@c(u)         \ addr -- c ( On TARGET )
  ?ram  curr-code-page @(g) in-emulator? 0=  or              \ If RAM or no emulator
  If  c@(uc)                          \ do it down link
  Else  emu-c@(u)                     \ use LeProm emulator
  Endif  ;                            \



\ Copy-Bytes Copy-Page .......          sfp 03/10/90
\

: Copy-Bytes   ( dest-addr dest-page -- )
  cr ." Downloading " img.pcb .pcb
  ."  to page " dup .byte ." , offset " over .word  4 spaces
  img.pcb open-path-pcb abort" Can't open application "
  Begin
    image-buffer b/img img.pcb handle  read-path
    0<> abort" Error reading Image File"
    ?dup
   While
    ascii . emit                      \ reassure user
    >r
	2dup
	image-buffer -rot
	r>
	copy-cmnd>t >target
    swap b/img + swap
  Repeat
  2drop  img.pcb handle close-path drop  ;


: Copy-Page	( page# -- )
	dup data-page? not
	If
		>page-table
		dup page.name Img.Pcb set-pathname
		"" .IMG" Img.Pcb set-ext
		dup page.chunk @(g) o-i @(p)l
		swap page.id @(g)
		copy-bytes
	Endif  ;

	



\ Image>Target Image>Monitor ............           \  16/10/90
\

defer Image>Target

: Image>Monitor \ --
    Begin  ser-key?  While  byte-to-host drop  Repeat	\ clear serial comms.
	#Pages 0
	?Do
		i >page-table page.chunk @(g)
		If
			i copy-page
		Endif
	Loop  ;


assign Image>Monitor to-do Image>Target




\ error(u) ?value(s) umbilical-.log                 \  16/10/90
\

: error(u)              \ -- ; error handling
  disp-error                            \ display it
  only forth also c-c                   \ force host vocabs
  also umbilical definitions            \
  abort  ;                              \


: ?value(s)             \ symbol-addr -- value
  2dup resolved? ?undef                  \ check symbol exists
  @(s)l  ;                               \ get its value


: umbilical-.log        \ $addr addr --
  2drop  ;




\ ?sci ?scc .............................          sfp 06/04/89
\

: ?sci                                \ Special INTERPRETER
  sci context-find                    \
  IF  execute  r> drop  ENDIF         \
;                                     \
                                      \

: ?scc                                \ Special COMPILER
  scc context-find                    \
  IF  execute  r> drop  ENDIF         \
;                                     \



                                      \
\ ?target(u)                                        \  16/10/90
\

: ?target(u)    \ --
  cs> 'word find(t)                     \ Word exists ?
  IF  compil?                           \ yes, compiling?
      IF  compile-local-ref  compile-cc \ yes, lay CFA
      ELSE  2dup voc?                   \ is it a vocabulary
            If  is-voc(s)               \ yes, set vocab
            Else
			?token code-page@ target-exec		\ no, execute target CFA
            Endif                       \
      ENDIF                             \
      r> drop                           \ exit outer word
  ENDIF  ;                              \



\ ?equates(u)                                       \  16/10/90
\

((
: ?EQUATES(u)   \ -- ; identical to ?EQUATES
  cs> 'word 'Equates(s) 2@(g) voc-chunk+ @(s)l latest-chunk @(p)l v-find(s)
  IF  @(s)  COMPIL?                     \ yes, compiling ?
      IF  LITERAL  ENDIF                \ yes, lay literal
      R> DROP                           \ Leave outer word
  ELSE  DROP                            \ discard text addr
  ENDIF  ;                              \
))




\ ?labels                                           \  16/10/90
\

: ?LABELS(u)
  cs> 'word 'Labels(s) 2@(g) voc-chunk+ @(s)l latest-chunk @(p)l v-find(s)
  IF  ?value(s)  COMPIL?                \ compiling ?
      IF  literal  ENDIF
      R> DROP                           \ leave outer word
  ELSE  DROP                            \ discard text addr
  ENDIF  ;                              \



\ number                                           sfp 06/04/89
\

: Number        \ -- n | abort
  here number? ?undef  ;




\ ?Page-Target(u) .. J Lee -- 18/10/90
\


: ?Page-Target(u)	( -- c/v | NIL ; inter page )
	find(p)
	If
		2dup c/v? 		\ is it a c/v?
		If
			cell(s)+ 2@(s)l cell(s)+ @(s)l	\ ? De-Ref. c/v
		Else
			?token
			found-sym-page @(g) >page-table page.id @(g)
			target-exec
		Endif
		r> drop
	Endif  ;






\ Outer Interpreter ........................... J Lsfp 08/10/90
\

: INTERPRETING(u)
  ?SCI ?INTERPRETER ?TARGET(u) ?variables ?ASM-ACCESS
  ?EQUATES ?LABELS(u) ?page-target(u)  interp-number  ;

: COMPILING(u)
  ?SCC ?COMPILER ?ASM-ACCESS ?TARGET(u) ?variables 
  ?EQUATES ?LABELS(u) ?pages compile-number  ;

: ASSEMBLING(u)
  ?SCI ?INTERPRETER ?ASM-ACCESS ?TARGET(u)
  ?EQUATES ?LABELS(u) ?variables ?C-C  assemble-number  ;




\ interpret(u)  ............................... J L \  16/10/90
\

: interpret(u)          \ --
  BEGIN
    get-token c@
    WHILE  compil?
           IF   compiling(u)
           ELSE interp?
                if    interpreting(u)
                else  assembling(u)
                endif
           ENDIF
           ?STACK
  REPEAT  ;




\ Quit ........................................ J L \  16/10/90
\
                                      \
: Quit-emu                            \ --
  s0 @ sp!                            \ bullet proofing
  STATE(T) off(g)                     \ force interpretation
  blk off                             \ input from keyboard
  BEGIN                               \
    r0 @ rp!                          \ N.B. host return stack
    cr query interpret(u)             \ deal with line
    interp?                           \ see if prompt needed
    IF  prompt  ENDIF                 \
  AGAIN                               \
;                                     \




\ $from-emu                                         \  16/10/90
\

: $From-emu     \ first last $addr ---
  blk @ >r  >in @ >r  blk off
  get-stream next-file     	      \ open next file
  dup ?error pcr
  begin  next-line
    while  interpret(u)               \
  repeat                              \
  prev-file  dup ?error
  pcr ." Finished."
  r> >in !  r> dup blk !   \
  0=                                  \ keyboard?
  if  #tib off  >in off  endif  ;        \ yes; clear TIB




\ targ-prompt targ-sign-on                          \  16/10/90
\

: targ-prompt   \ -- ; prompt while Umbiiical Forth runs
  ."  ok"  depth ?dup
  if  ." -" .  endif
  space  ;


: targ-sign-on  \ -- ; target sign-on
  cls  cr cr                            \ pretties
  cr ." Umbilical Forth V3.00"          \ sign on
  cr .target                            \ say which target
  cr ." Copyright (C) 1990-1993 MicroProcessor Eng. Ltd."
  cr  decimal                           \ force base
\  cr ." Link Baud Rate: " b-rate @ u.   \ show baud rate
  cr ." BASE is now DECIMAL"            \ warn user
  cr cr cr ."   ok"  ;                \ makes it prettier




\ assign(u/t) assign(u/r)                          sfp 28/09/90
\


: assign(u/t)   \ -- ; assign drivers to xx(t)
\ use emu-xx(u) for Harvard (e.g. 8031), xx(u) for others
  assign c@c(u) to-do c@(t)  assign c!c(u) to-do c!(t)
  assign @c(u) to-do @(t)    assign !c(u) to-do !(t)
\  assign @c(u) to-do w@(t)   assign !c(u) to-do w!(t)
;


: assign(u/r)   \ -- assign RAM drivers to xx(r)
\ Only use following two for Harvard architectures
\ assign c@(ur) to-do c@(r)     assign c!(ur) to-do c!(r)
\ assign @(ur) to-do @(r)       assign !(ur) to-do !(r)
  assign c,(ur) to-do c,(r)     assign ,(ur) to-do ,(r)  ;


: assign(u/o)   \ -- ; assign output drivers for emulator
  assign emu-c@(u) to-do c@(o)  assign emu-c!(u) to-do c!(o)
  assign emu-@(u) to-do w@(o)   assign emu-!(u) to-do w!(o)  ;


: assign-forth(u)       \ -- ; set Forth handlers
  assign targ-prompt to-do prompt       \ reset host prompt
  assign umbilical-.log to-do .log	\ reset logging
  assign interpret(u) to-do interpret(t)  \ and interpreter
  assign quit-emu to-do quit
  assign error(u) to-do error
  assign (abort) to-do abort  ;




\ Reset-xc .................................... J L \  16/10/90
\

: Reset-xc      \ --
  no-log  internal                      \ no log, no heads
  assign(u/t)                           \ assign xx(t) drivers
  assign(u/r)                           \ assign xx(r) drivers
\ rp @(g) dp(t) !(p)                    \ set DP in RAM
\  here(s) cold-dp(s) !(g)
  assign-forth(u)  ;




\ cord ........................................ J L \  16/10/90
\

: cord          \ --
  reset-xc                              \ reset re-usable code
  targ-sign-on                          \
  quit-emu                             \ run interpreter
;



\ reset-target copy-image                           \  16/10/90
\

also c-c definitions

: reset-target  \ -- ; ask user to reset target
  cr cr ." Please reset target system, and then "
  cr    ." press <space> to run Umbilical Forth."
  Begin  key bl =  Until  ;


: copy-image    \ -- ; conditional copy of image to target
  Curr-code-page @(g) In-emulator? 0=
  if  cr cr ." Download files to target? (y/n) " y/n? cr
      If  image>target  Endif
  endif  ;

previous definitions




\ Umbilical-Forth ............................. J L \  16/10/90
\

also c-c definitions

: Umbilical-Forth       \ -- ; directive
  (finis)                             \ finish cross compilation
  release-files
  umbilical-mode  In-Umbilical On(g)  \ install XShell2 API
  only forth also c-c also umbilical  \ set search order
  cls reset-target                    \ ask user to do it
  ser-close  ser-open
  copy-image                          \ ask user if needed
  cord  ;                             \ run umbilical forth

previous definitions




\ more                                             sfp 02/07/90
\

: more          \ --
  begin  key?  while  key drop  repeat  \ flush input buffer
  cr ." Press <space> to continue "     \ ask for input
  key bl <> abort" ABORTED!"  ;         \ wait for it




\ (back) dump-buff                                  \  16/10/90
\

decimal

: (Back)        \ -- ; clear up from Umbilical
  assign .depth to-do prompt          \ reset host
  assign (quit) to-do quit            \
  assign (abort) to-do abort          \
  assign (error) to-do error          \
  only forth  also c-c                \ force search order
  also umbilical definitions  ;          \


variable dump-buff      \ -- addr ; buffer for DUMP
  16 allot
variable dump-page




\ Special INTERPRETER ......................... J Lsfp 04/10/90
\

only Forth also c-c also Umbilical also SCI definitions

: Back          cc/si                 \ -- ; host Forth system
  (back)                              \ clear up
  abort  ;                            \ normal Forth system




\ Words Opcodes                                     \  16/10/90
\

\ : Words         cc/si   \ --
\  words(s) cr  ;

: Opcodes       cc/si  \ --
  ASM-ACCESS words  ;




\ Help                                             sfp 03/10/90
\

: Help          cc/si   \ --
  Cr ." Opcodes and macros"
  Cr ." =================="
  ASM-ACCESS words  more
  Cr ." Special when Interpreting  "    \ Special Case
  Cr ." ========================="      \ Interpreter
  SCI words INTERPRETER words  more
  Cr ." Special when Compiling"         \ then Special Case
  Cr ." ======================"         \ Compiler
  COMPILER words
  Cr  ;




\ Include this screen for Harvard architectures    sfp 28/06/90
\


: @C	cc/si	\ address -- n
  code-page@ @-cmnd>t >target  ;

: C@C	cc/si	\ address -- b
  code-page@ c@-cmnd>t >target  ;

: !C	cc/si   \ b addr --
  code-page@ !-cmnd>t >target  ;

: C!C	cc/si   \ n addr --
  code-page@ c!-cmnd>t >target  ;


: @L	cc/si	\ address page -- n
  @-cmnd>t >target  ;

: C@L	cc/si	\ address page -- b
  c@-cmnd>t >target  ;

: !L	cc/si   \ n addr page --
  !-cmnd>t >target  ;

: C!L	cc/si   \ b addr page --
  c!-cmnd>t >target  ;


: @		cc/si	\ addr -- n
  [+asm-access] @ [previous]  ;

: C@	cc/si	\ addr -- b
  [+asm-access] C@ [previous]  ;

: !		cc/si	\ n addr --
  [+asm-access] ! [previous]  ;

: C! 	cc/si	\ n addr --
  [+asm-access] C! [previous]  ;



\ Special case INTERPRETER ..................... J sfp 01/10/90
\

: .             cc/si   \ n --
  .  ;


: u.            cc/si   \ n --
  u.  ;


: ?             cc/si   \ addr --
  data-page@ @-cmnd>t >target  .  ;




\ Special case INTERPRETER ..................... J sfp 04/04/89
\

decimal

: Hex           cc/si                 \ --
  16 base !  ;                        \
                                      \
: Decimal       cc/si                 \ --
  10 base !  ;                        \
                                      \
: Binary        cc/si                 \ --
  2 base !  ;                         \




\ Special case INTERPRETER cont. ................   \  16/10/90
\

((
: Bye           cc/si   \ -- ; leave system
  free-symbol-space
  ser-close  Bye  ;                      \ be kind to DOS
))

: Cls           cc/si   \ -- ; clear the screen
  cls  ;

: Cold          cc/si   \ --
\  cold-dp(s) @(g) (forget(s))
  targ-sign-on quit-emu  ;


: Words	cc/si	\ --
	words(s)  ;




\ Cdump                                            sfp 24/04/89
\

hex

((

: Cdump         cc/si   \ addr len -- ; dump CODE space
  t>pop2                                \ get data back
  BASE @ -rot  HEX  bounds              \ get limits
  DO  CR  i .WORD  i 010 bounds         \ print address
      do  space  i c@(t) .BYTE  loop    \ print byte
      2 SPACES  I 010 bounds            \ gap
      DO  I c@(t) .ASCII  LOOP          \ ascii o/p
      key? ?LEAVE                       \ quit or halt
  010 +LOOP                             \ until done
  BASE !  CR  ;                         \ restore base

))




\ dump                                             sfp 04/10/90
\

hex

: dump          cc/si   \ addr len -- ; dump DATA space
  [+asm-access] dpr@ [previous] dump-page !
  BASE @ -rot  HEX  bounds              \ get limits
  DO  CR dump-page @ 1 .r ." :" i .WORD \ print address
 	  i  010 0
      do  dup i + 					 \ form address
		 [+asm-access] c@ [previous]
          dup dump-buff i + c!          \ store it
          space .BYTE                   \ print byte
      loop                              \
      drop  2 SPACES  dump-buff 010 bounds    \ gap
      DO  I c@ .ASCII  LOOP             \ ascii o/p
      halt? ?leave                      \ quit or halt
  010 +LOOP                             \
  BASE !  CR  ;                         \ restore base
\ use lines below for Harvard architectures
\     do  dup i + c@(ur)                \ fetch byte


\ debug
: test-dump          cc/si   \ addr page len -- ; dump DATA space
\  [+asm-access] dpr@ [previous] dump-page !
swap dump-page !
  BASE @ -rot  HEX  bounds              \ get limits
  DO  CR dump-page @ 1 .r ." :" i .WORD \ print address
 	  i  010 0
      do  dup i + 					 \ form address
		  dump-page @ c@-cmnd>t >target
          dup dump-buff i + c!          \ store it
          space .BYTE                   \ print byte
      loop                              \
      drop  2 SPACES  dump-buff 010 bounds    \ gap
      DO  I c@ .ASCII  LOOP             \ ascii o/p
      halt? ?leave                      \ quit or halt
  010 +LOOP                             \
  BASE !  CR  ;                         \ restore base
\ use lines below for Harvard architectures
\     do  dup i + c@(ur)                \ fetch byte




\ latest                                           sfp 28/06/90
\

: LATEST        cc/si  \ --
  1 abort" No NAMEs on target"  ;




\ fill erase blank                                 sfp 28/06/90
\


((

;S      \ Use versions below for Harvard Architectures

: fill          cc/si   \ addr len char --
  t>pop1 t>pop1 t>pop1                  \ get three items back
  -rot swap fill(r)  ;                  \ reorder and fill
: erase         cc/si   \ addr len --
  t>pop2 0 fill(r)  ;
: blank         cc/si   \ addr len --
  t>pop2 bl fill(r)  ;

))




\ Special case INTERPRETER cont. ................  sfp 01/10/90
\

: All           cc/si   \ -- 1 -1 ; to target stack
  1 -1  ;

: Onwards       cc/si   \ n -- n -1 ; on target stack
  -1 ;

: Alone         cc/si   \ n -- n n
  dup  ;

: UpTo          cc/si   \ n -- 1 n
  1 swap  ;




\ .fth Use Qc  Using L N P QX .SCR List             \  16/10/90
\

: .FTH          cc/si  .fth  ;
: Use           cc/si  Use  ;
: QC            cc/si  QC  ;

: Using         cc/si  Using  ;
\ : L             cc/si  scr @ List  ;
\ : N             cc/si  scr @ 1+ List  ;
\ : P             cc/si  scr @ 1- List  ;
\ : QX            cc/si  Qx  ;
: .SCR          cc/si  .SCR  ;
\ : List          cc/si  List  ;




\ .s resync                                         \  16/10/90
\

: .S            cc/si  .s  ;

: resync        cc/si
  (back)
  reset-xc                              \ reset re-usable code
  targ-prompt                           \ fake it for user
  quit-emu  ;                           \ run interpreter




\ Dasm Dis .. J Lee -- 01/11/90
\


: Dasm  cc/i	( addr len -- )
	[dasm]  ;


: Dis  cc/i	( -- ; <name> )
	'(t) [dis]  ;




\ End of special case INTERPRETER                  sfp 03/04/89
\

only forth definitions
decimal


