((
	UMBFIX.FTH

	Fix KEY problems in RTX Umbilical Forth.
	Load this file on top of COMPCORE before re-building the compiler.

))


variable Key-Buffer		\ Buffer for key stroke
variable Key-Flag		\ flag whether buffer used, TRUE=Used
	

: (key)			\ -- char ; get a key via the master module
  (alt-key)			\ do the one in the master module
;

: (umb-key)		\ -- char ; maybe log the key press
  Key-Flag @			\ key in buffer?
  If
    Key-Buffer c@  Key-Flag off	\ get key sroke from buffer
  Else
    (key)			\ get key stroke from DOS
  Endif
  umb-i/p>log			\ perhaps log it
;

: (Umb-Key?)		\ -- t/f
  Key-Flag @ ?dup 0=		\ check key buffer first
  If
    drop (key?)			\ if no key in buffer, check DOS
  Endif
;

: Umb-UnGetCh		\ char -- ; put char back into key buffer
  Key-Buffer c!			\ put char in key buffer
  Key-Flag on			\ flag that char is there
;
 
: serial-key		\ -- char ; get a serial char
  begin
    key?			\ has a key been pressed?
    if				\
      key dup 02 =			\
      if			\
        drop abort		\ if so, abort if ^B
      else			\
        umb-ungetch		\ otherwise return to buffer
      endif			\
    endif			\
    ser-key?			\ carry on until serial char
  until				\
  ser-key			\ get serial char
;

: byte-to-host		\ -- char ; get a char for umbilical
  serial-key
;

: umbilical-io		\ -- ; maybe also log
  Key-Flag off                          \ no key available in buffer
  assign (umb-key) to-do key 		\ new loggable key
  assign (umb-key?) to-do key?          \
  assign (umb-emit) to-do emit		\ new loggable emit
  assign (umb-type) to-do type		\ new loggable type
;
