((

	XC-PRIMS.FTH

	J Lee :- 26/6/90

	MicroProcessor Engineering Ltd
	133/133a Hill Lane
	Southampton
	SO1 5AF

	tele:	(0703) 631441
	inter:	+44 703 631441


	This code performs primitive operations on the symbol table.

	All of the '(s)' memory operators use an implicit segment in their
	operation. This segment is know as the 'CURRENT-CHUNK' and can be found
	by inspecting the 'LATEST-CHUNK' of the 'DEFINITIONS(S)' vocabulary.

))



only Forth also c-c definitions
                                 

                        
\ Fill(s) .. J Lee -- 01/08/90
\


: Fill(s)	( addr len b -- )
	rot voc-seg@ swap 2swap fill(s)l  ;




\ Cmove(s) Cmove>(s) .. J Lee -- 02/07/90
\


: Cmove(s)	( source destination len -- )
	rot voc-seg@ swap 2swap cmove(s)l  ;



: Cmove>(s)	( source destination len -- )
	rot voc-seg@ swap 2swap cmove>(s)l  ;




\ !(s) @(s) c!(s) c@(s) 2!(s) 2@(s) .. J Lee -- 02/07/90
\


: !(s)	( n offset -- )
	voc-seg@ latest-chunk @(p)l swap !l  ;

 
: @(s)	( offset -- n )
	voc-seg@ latest-chunk @(p)l swap @l  ;


: c!(s)	( c offset -- )
	voc-seg@ latest-chunk @(p)l swap c!l  ;


: c@(s)	( offset -- c )
	voc-seg@ latest-chunk @(p)l swap c@l  ;


: 2!(s)	( d offset -- )
	voc-seg@ latest-chunk @(p)l swap 2!l  ;


: 2@(s)	( offset -- d )
	voc-seg@ latest-chunk @(p)l swap 2@l  ;




\ !(s)l @(s)l c!(s)l c@(s)l 2!(s)l 2@(s)l .. J Lee -- 02/07/90
\


: !(s)l	( n seg offset -- )
	!l  ;


: @(s)l	( seg offset -- n )
	@l  ;


: c!(s)l	( c seg offset -- )
	c!l  ;


: c@(s)l	( seg offset -- c )
	c@l  ;


: 2!(s)l	( d seg offset -- )
	2!l  ;


: 2@(s)l	( seg offset -- d )
	2@l  ;




\ Erase(s) Erase(s)l Blank(s) .. Jon 26/2/90
\


: Erase(s)	( start len -- )
  0 fill(s)  ;


: Erase(s)l	( seg start len )
  0 fill(s)l  ;


: Blank(s)	( start len -- )
  bl fill(s)  ;




\ On(s) Off(s) +!(s) .. J Lee -- 26/6/90
\


: On(s)	( offset -- )
    -1 swap !(s)  ;


: Off(s)	( offset -- )
    0 swap !(s)  ;


: +!(s)	( n offset -- )
    dup c@(s)  rot +  swap c!(s)  ;




\ Count(s) Type(s) Count(s)l Type(s)l Set-Bit(s) .. J Lee -- 26/6/90
\


: Count(s)	( $offset -- offset len )
  dup 1+  swap c@(s)  ;


: Type(s)	( offset n -- )
  0
  ?Do
	dup c@(s) emit  1+
  Loop
  drop  ;


: Count(s)l	( seg $offset -- seg offset len )
  2dup c@(s)l  swap 1+ swap  ;


: Type(s)l	( seg offset n -- )
  0
  ?Do
	2dup c@(s)l emit  1+
  Loop
  2drop  ;


: Set-Bit(s)	( n seg offset -- )
	2dup c@(s)l
	>r rot r>  or
	-rot c!(s)l  ;


