((

	XDTC50-3

	MPE Forth Cross Compiler v5.00

	J Lee - 9/7/90


	Copyright (C) 1983-1991

	MicroProcessor Engineering
	133 Hill Lane
	Southampton
	SO1 5AF
	England

	tel: (+44) 703 631441   (international)
	tel: 0703-631441        (domestic)

))




\ .symbol-space .. sfp 12/01/90
\


: .Curr-File	( -- )
	." Using " .scr  ;


: NccAbort	( -- )
	ncclogo  interpret
	.curr-file cr
	only Forth definitions  ;




\ latest(t) is-voc(s) .. sfp 15/08/88
\


only forth also c-c definitions


: Latest(t)	(( -- addr(t) ))
	last(t) @(g)  ;


: Is-Voc(s)	( voc-addr -- )
	Context(s) 2!(p)  ;




\ Sc/c(s) Rc/c(s) .. Jon 05/01/89
\

global-var save-env-page		\ temporary old page holder


: Sc/c(s)-Page	( -- ; save current page )
	curr-page@ save-env-page !(g)  ;


: Sc/c(s)	( -- )
	Context(s) 2@(p) Cont(s) 2!(g)	\ save symbol vocabulary
	Current(s) 2@(p) Curr(s) 2!(g)  ;	\ environment


: Rc/c(s)	( -- )
	Cont(s) 2@(g) Context(s) 2!(p)		\ restore symbol
	Curr(s) 2@(g) set-definitions(s)   	\ vocabulary environment
	save-env-page @(g) curr-page!			\ restore current page
	current(s) 2@(p) voc-chunk+ @(s)l voc-seg!  ;	\ reset page voc-seg




\ Compil? Interp? .. sfp 21/09/89
\


: Compil?	( -- t/f )
	State(t) @(g) 1 =  ;


: Interp?	( -- t/f )
	State(t) @(g) 0=  ;


: Assembl?	( -- t/f )
	State(t) @(g) 2 =  ;


: ?b-d	( -- t/f ; if CC is compiling and between CREATE .. DOES> )
	compil?  state @ 0<>  and  ;





\ Printing  .. sfp 21/02/90
\


hex

	cr cr	.( Loading Form Handlers ....... )
	cr


: Eject	( -- )
	0c emit  ;


: Title	( -- )
	cr 3 spaces .version
	cr 3 spaces .target
	cr 3 spaces .symbol-space
	cr cr 5 #Lines !(g)  ;


: New-Page	( -- )
	eject title
	#Logged off(g)  ;


: Page	( -- )
	#Lines @(g)
	If
		#Lines @(g) L/P 1- >
		If
			new-page
		Else
			1 #Lines +!(g)
		Endif
	Else
		new-page
	Endif  ;


: Pcr	( -- )
	cr page
	#Logged off(g)  ;


: 6U.r	( n -- )
	Base @  hex
	swap 0 6 d.r	\ force to positive 32-bit number
	Base !  ;




\ Save/Restore Context .. Jon 09/08/88
\


hex

	cr cr	.( Loading Error redefinitions ... )
	cr



: SC/C	( -- ; save CURRENT and CONTEXT, and go to the root FORTH )
	Current @ Curr !(g)
	Context @ Cont !(g)
	Forth definitions  ;


: RC/C	( -- ;restore saved environment )
	Curr @(g) Current !
	Cont @(g) Context !  ;




\ Error redefinitions ..  sfp 09/12/89
\


hex


: ?Exec	( -- ; conditionally print error message )
	interp? not  012 ?error  ;


: ?Comp	( -- )
	Compil? not  011 ?error  ;


: Min-1	( -- ; error if stack depth less than one item )
	depth 1 <   1 ?error  ;		\ stack depth check


: ?In-Root	( -- ; error if string at HERE is not defined in host FORTH )
\	here [ ' forth >body ] literal  v-find	\ ModForth2 version
	here [ ' forth ] literal  v-find	\ ModForth3 version
	?dup 0= 01C ?error  ;


: ?Undef	( n -- )
	0= 0 ?error  ;




\ Pseudo operations ..  Jon 30/01/89
\


hex

	cr cr	.( Loading Pseudo ops .......... )
	cr


: Target-Width	( width -- )
	the-equate HEADS? @(s)l
	If
		Width(t) !(g)
	Else
		drop
	Endif  ;


: Internal	 ( -- )
	0 target-width  ;


: External	 ( -- )
	01F target-width  ;


: No-Heads	( -- )
	0 target-width
	0 the-equate HEADS? !(s)l  ;


: Bounding	( prom-size mask min-space leading-offset -- )
	Prom-Offset !(g)  min-space !(g)
	swap  Prom-Size !(g)
	Dp(T) @(p) and  Prom-Size @(g) +  Next-Prom !(g)
	?bounding on(g)  ;


: ?Rom-End	( -- ; check for end of ROM )
	Dp(t) @(p)
	curr-page@ >page-table dup page.start @(g)  swap page.end @(g) uwithin? not
	If
		cr	cr ." ***********************************************"
			cr ."  WARNING: Dictionary extended beyond ROM / Page"
			cr ." ***********************************************"
		cr
	Endif  ;




\ Pseudo operations .. sfp 20/01/90
\


hex


: Initialised-Ram	( #bytes -- )
  dup #bytes>#paras alloc-mem                   \ grab memory fro RAM table
  abort" Can't grab RAM table memory"           \ abort on error
  2dup 0 rot 0 fill(s)l                          \ zero RAM table memory
  Ram-Area !(g)                                 \ set RAM table pointer
  Ram-Size !(g)                                 \ set max size (#bytes)
  Curr-Ram-Size off(g)  ;                       \ set curr-size of RAN table


: Free-Init-Ram  ( -- ; free RAM table )
  kernel-ram-page @(g)
  If
    Ram-Area @(g) free-mem
    If  ." Can't free RAM table"  bye  Endif
  Endif  ;


: Ram-Base	( addr -- )
	dup curr-page@ >page-table page.rp !(g)
	the-label RAM-START 2dup status+ mark-resolved !(s)l
	?Rom on(g)  ;


: Rom-Target	( -- ; inform compiler to generate a ROM target )
	?Rom on(g)  ;


: Mem-End	( addr -- )
	the-equate EM !(s)l  ;


: Ram-End	( addr -- )
	mem-end  ;

: Rom?	( -- t/f ; ROM/RAM system check )
	?Rom @(g)  ;




\ Pseudo operations .. sfp 27/02/89
\


hex

: Org	( addr -- )
	Dp(t) !(p)  ;


: DOrg	( addr -- ; as ORg but for THERE in a Data Page )
	with-data
	curr-page@ >page-table page.rp !(g)
	with-code  ;


: Mem-Base	( addr -- )
	dup Dp(t) !(p)  dup O-I !(p)
	the-label ORIGIN 2dup status+ mark-resolved !(s)l
	Emulator-Out @(g) 0=
	If
		img.pcb i.open abort" Can't open KERNEL file"
	Endif  ;


: Rom/Ram	( -- )
	?Rom on(g)  ;


: ><	( b1b2 -- b2b1 )
	0100 um* or  ;




\ Pseudo-ops -- Aligning .. sfp 27/02/89
\


: Align	( -- ; align CFAs to even boundaries )
	2 ?Aligning !(g)  ;


: Align-Even	( -- ; align CFAs to even boundaries )
	2 ?aligning !(g)  ;


: Align-Odd	( -- ; align CFAs to odd boundaries )
	1 ?aligning !(g)  ;


: No-Align	( -- ; turn alignment off )
	0 ?aligning !(g)  ;




\ Memory reference .. sfp 20/01/90
\


hex

	cr cr	.( Loading Memory referencing .. )
	cr


: Here(t)	( -- addr )
	Dp(t) @(p)  ;


: There(t)	( -- addr )
        with-data
	curr-page@ >page-table page.rp @(g)
        with-code  ;


: Allot-Ram  ( n -- ; allot n bytes in RAM table )
  with-data
  dup curr-page@ >page-table page.rp +!(g)      \ force Page table pointer
  Curr-Ram-Size +!(g)                           \ update RAM table pointer
  with-code
  kernel-ram-page @(g)  curr-data-page @(g)  =
  If
    Curr-Ram-Size @(g)  Ram-Size @(g)  u>  $1a ?error   \ check for overflow
  Endif  ;

: ?Inram	( addr1 -- addr2 t/f )
	?Rom @(g)
	If
		dup the-label RAM-START @(s)l  u< not
		If
			dup the-label RAM-START @(s)l Ram-Size @(g) + u<
			If
				the-label RAM-START @(s)l - 1
			Else
				0
			Endif
		Else
			0
		Endif
	Else
		0
	Endif  ;




\ Memory reference .. sfp 21/02/90
\



: D-Addr	( address -- offset block# ; converts target address to file )
	O-I @(p) - 0 B/IMG um/mod
	SB# @(g) +  ;


: C!(d)	( b -- )
	D-Addr i.blk + c!
	i.upd  ;


: C@(d)	( -- b )
	D-Addr i.blk + c@  ;


defer c!(o)     assign C!(D) to-do C!(O)
defer c@(o)     assign C@(D) to-do C@(O)




\ Memory Reference .. sfp 20/01/90
\


: (C@(t))	( addr -- b )
	?inram
	If
		Ram-Area @(g) swap c@l
	Else
		c@(o)
	Endif  ;


: (C!(t))	( b addr -- )
	?inram
	If
		Ram-Area @(g) swap c!l
	Else
		c!(o)
	Endif  ;


defer c@(t)     assign (C@(T)) to-do C@(T)
defer c!(t)     assign (C!(T)) to-do C!(T)

defer w@(o)
defer w!(o)




\ Memory Reference .. J Lee -- 09/10/90
\

variable Split-Buffer

: !(d)	( n addr -- )
	swap Split-Buffer !		\ save data word
	d-addr i.blk + >r		\ get address in buffer
	Split-Buffer 1+ c@ r@ c!	\ stash high byte
	Split-Buffer c@ r> 1+ c!	\ stash low byte
	i.upd  ;				\ update block buffer


: @(d)	( addr -- n )
	d-addr i.blk +			\ form buffer address
	dup c@ Split-Buffer 1+ c!	\ get high byte
	1+ c@ Split-Buffer c!		\ get low byte
	Split-Buffer @  ;			\ get word


defer @(o)		assign @(d) to-do @(o)
defer !(o)		assign !(d) to-do !(o)




\ Memory Reference .. J Lee -- 09/10/90
\


: !(r)	( n addr -- )
	swap >< swap Ram-Area @(g) swap !l  ;


: @(r)	( addr -- n )
	Ram-Area @(g) swap @l ><  ;


: c!(r)	( b addr -- )
	Ram-Area @(g) swap c!l  ;


: c@(r)	( addr -- b )
	Ram-Area @(g) swap c@l  ;


: (!(t))	( n addr -- )
	?inram
	If
		!(r)
	Else
		!(o)
	Endif  ;


: (@(t))	( addr -- n )
	?inram
	If
		@(r)
	Else
		@(o)
	Endif  ;


defer @(t)		assign (@(t)) to-do @(t)
defer !(t)		assign (!(t)) to-do !(t)

3 Constant Float-cells			\ size of float in cells
Float-cells cell * Constant Float-bytes \ size of float in bytes

: F!		\ float addr -- ; stores float at addr
\  ?inram 				\
\  If					\
    Float-cells 0			\ store three integers
    do					\
      >r				\ save address
      >< Ram-Area @(g) r@ !l		\
      r> cell+				\ restore address
    loop				\
    drop				\
\  Endif 				\
;


: F@		\ addr -- float ; return float at addr
\  ?inram				\
\  If					\
    Float-bytes	+ cell-			\ move to high word
    Float-cells 0			\ store three integers
    do					\
      >r				\ save address
      Ram-Area @(g) r@ @l ><		\
      r> cell-				\ restore address
    loop				\
    drop				\
\  Else					\
\    w!(o)				\
\  Endif 				\
;






\ Memory Reference .. J Lee -- 09/10/90
\


: +!(t)	( n addr -- )
	dup >r @(t) + r> !(t)  ;


: ,(t)	( n -- )
	width(t) @(g) 0=  ?b-d  and
	If
		drop
	Else
		here(t) !(t)
		2 dp(t) +!(p)
	Endif  ;


: c,(t)	( b -- )
	width(t) @(g) 0=  ?b-d  and
	If
		drop
	Else
		here(t) c!(t)
		1 dp(t) +!(p)
	Endif  ;




\ Memory reference .. sfp 14/04/89
\


hex

((
: Ita	( -- addr1 ; fetches 1st free address in initialisation table )
	Ram-Area @(g)  dup @  dup cell+  Ram-Size @(g)  u< 0=
	01a ?error
	+ cell+  ;
))


: Ita  ( -- seg adr ; returns 1st free space in init. RAM table )
  Ram-Area @(g) Curr-Ram-Size @(g)  ;


: (,(r))	( n -- )
	>< ita !l
	2 allot-ram  ;


: (C,(r))	( b -- )
	ita c!l
	1 allot-ram  ;


defer ,(r)	assign (,(r)) to-do ,(r)
defer c,(r)	assign (c,(r)) to-do c,(r)




