((

	XDTC50-4

	MPE Forth Cross Compiler v5.00

	J Lee - 9/7/90


	Copyright (C) 1983-1991

	MicroProcessor Engineering
	133 Hill Lane
	Southampton
	SO1 5AF
	England

	tel: (+44) 703 631441   (international)
	tel: 0703-631441        (domestic)

))




\ Memory reference .. sfp 24/04/89
\


: Cmove(t)	( addr1 addr2 len -- )
	?dup							\ if something
	If
		0
		Do
			over c@(t)
			over c!(t)			\ copy a byte
			swap 1+  swap 1+		\ step on
		Loop						\ till done
	Endif
	2drop  ;						\ lose addresses


: Fill(t)	( addr len -- )
	-rot  bounds
	?Do
		dup i c!(t)
	Loop
	drop  ;


: Erase(t)	( addr len -- )
  0 fill(t)  ;




\ Ref! ********************************* .. sfp 21/09/89
\


Only Forth Also C-C Definitions

hex

: Forward-Error	( -- )
	?b-d 01B ?error  ;

decimal

: Forward-Warn	( -- )
	in-umbilical @(g)
	If
		pcr ." WARNING: " here count type
		."  is a forward reference." pcr
	Endif  ;


: Ref!	(( Symbol-Ref-Field(d) -- value ))
	forward-warn
	Latest-Chunk @(v) here(s)  2over 2@(s)l 2,(s)	\ Ref-Packet
	dup >r				\ preserve HERE(S)
	2swap 2!(s)l
	assembl?
	If
		save-env-page @(g) curr-page!	\ get correct DP(T) for page
		here(t)
		0 curr-page!				\ back to labels page
	Else
		here(t)
	Endif
	,(s)
	r>					\ restore HERE(S)
	assembl? not
 	If  0  Else  1  Endif
	,(s)						\ 0=CFA, 1=label
	Assembl?
	If
		dup Ref1 @(g)
		If
			Ref2 dup @(g)
			If  cr ." Too many references at " Here(t) u. space Endif
			latest-chunk @(v) ref2-seg !(g)
		Else
			Ref1
			latest-chunk @(v) ref1-seg !(g)
		Endif
		!(g)
	Endif
	1 #forward +!(g)  ;




\ (Ref) Ref Run-Time-Ref Compile-Ref .. sfp 21/02/90
\


: (Ref)	(( symbol-addr(d) t/f -- sym-value ))
	If
		@(s)l 
	Else
		cell(s)+ ref!
	Endif  ;


: Ref	(( sym-addr(d) -- value ))
	2dup resolved? (ref)  ;		\ Only used for normal


: Ref-Label	(( sym-addr(d) -- value ; used for references to labels only ))
	state(t) @(g) >r		\ preserve target state
	2 state(t) !(g)		\ force 'assembler' mode
	ref					\ use normal reference
	r> state(t) !(g)  ;		\ restore target state


: Run-Time-Ref	(( r-t-sym-addr(d) -- value ))
	2dup 3 cells(s)- run-time?  (ref)  ;


\ This word is only needed because COMPILE-REF will only compile short calls,
\ even if an inter-page call is made ( (.") for example )
: ?Page-Call	( -- ; compile interpreage reference if needed )
	curr-page@ >page-table page.id @(g)	\ Init. syms MUST be in page 0
	If
		0 literal(a) [+asm-access] cpr! [previous]	\ page 0 call
	Endif  ;		
	

: (Compile-Ref)	(( symbol-addr(d) t/f -- ))
	dup >r		\ preserve flag, 0 for forward reference
	(ref) >>1 				\ produce call instruction
	r>
	If
		break-opt
	Else
		\\
	Endif
	,code  ;					\ compile value


: Compile-Ref	(( sym-addr(d) -- ))
	width(t) @(g) 0=  ?b-d  and
	If
		2drop
	Else
		2dup resolved?
		dup 
		If
			?page-call
		Endif
		(compile-ref)
	Endif  ;


: Compile-Local-Ref	(( symbol-addr(d) -- ))
	width(t) @(g) 0=  ?b-d  and
	If
		2drop
	Else
		2dup resolved? (compile-ref)
	Endif  ;


: Compile-Run-Time-Ref	(( sym-addr(d) -- ))
	3 cells(s)+ run-time-ref >ca(t) ,(t) \\  ;




\ Memory reference .. Jon 09/08/88
\


decimal

: Context-Find	( addr t | f -- ; find in CONTEXT voc using text at HERE )
	here context @ v-find  dup 0=
	If  nip  Endif  ;


create word-buffer		64 allot

: Bl-Word-Up	( -- ; copy next text string to HERE and safety )
	get-token word-buffer over c@ 1+ cmove  ;


: Word-Down	( -- ; move previously saved string to HERE )
	word-buffer here  over c@ 1+ cmove  ;


\ Memory reference .. Jon 09/08/88
\


: Cmove,(t)	( addr n -- )
	bounds
	?Do
		i c@ c,(t)
	Loop  ;


: Allot(t)	( n -- )
	dp(t) +!(p)  ;





\ Memory reference .. sfp 25/03/87
\


: Toggle(t)	( addr b -- )
	over c@(t) xor swap c!(t)  ;


: Word(t)	( -- ; accepts word from input, to host and target )
	word  c@ 1+  0
	Do
		here i + c@
		here(t) i + c!(t)
	Loop
	here(t)  ;





\ Memory reference .. Jon 10/01/89
\

((
: ?Bound
	?bounding @(g)
	If
		next-prom @(g) here(t) u<
		If
			Prom-Size @(g) Next-Prom +!(g)
		Endif
		Next-Prom @(g) here(t) -  Min-Space @(g) u<
		If
			Base @  hex
			Begin
				console  cr ." Target DP = "  here(t) u.
				."  -- Step to next PROM ? "  y/n? dup
				If
					Next-Prom @(g) Prom-Offset @(g) + Dp(t) !(p)
					Prom-Size @(g) Next-Prom +!(g)
				Endif
				set-log-mode	\ restore printer mode
				0=
			Until
			Base !
		Endif
	Endif  ;
))



\ Memory reference .. sfp 27/02/89
\


: ?Force-Even	( b -- ; force even memory address if required )
	here(t) 1 and  ?aligning @(g) 0<>  and
	If
		c,(t)
	Else
		drop
	Endif  ;


: ?Force-Align	( -- )
	Case  ?aligning @(g)
		1	of  here(t) 1 and 0=
				If  bl c,(t)  Endif
			Endof
		2	of  here(t) 1 and
				If  bl c,(t)  Endif
			Endof
	Endcase  ;



: ?Bl-Even	( -- ; insert character as required )
      bl ?force-even  ;


: ?0-Even	( -- )
	0  ?force-even  ;


\ Printing .. Jon 09/08/88
\


hex

	cr cr	.( Loading Printing words ...... )
	cr


: ?None	( -- )
	All-Res @(g)
	If
		."    None "  pcr
	Else
		All-Res on(g)
	Endif  ;




\ Printing .. Jon 10/08/88
\


decimal

: (.Log)	(( $addr addr sym(d) -- ))
	?Log @(g)
	If
		#Logged @(g)  Log/Line =
		If	pcr	Endif
		2swap		\ -- sym(d) $addr addr
		space  6u.r  space  count type  space	\ display addr and $addr
		>name(s) count(s)l 31 and
		Width @  Log-Width  min min
		Log-Width over - >r
		type(s)l  r> spaces
		1 #Logged +!(g)
	Else
		." ."  out @ 50 >=
		If	pcr	Endif
		2drop 2drop
	Endif  ;


: Compiler-.Log	( $addr addr -- )
	'Latest(s) 2@(v)  (.Log)  ;


defer .Log	assign Compiler-.Log to-do .Log





\ Printing .. sfp 15/08/88
\


decimal

: .Unres	(( sym-nfa(d) fwd-ref-fld(d) -- ))
	2@(s)l 2dup or					\ any forward refs?
	If
		All-Res off(g)				\ yes, clear flag
		pcr 2 spaces 2swap .name(s)	\ display name
		Begin
			35 out @ - spaces ##S 0	\ tab it
			Do
				2dup dcell(s)+ @(s)l 6u.r space	\ show address
				2@(s)l 2dup or 0= ?leave			\ see if at end
			Loop
			pcr
			2dup or 0=   halt?  or
		Until
		2drop
	Else
		2drop 2drop
	Endif  ;




\ Printing .. sfp 15/08/88
\


: ?Unres	(( voc(s)(d) -- ))
	Voc-Chunk+ @(s)l
	Begin
		Chunk-Threads  #Threads(s) cell(s)* bounds
		Do
			dup i						\ for each thread
			Begin
				@(s)l ?dup					\ -- nfa [nfa]
			While
				2dup name>(s) cell(s)+			\ -- nfa nfa addr(s)
				2dup resolved?					\ symbol defined ?
				If
					2drop					\ yes, chuck data
				Else
					2over 2swap
					cell(s)+ .unres			\ no, show words
				Endif
				over swap n>link(s)				\ switch to link
			Repeat
			cell(s)
		+Loop
		>Chunk-Link @(s)l  dup 0=				\ get next chunk
	Until
	drop  ;




\ Printing .. sfp 15/08/88
\


: ."Unres"	( -- )
	pcr ." Unresolved "  ;


: ?Link	(( symbol(d) -- ))
	2dup >name(s)
	2swap 4 cells(s)+
	.unres  ;


: ?Cfas	( -- )
	."unres"  ." ;CODE pointers "  pcr
	target : ?link
	target CONSTANT ?link
	target VARIABLE ?link
	target USER ?link
	target DOES> ?link
	?none  ;


: ?Does>	( -- )
	."unres"  ." DOES> pointers "  pcr
	target VOCABULARY ?link
	?none  ;



		   
\ Printing .. Jon 10/08/88
\


: ?Labs	( -- ; show unresolved labels )
	."unres"  ." labels "  pcr
	'Labels(s) 2@(g) ?unres  ?none  ;


: Voc-Links	(( -- 0(d) vl1 vl2 .... ; get all voc-links ))
	0 0  <Voc-Link(s) 2@(p)		\ and first
	Begin
		2dup or 0<>			\ while they exist
	While
		2dup 2@(s)l			\ stack and get next one
	Repeat
	2drop  ;




\ Printing .. sfp 14/04/89
\


: .Voc	(( voc-link(d) -- ; show unresolved in voc ))
	<voc-link(s)-						\ voc-link to voc
	." in "  2dup >name(s) .name(s) pcr	\ display voc name
	?unres ?none  ;					\ set vocab, find unres


: ?Vocs	(( 0(d) vl1(d) vl2(d) .... -- ; show all unres ))
	Begin
		2dup	or 0<>	\ while vocs exist
	While
		.voc			\ check them
	Repeat
	2drop  ;

 


\ Printing .. sfp 15/08/88
\


: ?Words	( -- )
	."unres"  ." words " pcr
	voc-links					\ extract all vocs
	?vocs  ;					\ show language vocs


: ?Resolve	( -- )
	pcr  All-Res on(g)
	?cfas ?does> ?labs ?words  ;


