((

	XDTC50-5

	MPE Forth Cross Compiler v5.00

	J Lee - 9/7/90


	Copyright (C) 1983-1991

	MicroProcessor Engineering
	133 Hill Lane
	Southampton
	SO1 5AF
	England

	tel: (+44) 703 631441   (international)
	tel: 0703-631441        (domestic)

))


2 Constant Single-code			\ code of variable in bytes
4 Constant Double-code			\ code of Double variable in bytes
6 Constant Float-code			\ code of Fvariable in bytes
8 Constant Farray-code			\ code of Farray in bytes

\ Close-Image Error-Exit XC-Error .. sfp 21/02/90
\

Only Forth Also C-C Definitions

: ndup		\ n1 ... nn n -- n1 ... nn n1 ... nn
  Dup 0					\ Take each number
  ?Do					\
    Dup pick Swap			\ put on top
  Loop					\
  Drop					\
;

: .Text-file            \ -- ;
  $15 op-handle @ ioctl drop            \
;

: $Fnumber?		\ a -- 0 | n1 1 | n1 n2 2 | n1 n2 n3 3
  dup count upper			\ convert to upper case
  cs> swap				\ make into long address
  base @ ($Fnumber?)			\ call public word
;

: floats                                \ -- ; allow f.p. input
  assign $fnumber? to-do number?  ;     \ switch in fnumber?
  public
  

\ Close-Image Error-Exit XC-Error .. sfp 21/02/90
\


Only Forth Also C-C Definitions


: Close-Image	( -- ; close image, whether emulator or file )
((	Emulator-Out @(g)
	If
		close-emulator
	Else
		close-disk
	Endif
))
((
	emulator?
        If  close-emulator  Endif	\ shut down emulator if needed
))
        curr-code-page @(g) in-emulator?    \ writing a file or emulator
        If  close-emulator  else  close-disk  Endif
  ;


: Free-Compiler-Mem  ( -- ; free all external compiler memory )
        release-files
        free-init-ram
        free-symbol-space  ;


: Error-Exit	( -- )
        free-compiler-mem               \ release compiler memory
	bye  ;				\ leave


\ action of ABORT
: Abort-Exit  ( -- )
        assign bye to-do abort          \ avoid recursive errors
        close-log
((	emulator?
        If  close-emulator  Endif	\ shut down emulator if needed
        curr-code-page @(g) in-emulator? 0=     \ writing a file?
        If  close-image  Endif
))
	close-image			\ shut down output
        error-exit  ;


: XC-Error	( error# -- )
	disp-error	\ show error
	.where		\ show error position
	close-log		\ close log & >screen
	close-image
	Error-Exit  ;



\ Abort-Compilation .. sfp 21/02/90
\


: Abort-Compilation	( -- )
	close-log
((
        emulator?
        If  close-emulator  Endif       \ shut down emulator
        curr-code-page @(g) in-emulator? 0=     \ writing a file?
        If  close-image  Endif
))
	close-image
	cr cr
	cr ." *****************************"
	cr ."       USER INTERVENTION      "
	cr ."   CROSS COMPILING ABANDONED  "
	cr ." *****************************"
	only Forth definitions
	Error-Exit  ;




\ Abandon .. sfp 21/02/90
\


decimal

: Abandon	( -- )
  key?					\ user pressed a key ?
  If					\ yes,
    key 3 =				\  was it a control-C ?
    If					\  yes,
        abort-compilation	\    give up the ghost ...
    Else					\  no,
        key drop			\    wait for user
    Endif
  Endif  ;




\ mrk-jmp< mrk-jmp> insert-mrk-jmp> >page# this .. J Lee -- 09/10/90
\

hex

: mrk-jmp<	( -- addr )
	here(t)  ;


: mrk-jmp>	( -- addr )
	here(t) 2-  ;


: Insert-Mrk-Jmp>  ( .. 3 .. -- .. a 3 .. )
	0				\ add a forward branch
	Begin
		over 3 <>		\ to be resolved to the
	While
		1+ swap >r	\ list of leaving addrs
	Repeat			\ associated with the
	mrk-jmp> rot rot		\ most recent Do loop.
	Begin
		dup
	While
		r> swap 1-
	Repeat
	drop  ;


: >Page#	( a -- a' )
	0FC00 and  ;


: This	( a -- a1 a2 )
	here(t) >page#  ;


: This+1	( a1 -- a1 a2 )
	here(t) >page# 0400 +  ;


: This-1	( a1 -- a1 a2 )
	here(t) >page# 0400 -  ;


: Page?	( a1 a2 -- a1 t/f )
	over =  ;


: Odd?	( a -- t/f )
	1 and 0<>  ;




\ <Res-Jmp >Res-Jmp Resolving-Jmps> .. Jon 12/08/91
\

hex

: <Res-Jmp	( addr< -- )
	dup odd? 22 ?error					\ -- addr<
	CASE  dup >page#					\ -- addr< page<
		0 page?					?OF  drop 0400  ENDOF
		here(t) >page# page?		?OF  drop 0000  ENDOF
		here(t) >page# 0400 - page?	?OF  drop 0600  ENDOF
				021 error
	ENDCASE
	swap 03FF and 2/ or
	here(t) 2- @(t) or here(t) 2- !(t)  ;


: >Res-Jmp	( addr -- )
	here(t) odd? 22 ?error
	CASE  dup 2+ >page#                 \ -- addr page
		this 0 =      ?OF  drop 0400  ENDOF
		this page?    ?OF  drop 0000  ENDOF
		this-1 page?  ?OF  drop 0200  ENDOF
                      021 ?error
	ENDCASE
	here(t) 03FF and 2/ or              \ -- addr> >addr'
	over @(t) or swap !(t)  ;


: Resolving-Jmps>	( 0 a1 .. an -- )
	Begin
		?dup
	While
		>res-Jmp
	Repeat  ;




\ mark< mark> >resolve resolving .. Jon 08/12/88
\

hex

: Mark<	( -- addr )
	here(t)  ;


: Mark>	( -- addr )
	here(t) 0 ,(t)  ;


: >Resolve	( addr -- )
	here(t) swap !(t)  ;


: Resolving	( 0 a1 .. an -- )
	Begin
		?dup
	While
		>resolve
	Repeat  ;



\ Resolve .. Jon 12/07/89
\

hex

: (Resolve)	(( n fwd-ref(d) symbol(d) -- ))
\ debug @(g) If  cr ." RESOLVING: " 2dup >name(s) .name(s) cr  Endif
	status+ mark-resolved	\ mark symbol as resolved
	3dup !(s)l			\ set target addr in symbol
	cell(s)+ 2dup 2@(s)l	\ fetch next forward reference packet
	0 0 2rot 2!(s)l		\ set ^forward reference as resolved
	rot >r				\ stach symbol value
	Begin
		2dup or 0<>
	While
		2dup dcell(s)+  2dup @(s)l
		r@ swap 2swap cell(s)+ @(s)l
		Case                		\ label-addr reference-location mode
			assembl?
			If				\ fix for labels page
				save-env-page @(g) curr-page!
			Endif
			0 Of  swap >>1 swap !(t)  Endof   \ 0 : convert to CALL
			1 Of  !(t)                Endof   \ 1 : ABSOLUTE address
				02d error
		Endcase
		assembl?
		If				\ fix for labels page
			0 curr-page!
		Endif
		2@(s)l
	Repeat
	2drop r> drop  ;




\ Resolve Resolve-Def-Word .. Jon 17/11/88
\

: Resolve	(( n addr(d) -- ))
	2dup (resolve)  ;                    \ go resolve symbol


: Resolve-Def-Word	(( n addr(d) -- ))
	2dup status+ mark-run-time           \ mark run time defined
	2dup 3 cells(s)+ 2swap               \ target addr field
	(resolve)  ;                         \ go resolve symbol




\ Forward references                               Jon 07/12/88
\

: Insert>Mark	( .. 3 .. -- .. a 3 .. )
	0				\ add a forward branch
	Begin
		over 3 <>		\ to be resolved to the
	While
		1+ swap >r	\ list of leaving addrs
	Repeat			\ associated with the
	mark> rot rot		\ most recent Do loop.
	Begin
		dup
	While
		r> swap 1-
	Repeat
	drop  ;




\ Forward references .. sfp 24/03/87
\


: ?BD-Literal	( n -- ; compile into C-C if in <builds ... does> )
	?b-d
	If
		compile LIT  ,
	Else
		drop
	Endif  ;



: Value,	( val -- ; allow for <builds ... does> )
	dup ,(t)  ?bd-literal  ;


: Literal	( val -- )
	dup literal(a)  ?bd-literal  ;


((
hex
: Literal	( val -- )
	dup dup 01f u>
	If
		[+asm-access] LIT [previous] ,(t)
	Else
		0be40 or ,code
	Endif
	?bd-literal  ;
))
decimal




\ cur-voc-nfas thread, .. sfp 15/08/88
\


: Cur-Voc(s)	(( -- addr(s) ))
	current(s) 2@(p)  ; 	\ current target voc


: Cur-#Threads(t)	( -- n )
	#threads(t)  ;		\ number of threads in it


: Thread,	( -- )
	here c@  here 1+ c@ +		\ count + first letter
	cur-#threads(t) 1- and cell*	\ mask to get hash code
	cur-voc(s) t-nfa+ rot + 		\ index into nfas
	2dup @(s)l ,(t)			\ lay down old value
	here(t) -rot !(s)l  ;		\ and update nfas table




\ Forward references .. sfp 15/08/88
\


: (Host-Create)	( -- ; make symbol head )
	cs> 'word $create(s)  ;


: (Head-Create)	( -- ; INTERPRETER head )
\	here dup 2 cells+ here c@ 1+ cmove>	\ copy string up for ModForth2
	here dup  cell+ here c@ 1+ cmove>	\ copy string up for ModForth3
	header  lay:					\ header and do-colon
	state on  ;					\ host's compiler on




\ Resolved-Symbol .. Jon 10/08/88
\


: Resolved-Symbol	(( n -- sym-val-fld(d) ))
	(host-create) ,(s) 2 zeros,(s)
	is-resolved latest-chunk @(v) last'(s)@  ;




\ Host-Create .. Jon 11/08/88
\


: Host-Create	( n -- )
	cs> 'word Current(s) 2@(p) voc-chunk+ @(s)l latest-chunk @(p)l
	v-find(s)					\ Symbol exists ?
	If						\  Yes,
		2dup resolved?			\   Symbol resolved ?
		If					\    Yes,
			2drop cr here .name ."  is redefined" cr	\ Redefine it,
			resolved-symbol
		Else					\ Otherwise,
			2dup >r >r resolve r> r>		\   resolve it,
		Endif				\   mark as target
	Else						\   symbol.
		drop resolved-symbol
	Endif
	'latest(s) 2!(v)  ;			\ addr of last host




\ Forward references .. sfp 21/02/90
\


hex

: Target-Create	( -- addr ; modified for leading link field )
	here dup c@ width(t) @(g) min ?dup
	If
		?0-even					\ link on even boundary
		thread,					\ lay thread link
		here(t) last(t) !(g)		\ mark NFA
		over c@ 080 or c,(t)  0		\ lay count byte
		Do
			1+ dup c@ c,(t)
		Loop						\ and text
		drop
	Else
		drop
	Endif
	?force-align		\ CFA is aligned too
	here(t)  ;




\ Forward references .. Jon 10/08/88
\


: Create	( -- )
	target-create host-create  ;


: Forward-Create	( -- )
	forward-error  
	(host-create) 3 zeros,(s)	\ Forward ref. symbol
	latest-chunk @(v) last'(s)@ cell(s)+ ref!  ; \ forward ref. packet





\ Compile-Number Interp-Number Assemble-Number .. sfp 21/09/89
\


: Compile-Number	( -- )
	here number? ?dup
	If
		Case
			1 Of  literal  Endof
			2 Of  swap literal literal  Endof
			3 Of  rot literal  swap literal literal  Endof
		EndCase

	Else
		sc/c(s)-page sc/c(s) forward-create ,(t) \\ rc/c(s)
	Endif  ;


: Interp-Number	( -- n | d )
	here number? ?undef  ;


: Assemble-Number	( -- n | d )
	here number? 0=
	If
		sc/c(s)-page  0 curr-page!  sc/c(s)	\ save page environment
		'Labels(s) 2@(g) set-definitions(s)	\ force labels page
		forward-create
		rc/c(s)
	Endif  ;




\ find(p) ('word(p)) .. J Lee -- 16/08/90
\


global-var found-sym-page	\ symbol page where symbol found


: Find(p)	( -- seg off TRUE | FALSE ; search in all pages )
	curr-page@ >r		\ preserve curr-page
	FALSE			\ false flag
	#Pages 0			\ for all pages
	?Do
		drop
		i dup page-chunk@ swap data-page? not  and \ search pages
		If
			i curr-page!			\ set as page
			i found-sym-page !(g)
			cs> 'word find(t)		\ found?
			?dup ?LEAVE
		Endif
		FALSE					\ leave false flag
	Loop
	r> curr-page!  ;		\ restore curr-page


: ('word(P))	( -- addr page TRUE | FALSE ; search all pages )
	curr-page@ >r		\ preserve curr-page
	FALSE			\ false flag
	#Pages 0			\ for all pages
	?Do
		drop
		i dup page-chunk@
                swap data-page?
                If
                        data-search @(g)
                Else
                        TRUE
                Endif
                and
		If
			i curr-page!			\ set as page
			cs> 'word find(t)		\ found?
			If
 				2dup resolved?
				If
					2dup c/v?		\ variables dont return targ addresses
					If  cell(s)+ 2@(s)l cell(s)+ @(s)l
					Else  @(s)l
					Endif
					i dup found-sym-page !(g)
					>page-table page.id @(g)	\ get target page id
					TRUE			\ leave true flag
					LEAVE		\ and exit loop
				Else
					2drop		\ drop symbol (check other pages)
				Endif
			Endif
		Endif
		FALSE					\ leave false flag
	Loop
	r> curr-page!  ;		\ restore curr-page




\ Primitives .. Jon 10/08/88
\

	cr cr	.( Loading primitives .......... )
	cr


: ?Interpreter	( -- )
	Interpreter context-find
	If
		execute r> drop
	Endif  ;


: ?Compiler	( -- )
	Compiler context-find
	If
		execute r> drop
	Endif  ;


: ?Equates	( -- )
	cs> 'word 'Equates(s) 2@(g) voc-chunk+ @(s)l latest-chunk @(p)l v-find(s)
	If
		@(s)l compil?
		If
			literal
		Endif
		r> drop
	Else
		drop
	Endif  ;




\ Primitives .. Jon 04/01/89
\


: ?Labels	( -- )
	cs> 'word 'Labels(s) 2@(g) voc-chunk+ @(s)l latest-chunk @(p)l v-find(s)
	If
		compil?
		If
			[+asm-access] LIT [previous] ref-label value,
		Else
			sc/c(s)-page  0 curr-page!  sc/c(s)
			'labels(s) 2@(g) set-definitions(s)
			ref-label
			rc/c(s)
		Endif
		r> drop
	Else
		drop
	Endif  ;


: ?C-C	( -- )
	c-c context-find
	If
		execute  r> drop
	Else
		forth context-find
		If
			execute r> drop
		Endif
	Endif  ;




\ ?c/v .. Jon 06/01/89
\


: ?c/v	( -- addr t | f )
	with-data
	cs> 'word find(t) dup					\ Look for symbol
	If 								\ Found it ?
		drop 2dup c/v?					\  is it a c/v ?
		If
			cell(s)+ 2@(s)l TRUE	\   yes, leave addr, flag
		Else
			2drop FALSE				\   no, just leave flag
		Endif
	Endif
	with-code  ;





\ Primitives .. Jon 10/08/88
\


hex



: Compile-cc	( if in <builds .. does> compile name at HERE into x-compiler )
	?b-d					\ <builds ... does> ?
	If
		?in-root		\ in FORTH vocab. ? 
		0>			\ immediate word ?
		If
			execute	\ do it
		Else
			,		\ compile it
		Endif
	Endif  ;




\ ?Asm-Access .. J Lee -- 17/10/90
\


: ?Asm-Access	( -- )                                       
	Asm-Access context-find
	If
		execute
		compile-cc
		r> drop
	Endif  ;





\ ?Target .. sfp 14/04/89
\


: ?Target	( -- ; local to a page )
  cs> 'word find(t)
  If							\ Found symbol ?
    compil?						\  Compiling ?
    If
      compile-local-ref compile-cc	\   compile references
      r> drop					\   exit
    Else				\ *** SUBSITUTE CASE STATEMENT ??? ***
      2dup voc?
      If						\ ? set voc
        is-voc(s) r> drop exit
      Endif
      2drop
    Endif
  Endif  ;


: Get-float		\ addr(s) -- float
  cell(s)+ 2dup @(s)l >r		\ Get next three words from symbol table
  cell(s)+ 2dup @(s)l >r		\
  cell(s)+      @(s)l			\
  r> r> 				\
;  

: Float-var		\ addr(s) -- float|
  Get-float				\ Get floating point number
  compil?				\ Compiling?
  If					\ Yes,
    rot dup literal(a) -rot		\   Compile onto target
    over    literal(a) 			\
        dup literal(a)			\
    ?b-d				\   Need host version ?
    If					\   Yes,
      rot  compile LIT ,		\     Compile float onto host
      swap compile LIT ,		\
           compile LIT ,		\
    Else				\   No,
      2drop drop			\     Discard copy of float
    Endif				\
  Endif					\
;

: Double-var		\ addr(s) --
  cell(s)+ 2@(s)l			\ Get double number
  compil?				\ Compiling?
  If					\ Yes,
    dup  literal(a)			\   Compile double onto target   
    over literal(a)			\
    ?b-d				\   Need a host version?
    If					\   Yes,  
      swap compile LIT ,		\     compile literal onto host
           compile LIT ,		\
    Else
      2drop
    Endif
  Endif
;

: Single-var		\ addr(s) -- ;
  cell(s)+ @(s)l			\
  compil?				\
  If					\
    dup literal(a)			\
    ?b-d				\
    If					\
      compile LIT ,			\
    Else				\
      drop				\
    Endif				\
  Endif					\
;

: Farray-var		\ n addr(s) | addr(s) -- f | ;
  cell(s)+ @(s)l			\
  compil?				\
  If					\
    Dup >ca(t) ,(t)			\
    ?b-d				\
    If					\
      ,					\
    Else				\
      drop				\
    Endif				\
  Else					\
    Swap 6 * +				\
    Dup  6 + @(t)			\
    Over 4 + @(t)			\
    Rot  2 + @(t)			\
  Endif					\
;

: ?Variables	( -- c/v | nil )
  ?c/v					\ constant or variable?
  If					\ Yes,
    Case 2dup @(s)l			\   number type
      Single-code of Single-var Endof	\ 
      Double-code of Double-var Endof	\
      Float-code  of Float-var  Endof	\
      Farray-code of Farray-var Endof	\
      2drop				\
    End-case				\
    r> drop				\
  Endif					\
;

\ ?Inter-Page-Ref Pages .. J Lee -- 15/08/90
\



((

	***************
	GENERIC version 
	***************


: Inter-Page-Ref	( symbol-addr[d] page# -- ; compile inter page call )
	-rot							\ hide page#
	@(s)l literal					\ compile addr as a literal
	>page-table page.id @(g)
	literal						\ lay target page id
	target PAGE-WORD compile-ref  ;	\ compile 'PAGE-WORD'

))


\ ***********
\ RTX version
\ ***********

: Inter-Page-Ref	(( symbol-addr(d) page# -- ; compile inter page call ))
	>page-table page.id @(g) literal		\ compile page#
	[+asm-access] CPR! [previous]			\ compile page set code
	@(s)l >>1 ,code  ;					\ compile subroutine call


: ?unres-inter-page	(( sym-addr(d) -- ; check resolved inter page call ))
	resolved? 0=
	If
		cr 'word $. ."  is an unresolved inter page call " abort
	Endif  ;


global-var page-call  1 page-call !(g)

: ?Pages	( -- ; compile an inter page reference if found )
	curr-page@
	0				\ dummy flag to drop
	#Pages 0
	?Do
		drop
		dup i <>
		If				\ check only if not curr-page
			i dup page-chunk@ swap data-page? not and \ get base
			If
				i curr-page!			\ set as page
				cs> 'word find(t)		\ found?
				If
					2dup ?unres-inter-page
					rot dup curr-page! -rot	\ reset curr-page
					i 0<> RTX? or 			\ not in page 0 (SPLIT model)
					If
						forward-error
						i inter-page-ref
					Else
						compile-ref  compile-cc	\ compile as a ref
					Endif
					-1 LEAVE		\ leave loop with true flag
				Endif
			Endif
		Endif
		0 					\ on last iteration leave false flag
	Loop
	swap curr-page!
	If
		r> drop				\ jump back into interpreter/compiler	
	Endif  ;




\ Outer Interpreter .. Jon 04/01/89
\


	cr cr	.( Loading Outer Interpreter ... )
	cr


: Interpreting	( -- )
	?interpreter ?equates ?labels
	?target ?variables ?c-c interp-number  ;


: Compiling	( -- )
	?compiler ?asm-access ?target ?variables  ?equates
	?labels ?pages compile-number  ;


: Assembling	( -- )
	?asm-access ?interpreter ?equates ?labels
	?target ?variables ?c-c assemble-number  ;




\ Outer Interpreter .. sfp 19/09/89
\


: Interpret(cc)	( -- )
	Begin
		abandon
		Host-Mode @(g)
		If
			bl word c@ 0=
			If  exit  Endif
			'word find ?dup
			If
				0<  state @  and
				If
					,
				Else
					execute
				Endif
			Else
				number? dup ?undef
				State @
				If  #literal  Else  drop  Endif
			Endif
		Else
			get-token c@ 0=  If  exit  Endif
			\  ."  | " here count type  space  key drop .s
			compil?
			If
				compiling
			Else
				interp?
				If
					interpreting
				Else
					assembling
				Endif
			Endif
		Endif
		?stack
	Again  ;


defer INTERPRET(T)		assign INTERPRET(CC) to-do INTERPRET(T)




\ $from .. sfp 12/01/90
\


: $From	( first last $addr-l -- )
	Blk @ >r  >in @ >r  blk off
	get-stream next-file		        \ open next file
	dup ?error
	pcr 						\ go to starting page
        redraw-bottom-bar
	." Source text file: " .Text-file cr
	Begin
		next-line
	While
		interpret(t)
	Repeat
	prev-file dup ?error
	pcr ." Finished." pcr
        redraw-bottom-bar
	r> >in !  r> blk !
	Blk @ 0=						\ if keyboard, null line
	If
		#tib off  >in off
	Endif  ;





\ Rom-Var(t) Ram-Var(t) -2Var -CVar .. J Lee 20/11/90
\
: 0,(r)'s       ( size -- )
  0 ?Do 0 ,(r) Loop ;

: 0,(t)'s       ( size -- )
  0 ?Do 0 ,(t) Loop ;

: Rom-set(t)  ( flag size -- addr )
  swap 
  if
    there(t) tuck ,(t)                  \ Place initialised ram addr
  else
    there(t) swap 
  endif
  kernel-ram-page @(g)                  \ same page?
  curr-data-page @(g)  =                \
  If   0,(r)'s                          \ Yes,
  Else cell(t) * allot-ram              \ No,
  Endif  ;

: Rom-Var(t)  ( -- addr )
  width(t) @(g) 0=  in-umbilical @(g) or not dup
  if
    Target VARIABLE compile-run-time-ref  \ Get run-time reference
  endif
  1 Rom-set(t)                          \
;

: Ram-Var(t)  ( -- )
  docreate,
  here(t)  0 ,(t)  ;


: Rom-2Var(t)  ( -- addr )
  width(t) @(g) 0=  in-umbilical @(g) or not
  If
    target VARIABLE compile-run-time-ref
    there(t) dup ,(t)
  Else
    there(t)
  Endif
  kernel-ram-page @(g)  curr-data-page @(g)  =
  If
    0 ,(r)  0 ,(r)              \ allocate RAM space
  Else
    cell(t) 2* allot-ram        \ allocate non-initialised RAM space
  Endif  ;


: Ram-2Var(t)  ( -- addr )
  docreate,
  here(t)  0 ,(t)  0 ,(t)  ;


: Rom-Float(t)  ( -- addr )
  width(t) @(g) 0=  in-umbilical @(g) or not dup
  if
    target FVARIABLE compile-run-time-ref \
  endif
  3 Rom-set(t)                          \
;

: Ram-Float(t)  ( -- addr )
  docreate,
  here(t)  3 0,(t)'s ;

: Rom-CVar(t)  ( -- addr )
  width(t) @(g) 0=  in-umbilical @(g) or not
  If
    target VARIABLE compile-run-time-ref
    there(t) dup ,(t)
  Else
    there(t)
  Endif
  kernel-ram-page @(g)  curr-data-page @(g)  =
  If
    0 c,(r)                     \ allocate RAM space
  Else
    1 allot-ram                 \ allocate non-initialised RAM space
  Endif  ;


: Ram-CVar(t)  ( -- addr )
  docreate,
  here(t)  0 c,(t)  ;




\ Rom-Voc(t) Ram-Voc(t) .. sfp 14/04/89
\


: Rom-Voc(t)	(( #threads t-cfa -- ^threads(r) ))
	there(t) ,(t)		\ pointer to threads
	voc-link(t) @(g) ,(t)		\ update voc-link
	voc-link(t) !(g)
	there(t) >r			\ preserve addr for compiler to copy threads to
        kernel-ram-page @(g)  curr-data-page @(g)  <>
        abort" A Vocabulary can only be defined in Kernel RAM"
	dup ,(r)  0
	?Do
		0 ,(r)          \ allocate RAM and space for init. threads
	Loop
	r> cell+  ;		\ retrieve pointer to threads


: Ram-Voc(t)	( #threads t-cfa -- ^threads )
	Voc-Link(t) @(g) ,(t)		\ update voc-link(t) with t-cfa
	Voc-Link(t) !(g)
	here(t) >r				\ save ^threads
	dup ,(t) 0
	?Do
		0 ,(t)
	Loop						\ zero alloted threads
	r> cell+  ;




\ Primitives .. Jon 19/08/88
\


hex

	cr cr	.( Loading Primitives .......... )
	cr


: Voc(t)	( -- ^threads )
	"" VC" here(t) .log				\ log it to user
	here(t)
	target VOCABULARY Compile-run-time-ref	\ vocabulary run-time-ref
	cur-#threads(t) swap Rom?		\ #threads for this voc.
	If							\ ROM version
		Rom-voc(t)
	Else							\ RAM version
		Ram-voc(t)
	Endif  ;




\ Primitives .. sfp 16/08/88
\


hex

: Voc(h)	( -- ; build new vocab )
	create  (make-voc)					\ build new host vocab
	latest-chunk @(v) last'(s)@			\ return seg offset of symbol
	create-voc-chunk					\ create a new voc chunk
	-rot link-voc-chunk					\ set pointer in voc symbol
        width(t) @(g) 0=  in-umbilical @(g) or not
        If
	  voc(t)							\ build target vocab
          'latest(s) 2@(v) t-vp+ !(s)l			\ stash CONTEXT addr
        Endif
	'latest(s) 2@(v)
	status+ mark-voc  ;					\ mark symbol as vocab


: Create(cc)	( address-of-does-section -- )
	get-token drop create			\ header
	"" CR" here(t) .log				\ log cfa to user
	compile-run-time-ref  ;			\ lay cfa




\ Is-Action-Of .. sfp 14/04/89
\


: Is-Action-Of	( addr -- ; here is-action-of <name> )
	[compile] target  resolve-def-word  ;




\ Primitives .. Jon 09/08/88
\


: ([)	( -- ; turn cross-compiler's interpreter on )
	State(t) off(g)  ;


: (])	( -- ; turn cross-compiler's compiler on )
	1 State(t) !(g)  ;


: ([Compile])	( -- <word> ; compile word )
	cs> get-token find(t)
	If
		compile-ref ?b-d
		If
			?in-root ,
		Endif
	Else
		forward-create ,(T)
	Endif  ;




\ ",[T] .. sfp 21/02/90
\


hex


: ",(T)	( -- <string> ; compile string )
	ascii " word
	dup c@ 1+ cmove,(t)
	?bl-even
	?b-d
	If
		here c@ 1+ allot  even(h)
	Endif  ;




\ Primitives - File handling for USING definitions .. sfp 27/03/87
\


: Restore-Prev	( -- ; restore file saved in PREV-PCB )
	pcr ." Finished with " .scr		\ say so
	re-using						\ re-open file
	pcr pcr  ;


: Cd-Word	( -- ; use CD-WORD <name> <target> <host> )
	[ also forth ] Create [previous] smudge
		state @  state on
		[compile] target
		state !
		' , smudge
	Does>
		dup @ execute compile-ref
		?b-d
		If
			cell+ @ ,
		Else
			drop
		Endif  ;




\ Primitives - Conditional compilation .. sfp 26/03/87
\

: C-Endif	( -- ; doesn't do anything )
;

: C-Else	( -- ; scan text until ENDIF )
  Begin
    Begin
      get-token c@ 0=
      While
        Obtain-line 0= If exit Endif
    Repeat
    "" )ENDIF" $here=
  Until
;

: C-If	( -- ; scan text until ELSE or ENDIF if top-of-stack is false )
  0=
  If
    Begin
      Begin
          get-token c@ 0=
        While
          Obtain-line 0= If exit Endif
      Repeat
      "" )ELSE(" $here=
      "" )ENDIF" $here=  or
    Until
  Endif
;

\ Primitives **************************** .. sfp 21/09/89
\


: '(T)	( -- cfa ; in Forth-83 ' is not immediate )
	cs> get-token find(t) ?undef	\ must be defined
	2dup resolved? ?undef		\ error if forward ref
	@(s)l  ;


: Immediate(t)	( -- )
	040 'Latest(s) 2@(v) >name(s) set-bit(s)
	Width(t) @(g)
	If
		latest(t) 040 toggle(t)
	Endif  ;


((
: ['(T)]	( -- ; compile CFA as a literal )
	target LIT compile-ref
	get-token find(t)
	If
		ref >ca(t)
	Else
		compil? ?undef
		forward-create
	Endif
	value,  ;
))


: ('(p))	( -- addr page TRUE | FALSE <name> ; collect string from input )
	get-token drop	\ get string to search for
        data-search on(g)
	('word(p))
        data-search off(g)  ;


: '(P)	( -- addr page ; search all pages )
	('(p))
	0=  If  cr ." Can't find " 'word $. ."  in any page"  abort  Endif  ;


: ['(P)]	( -- ; compile CFA as a literal )
	('(p))				\ search for string
	If
		swap literal
		literal
	Else
		cr ." Can't forward reference " 'word $. ." across pages"
		abort
	Endif  ;




\ Compiler .. sfp 19/09/89
\


hex

	cr cr	.( Loading Compiler ........... )
	cr


only forth  also c-c  also compiler definitions  c-c

: :	CC/C
	?exec  ;

: ;	CC/C
	?csp [+compiler] EXIT [previous]
	?b-d
	If
		compile EXIT
	Endif
	'latest: 2@(v) smudge(s)
	([)  state off  ;


: [']	CC/C
	'(t) literal  ;


: ['P]	cc/c
	['(p)]  ;


: Page-Of	cc/c
	'(p) nip literal  ;

: Addr-Of	cc/c
	'(p) drop literal  ;

: Long-Of	cc/c
	['(p)]  ;


: Begin	CC/C
	?comp  mark<  ?b-d
	If
		[compile] BEGIN                               
		drop
	Endif
	\\ 1  ;


: Endif	CC/C
	?comp 2 ?pairs ?b-d
	If
		2 [compile] ENDIF
	Endif
	>res-jmp \\  ;


: Then	CC/C
	[+compiler] ENDIF [previous]  ;




\ Compiler .. J Lee -- 10/07/90
\

: Do	CC/C
	target (DO) compile-ref
        [+asm-access] ?BRANCH [previous] mrk-jmp> mrk-jmp<  0  ?b-d 
	If
		[compile] DO
		drop
	Endif
	\\ 3  ;


: ?Do	CC/C
	target (?DO) compile-ref
        [+asm-access] ?BRANCH [previous] mrk-jmp> mrk-jmp< 0
	?b-d 01c ?error  3 \\  ;


: Loop	CC/C
	3 ?pairs  ?b-d
	If
		3 [compile] LOOP
	Endif
	target (LOOP) compile-ref [+asm-access] ?BRANCH [previous] 
	resolving-jmps>
        <res-jmp
        >res-jmp  \\  ;


: +Loop	CC/C
	3 ?pairs  ?b-d
	If
		3 [compile] +LOOP
	Endif
	target (+LOOP) compile-ref  [+asm-access] ?BRANCH [previous]
	resolving-jmps>
        <res-jmp
        >res-jmp  \\  ;


: Leave	CC/C
	target (LEAVE) compile-ref
        [+asm-access] BRANCH [previous] insert-mrk-jmp>  ?b-d
	If
		compile LEAVE
	Endif  ;


: ?Leave	CC/C
	target (?LEAVE) compile-ref
        [+asm-access] ?BRANCH [previous] insert-mrk-jmp>  ?b-d
	If
		compile ?LEAVE
	Endif  ;




\ Compiler .. J Lee -- 09/10/90
\


: -->	CC/C
	[compile] -->  ;


: [Compile]	CC/C
	([compile])  ;


: Smudge	CC/C
	target SMUDGE compile-ref  ;


: [	CC/C
	([)  ;


Cd-Word ] ] (])




\ Compiler .. J Lee -- 09/10/90
\


: Until	CC/C
	1  ?pairs  ?b-d
	If
		1 [compile] UNTIL
	Endif
	[+asm-access] ?BRANCH [previous] <res-jmp \\  ;


: Again	CC/C
	1 ?pairs  ?b-d
	If
		1 [compile] AGAIN
	Endif
	[+asm-access] BRANCH [previous] <res-jmp \\  ;


: For	CC/C
	?comp [+asm-access] >r [previous]
	mrk-jmp<  1  \\  ;


: Next	CC/C
	1 ?pairs [+asm-access] (next) [previous]  <res-jmp \\  ;




\ Compiler .. sfp 26/03/87
\


: Repeat	CC/C
	?b-d
	If
		>R
	Endif
	>r >r
	[+compiler] AGAIN [previous]
	r> r>  ?b-d
	If
		r>
	Endif
	2-
	[+compiler] ENDIF [previous] \\  ;


: If	CC/C
	<if> mrk-jmp>  ?b-d
	If
		[compile] IF
		drop
	Endif
	2 \\  ;


: Else	CC/C
	2 ?pairs  ?b-d
	If
		2 [compile] ELSE
		drop >r
	Endif
	[+asm-access] BRANCH [previous] mrk-jmp>  swap  >res-jmp  ?b-d
	If  r>  Endif
	2 \\  ;


: While	CC/C
	[+compiler] IF [previous]  2+  ;




\ Compiler .. sfp 19/10/89
\


Cd-Word , , ,(t)
Cd-Word c, c, c,(t)
Cd-Word c,(r) c, c,(r)
Cd-Word ,(r) , ,(r)


: @	CC/C
	[+asm-access] @ [previous]  ?b-d
	If  compile @(T)  Endif  ;


: C@	CC/C
	[+asm-access] C@ [previous]  ?b-d
	If  compile C@(T)  Endif  ;


: !	CC/C
	[+asm-access] ! [previous]  ?b-d
	If  compile !(T)  Endif  ;


: C!	CC/C
	[+asm-access] C! [previous]  ?b-d
	If  compile C!(T)  Endif  ;


Cd-Word +! +! +!(t)




\ Compiler .. sfp 19/09/89
\


Cd-Word Cmove Cmove Cmove(t)
Cd-Word Erase Erase Erase(t)
Cd-Word Fill Fill Fill(t)




\ Compiler .. Jon 17/11/88
\


: Does>	CC/C
	target (DOES>) compile-ref  ?b-d
	If
		compile EXIT
		state off
	Endif
	here(t) 'Latest: 2@(v) resolve-def-word
	DODOES,  ;


: Literal	CC/C
	literal  ;


: DLiteral	CC/C
	swap literal literal  ;




\ Compiler .. sfp 19/03/90
\


hex

: .(	CC/C
	029 word count type  ;


: ."	CC/C
	target (.") compile-ref  ?b-d
	If
		compile (.")
	Endif
	",(t)  ;


: ""	CC/C
	target (") compile-ref  ?b-d
	If
		 compile (")
	Endif
	",(t)  ;


: Abort"	CC/C
	target (ABORT") compile-ref ?b-d
	If  compile (ABORT")  Endif
	",(t)  ;


: ",	cc/c
	target ", compile-ref  ?b-d
	If  compile ",(t)  Endif  ;


: )	CC/C
	9 error  ;


: )) CC/C
	9 error  ;


: "	CC/C
	9 error  ;




\ ( \ recurse .. sfp 13/03/90
\


: (	cc/c
	[compile] (  ;


: (( cc/c
	[compile] ((  ;


: \	cc/c
	[compile] \  ;


: Recurse	cc/c
	'Latest(s) 2@(v) compile-ref  ;




\ Compiler - Eaker's CASE statement .. sfp 19/09/89
\


	cr cr	.( Compiler CASE is HOST and TARGET dependent )
	cr


: Case	CC/C
	?comp  target (case) compile-ref  0  4  ;


: Of	CC/C
	4 ?pairs
	target (OF) compile-ref  [+asm-access] ?BRANCH [previous] mrk-jmp>
        ?b-d
	If
		4 [compile] OF
		drop
	Endif
	5 \\  ;


: ?Of	cc/c
	4 ?pairs
	[+asm-access] ?BRANCH [previous] mrk-jmp>
        ?b-d
	If
		4 [compile] ?OF
		drop
	Endif
	5 \\  ;


: Endof	CC/C
	5 ?pairs  ?b-d
	If
		5 [compile] ENDOF
		drop >r
	Endif
	[+asm-access] BRANCH [previous] mrk-jmp> >r  >res-jmp  r>  ?b-d
	If  r>  Endif
	4 \\  ;


: EndCase	CC/C
	4 ?pairs  ?b-d
	If  [compile] ENDCASE  Endif
	[+asm-access] DROP [previous]
	resolving-jmps>  \\  ;


: End-Case	CC/C
	4 ?pairs  ?b-d
	If
		[compile] END-CASE
	Endif
	resolving-jmps>  \\  ;




\ Compiler .. sfp 28/03/87
\


Cd-Word Here here here(t)
Cd-Word There here there(t)
Cd-Word Allot allot allot(t)
Cd-Word Word word word(t)
Cd-Word Immediate immediate immediate(t)

: Ascii	CC/C
	bl word 1+ c@  literal  ;




\ create -- with defining mode  create ... ;code .. Jon 10/08/88
\


: Create	CC/C
	3 zeros,(s)   				\ expand reference packet
	'Latest: 2@(v) status+ mark-def-word
	width(t) @(g)				\ if heads allowed
	If
		target CREATE compile-ref	\ create in target
	Endif
	Do-Build @(g)				\ is image-in-host allowed ?
	If
		sc/c  Interpreter definitions
		word-down context-find 0=
		If
			(head-create)
			compile LIT 'Latest: 2@(v) swap , 
			compile LIT ,
			compile CREATE(CC)
		Else
			drop
		Endif
		rc/c
	Endif  ;




\ conditional compilation  assign to-do .. sfp 25/03/87
\


: If(	CC/C
	c-if  ;


: )Else(	CC/C
	c-else  ;


: )Endif	CC/C
	c-endif  ;


: Assign	CC/C	( -- ; compiles cfa )
	'(t) >>1 literal  ;


: To-Do	CC/C
	target (TO-DO) compile-ref	\ compile action
	'(t) ,(t)  ;


: [\\]	CC/C
	\\  ;




\ vocabulary switching .. sfp 25/03/87
\


\ allow vocabulary switches after HOST-COMPILATION
: CC/C	CC/C
	[compile] CC/C  ;	IMMEDIATE


: C-C	CC/C
	[compile] C-C  ;	IMMEDIATE




\ Interpreter .. sfp 14/04/89
\


hex

	cr cr	.( Loading Interpreter ........ )
	cr


only forth  also c-c also cc/i


: Make-turnkey cc/i
  the-label STRT 2dup resolved?		\ Cold start vector exists?
  If  					\ Yes,
    @(s)l				\
    bl-word-up				\ 
    cs> 'word Current(s) 2@(p)		\
    voc-chunk+ @(s)l latest-chunk @(p)l	\
    v-find(s)				\   Symbol exists ?
    If					\   Yes,
      2dup resolved?			\     Symbol resolved ?
      If				\     Yes,
        @(s)l Swap !(t)			\       save word addr at startup vector
      Else				\     No,
        2Drop Drop 0 error		\       cannot set if not defined
      Endif				\
    Else				\   No,
      2Drop 0 error			\     cannot set if not defined
    Endif				\
  Else					\ No,
    2Drop 0 error			\   cannot set if startup doesn't exist
  Endif					\
;

: Allot	CC/I
	allot(t)  ;


: ",	CC/I
	",(t)  ;


: .(	CC/I
	[compile] .(  ;


: ." CC/I
	[compile] ."  ;


: )	CC/I
	9 error  ;


: )) CC/I
	9 error  ;


: "	CC/I
	9 error  ;


: :	CC/I
	(])  !csp
	Current(s) 2@(p) Context(s) 2!(p)
	bl-word-up  create
	"" : " here(t) .log
	'Latest(s) 2@(v)  2dup smudge(s)  'Latest: 2!(v) ;



\ Interpreter .. sfp 05/06/90
\


: [']	CC/I
	'(t) literal  ;


: '	CC/I
	'(t)  ;


: 'P	cc/i
	'(p)  ;


: Page-Of	cc/i
	'(p) nip  ;

: Addr-Of	cc/i
	'(p) drop  ;

: Long-Of	cc/i
	'(p)  ;


: Here	CC/I
	here(t)  ;


: ;S	CC/I
	 r> r> r> 2drop drop  ;


: Latest	CC/I
	latest(t)  ;




\ Interpreter .. sfp 14/04/89
\


hex

: [compile]	CC/I
	([compile])  ;


: Toggle	CC/I
	toggle(t)  ;


: Immediate	CC/I
	immediate(t)  ?b-d
	If
		compile immediate(t)
	Endif  ;




\ Interpreter .. sfp 15/08/88
\


hex

: Vocabulary	CC/I
	?0-even  cs> get-token find(t)
	If
		2dup voc?
		If
			create			\ resolve symbol
                        width(t) @(g) 0=  in-umbilical @(g) or not
                        If
       			  voc(t)			\ make target
			  -rot t-vp+ !(s)l	\ stash address
                        Else
                          2drop
                        Endif
		Else
			drop voc(h)
		Endif
	Else
		voc(h)
	Endif  ;


: Ascii	CC/I
	bl word 1+ c@  ;




\ Interpreter .. Jon 11/08/88
\



: Equ	CC/I
	dup get-token drop
	sc/c(s)-page  0 curr-page!  sc/c(s)	\ Save voc env.
	'Equates(s) 2@(g) set-definitions(s)	\ force equates page
	cs> 'word Current(s) 2@(p) voc-chunk+ @(s)l latest-chunk @(p)l v-find(s)
	If
		rot drop		\ drop extra copy of EQU value
		2dup  pcr >name(s) .name(s) ."  is reset"  pcr
		rot >r 2dup r@ -rot !(s)l  "" EQ" r> 2swap (.log)
	Else
		drop  (host-create) ,(s)
        "" EQ" swap latest-chunk @(v) last'(s)@ (.log)
	Endif
	rc/c(s)  ;			\ restore voc env.




\ Interpreter .. sfp 21/02/90
\


: Label	CC/I
	dup get-token drop
	sc/c(s)-page  0 curr-page!  sc/c(s)
	'Labels(s) 2@(g)  2dup context(s) 2!(p)
	set-definitions(s)				\ force labels page
	host-create "" LB" swap .log
	rc/c(s)  ;


: L:	CC/I
	here(t) [+interpreter] LABEL [previous]  ;


: User	CC/I
	?0-even  get-token drop  create
	"" US" here(t) .log
	target USER compile-run-time-ref
	,(t)  ;




\ From From-File ( \ .. sfp 14/04/89
\


: From-File	cc/i		( first last -- ; <file> )
	cs> get-token
        2dup  dup c@ 1+  curr-text$  rot  cmovel
        [+interpreter] $from [previous]  ;


: From	cc/i		( first last -- )
	curr-text$ [+interpreter] $from [previous]  ;


: (	cc/i		( -- )
	[compile] (  ;


: (( cc/i	( -- )
	[compile] ((  ;


: \	cc/i		( -- )
  [compile] \  ;




\ Interpreter .. sfp 14/04/89
\


: Load	CC/I		( n -- )
	Blk @ >r   >In @ >r   >In off   Blk !
	interpret(t)
	r> >In !   r> Blk !  ;


: Constant	CC/I
	?0-even  bl-word-up
        target-create 
        with-data host-create
	"" CN"  over with-data .log
        with-code
        width(t) @(g)
        If
          DoConstant, dup ,(t)
        Endif
	with-data make-c/v-data-packet
        with-code  ;


: 2Constant	CC/I
	?0-even  bl-word-up
        target-create 
        with-data host-create
	over "" CN" swap with-data .log
        with-code
        width(t) @(g)
        If
          2dup Do2Constant,
        Endif
	with-data make-double-data-packet
        with-code  ;

: FConstant     CC/I
  ?0-even  bl-word-up
  target-create
  with-data dup host-create
  "" FC" swap with-data .log
  with-code
  width(t) @(g)
  If 3dup DoFconstant, Endif
  with-data make-float-data-packet
  with-code  ;

: Farray        CC/I
  ?0-even  bl-word-up
  target-create
  with-data
  dup >r
  dup host-create
  "" FA" swap with-data .log
  with-code
  Target FARRAY compile-run-time-ref
  DoFarray,
  with-data
  r> make-farray-data-packet
  with-code
;

: Host&Target	CC/I
	Do-Build on(g)  ;


: Target-Only	CC/I
	Do-Build off(g)  ;




\ Interpreter .. Jon 13/08/88
\


: Create	CC/I
	?0-even  bl-word-up 
        with-code target-create
        with-data host-create
	with-code "" CR" here(t) with-data .log
        with-code
	in-umbilical @(g) 0=  width(t) @(g) 0>  AND
        If  DOCREATE,  Endif
        here(t)
	with-data make-c/v-data-packet with-code  ;


: Variable	CC/I
	?0-even  bl-word-up  
        with-code target-create
        with-data host-create
        rom?                            \ ROM target?
        If                              \ y: show RAM address
          there(t)                      \
        Else                            \ n: show in-line address
          with-code here(t) cell(t) +
        Endif
        "" VR" swap with-data .log
	with-code
	Rom?
	If
                rom-var(t) 
	Else
                ram-var(t)
	Endif
        with-data
	make-c/v-data-packet
        with-code  ;


: 2Variable	CC/I
	?0-even  bl-word-up
        with-code target-create
        with-data host-create
        rom?                            \ ROM target?
        If                              \ y: show RAM address
          there(t)                      \
        Else                            \ n: show in-line address
          with-code here(t) cell(t) +
        Endif
        "" VR" swap with-data .log
	with-code
	Rom?
	If
                rom-2var(t)
	Else
		ram-2var(t)
	Endif
        with-data
	make-c/v-data-packet
        with-code  ;

: FVariable     CC/I
  ?0-even  bl-word-up
  with-data host-create
  with-code target-create
  "" FV" here(t) with-data .log
  with-code
  ?Rom @(g)
  If   Rom-Float(t)
  Else Ram-Float(t)
  Endif
  with-data
  make-c/v-data-packet
  with-code  ;

: UVariable	CC/I	( -- ; just like USER )
	dup $01f > abort" UVariable should be in range: 0..01f hex "
	?0-even  bl-word-up
        with-data host-create
        with-code target-create
	with-data "" CN" over .log
	with-code DoConstant, ,(t)
        with-data make-c/v-data-packet
        with-code  ;


hex

: CVariable	CC/I
	?0-even bl-word-up
        with-code target-create
        with-data host-create
        width(t) @(g) 0=  in-umbilical @(g) or  \ umbilical target?
        If                                      \
            there(t)                            \ y: show variable address
        Else                                    \
            here(t)                             \ n: show CFA
        Endif                                   \
        "" VR" swap with-data .log              \ 
	with-code
	Rom?
	If
                rom-cvar(t)
	Else
                ram-cvar(t)
	Endif
        with-data
	make-c/v-data-packet
        with-code  ;




\ uCode OpCode ,Code .. J Lee -- 09/10/90
\

hex

: uCode	CC/I	( n -- ; create HOST opcode )
	also asm-access definitions  opcode  previous definitions  ;


: OpCode	CC/I	( n -- ; build opcode in TARGET )
	bl-word-up  create
	"" OP" here(t) .log
	target OPCODE compile-run-time-ref
	,(t)  0a020 ,(t)
	[+interpreter] IMMEDIATE [previous]  ;


: ,Code	CC/I	( n -- ; lay opcode )
	,Code  ;

decimal




\ Interpreter .. sfp 14/04/89
\


: !	CC/I
	!(t)  ;


: @	CC/I
	@(t)  ;


: On    CC/I
        -1 swap !(t)  ;


: Off   CC/I
        0 swap !(t)  ;


: C!	CC/I
	c!(t)  ;


: C@	CC/I
	c@(t)  ;


: +!	CC/I
	+!(t)  ;


: ,	CC/I
	,(t)  ;


: C,	CC/I
	c,(t)  ;




\ Interpreter .. sfp 19/09/89
\


: Cmove	CC/I
	cmove(t)  ;


: Erase	CC/I
	erase(t)  ;


: Fill	CC/I
	fill(t)  ;


: [	CC/i
	([)  ;


: ]	CC/I
	(])  ;




\ Interpreter .. sfp 15/08/88
\


hex

: Is-Fence	CC/I
	latest(t) fence(t) !(g)  ;


: There	CC/I
	there(t)  ;


: Literal	CC/I
	?comp  ;


: DLiteral	CC/I
	?comp  ;


: Thru	CC/I		( start end -- )
	1+ swap
	Do
		i [+interpreter] LOAD [previous]
	Loop  ;




\ Interpreter .. sfp 19/09/89
\



: Thru-Using	CC/I	 ( start-screen# end-screen# --- ; <file-name> )
	pcr cs> get-token $using
	If
		re-open   8 error
	Endif
	pcr .curr-file pcr
        redraw-bottom-bar
	[+interpreter] THRU [previous]
	pcr ." Finished with " .scr pcr re-using  ;


: Load-Using	CC/I		( screen# --- ; <file-name> )
	pcr cs> get-token $using
	If
		re-open   8 error
	Endif
	pcr .curr-file pcr
        redraw-bottom-bar
	[+interpreter] LOAD [previous]
	pcr ." Finished with " .scr pcr re-using  ;




\ Conditional Interpretation .. sfp 15/08/88
\


: If(	CC/I
	c-if  ;


: )Else(	CC/I
	c-else  ;


: )Endif	CC/I
	c-endif  ;




\ Immediate word compilation .. Jon 10/08/88
\


: I:	CC/I
	[+interpreter] : [previous]
	Do-Build @(g)
	If 
		sc/c  Compiler definitions
		word-down context-find
		If
			drop
		Else
			(head-create)
		Endif
		rc/c
	Endif  ;




\ defer .. Jon 13/08/88
\


hex

: Defer	CC/I
	?0-even get-token drop  create
	"" DF" here(t) .log
	Rom?
	If
		target DEFER compile-run-time-ref
		there(t) ,(t)
		target CRASH 2dup resolved? 0= 01b ?error
                kernel-ram-page @(g)  curr-data-page @(g)  =
                If
                        @(s)l ,(r) 
                        $0a020 ,(r)
                Else
                        2drop
        		cell(t) allot-ram	\ action of deferred word
               		cell(t) allot-ram	\ Exit has to be set by target TO-DO
                Endif 
	Else
		target CRASH compile-ref \\
		[+compiler] EXIT [previous]
	Endif
        with-code  ;

decimal




\ assign to-do .. sfp 09/04/90
\


: Assign	CC/I		( -- cfa )
	'(t) >>1  ;


: To-Do	CC/I	( cfa -- ; to-do <word> )
	'(t) 	        		\ find target body
	Rom?				\ ROM target?
	If
                kernel-ram-page @(g)  curr-data-page @(g)  =
                in-umbilical @(g)  OR
		If
        		cell(t) + @(t) dup >r !(t)      \ write ACTION
                        $a020 r> cell(t) + !(t)         \ and EXIT
                Else
                        2drop
                        cr ." Can't assign word to unitialised RAM" cr abort                Endif
        Else
        	!(t)   			\ store CFA
        Endif  ;




\ vocabulary switching - interpreter .. sfp 21/02/90
\


: Forth	CC/I
	'Forth(s) 2@(g) Context(s) 2!(p)  ;


: Only	CC/I
	only(s)  ;


: Also	CC/I
	also(s)  ;


: Previous	CC/I
	previous(s)  ;


: Definitions	CC/I
	definitions(s)  ;


: Alias	cc/i		( -- ; use ALIAS <old> <new> )
  '(t)							\ get cfa of <old>
  get-token drop  host-create  ;		\ make <new> symbol




\ host/target compilation control .. sfp 14/04/89
\


: Host-Compilation	CC/I
	Host-Mode on(g)
	Forth definitions  ;


: CC/I	CC/I		( allow vocabulary switches after HOST-COMPILATION )
	[compile] cc/i  ;	IMMEDIATE


: C-C	CC/I
	[compile] c-c  ;	IMMEDIATE




