((

	XDTC50-6.FTH

	MPE Forth Cross Compiler v5.00

	J Lee - 9/7/90


	Copyright (C) 1983-1991

	MicroProcessor Engineering
	133 Hill Lane
	Southampton
	SO1 5AF
	England

	tel: (+44) 703 631441   (international)
	tel: 0703-631441        (domestic)

))




\ Finish cross-compilation .. sfp 15/08/88
\


	cr cr	.( Loading Termination words ... )
	cr


hex

only forth also c-c definitions


: (Finis-Voc)	( -- )
	<voc-link(s) 2@(p)					\ retrieve latest voc-link
	Begin
		<voc-link(s)-  2dup >r >r  resolved?	\ copy threads if voc res.
		If
			r> r>  2dup >r >r
			2dup t-nfa+				\ get nfa addr in symbol table
			2swap t-vp+ @(s)l			\ get address for target copy
			#threads(t) 0				\ Copy all target threads
			?Do
				3dup -rot @(s)l		\ get thread from symbol table
				swap !(t)				\ write to target
				cell(t) +				\ step on through target
				swap cell(s)+ swap		\ and symbol table
			Loop
			2drop drop
		Endif
		r> r> <voc-link(s)+ 2@(s)l  2dup or 0=	\ cont. until no more vocs
	Until
	2drop  ;


: Finis-Voc	( -- )
	(finis-voc)
	the-label INIT-VOC-LINK  2dup resolved?		\ initial voc link resolved?
	If
		@(s)l voc-link(t) @(g) swap !(t)		\ y: write to target
	Else
		2drop
	Endif  ;




\ Finish cross-compilation .. Jon 03/01/89
\


: Finis-Rom	( -- )
	the-label INIT-FENCE 2dup resolved?
	If
		@(s)l  There(t) swap !(t)
	Else
		2drop
	Endif
	the-label INIT-DP 2dup resolved?
	If
		@(s)l there(t) swap !(t)
	Else
		2drop
	Endif
        kernel-ram-page @(g)            \ kernel RAM defined ?
        If                              \ y: copy out initialised RAM
                Ram-Area @(g)           \ get RAM table segment
        	here(t)  the-label INIT-RAM resolve     \ resolve label
        	Curr-Ram-Size @(g) Ram-Size @(g) min    \ get length of table
        	dup ,(t) 0              \ lay table length in ROM
        	?Do
        		dup i c@l c,(T) \ copy bytes into ROM
        	Loop
        Endif  ;




\ Finish cross-compilation .. sfp 21/02/90
\


: Finis-Ram	( -- )
	the-label INIT-FENCE 2dup resolved?
	If
		@(s)l Fence(t) @(g) ?dup 0=
		If
			here(t)
		Endif
		swap !(t)
	Else
		2drop
	Endif
	the-label INIT-DP 2dup resolved?
	If
		@(s)l  here(t) swap !(t)
	Else
		2drop
	Endif  ;




\ Finish cross compilation .. sfp 21/02/90
\


: ?Init-Ram  ( -- ; initialised RAM table addr. and size )
  kernel-ram-page @(g)            \ kernel RAM defined ?
  If                              \ y: copy out initialised RAM
    Curr-Ram-Size @(g)  Ram-Size @(g)  min  \ get length of table
    the-label INIT-RAM @(s)l
    pcr ." RAM Table =  " ." Addr: " ascii $ emit .hex
    ."   Length: " ascii $ emit dup .hex  pcr
  Endif  ;


: ?Image  ( -- ; image size )
  pcr here(t) O-I @(p) - u. ." bytes of output in "
  0 in-emulator?          \ check whether kernel is in emulator
  If
    ." Emulator"
  Else
    ." file " .img
  Endif
  pcr  ;


: Finis-Report  ( -- ; report other compilation details )
  decimal
  ?resolve
  pcr pcr ." There were " #forward @(g) u. ." forward references" pcr
  ?init-ram
  ?image
  ?rom-end  ;		\ check whether beyond the end of ROM


: (Finis)	( -- )
	new-page
	finis-voc
	?Rom @(g)
	If
		finis-rom
	Else
		finis-ram
	Endif
        finis-report
((      emulator?  If  close-emulator  Endif      \ close emulator, if opened
        0 in-emulator? 0=  If  close-image  Endif \ close file, if open
))
	close-image
	close-log			\ close log file
	reset-aux1			\ reset auxillary module
;




\ Finish cross-compilation .. sfp 24/04/89
\


: Finis	( -- )
	(finis)			\ finish cross compiling
        assign (abort) to-do abort
        assign (error) to-do error
	free-compiler-mem
	bye  ;		\ exit program
\	only Forth definitions  console  cr  ."  ok"
\	abort  ;




\ CC-Text-Interpret .. sfp 09/12/89
\


only forth also c-c definitions


: CC-Text-Quit	( -- )
	interpret(t)			\ finish off old line
	Begin
		next-line			\ while theres a line:
	While
		interpret(t)		\   interpret it.
	Repeat
	interp?				\ interpreting ?
	If
		." c-c " .depth cr
	Endif  ;				\ back to keyboard




\ CC-Blk-Interpret CC-Quit .. sfp 09/12/89
\


: CC-Blk-Quit	( -- )
	Begin
		interpret(t)  compil? not	\ prompt if interpreting
		If
			." c-c " .depth cr
		Endif
		query
	Again  ;


: CC-Quit	( -- )
	from? 			\ from a text file?
	If
		cc-text-quit	\ text interpret
	Else
		cc-blk-quit	\ block interpret
	Endif  ;




\ Finish cross-compilation .. sfp 05/06/90
\


only forth also c-c definitions

: Init-Defers  ( -- ; initialise xc deferred words )
  assign abort-exit to-do abort		\ errors exit compiler
  assign xc-error to-do error
  assign free-compiler-mem to-do close-compiler
  assign interpret(cc) to-do interpret(t)  ;


only forth also c-c also forth definitions


: Cross-Compile	( -- )
        init-defers
        open-log
	init							\ initialise compiler
	symbols-allocated on(g)			\ symbol space in use
	Init-target
	from?
	If
		cr  op-handle @ .curr-text$
	Else
		cr .scr
	Endif
        Found-emulator?
        If  emulator  Else  -emulator  Endif     \ look for emulator driver
	pcr
	state(t) off(g)
	cc-quit  ;




\ End of load .. Jon 02/11/88
\


decimal

assign NCCABORT to-do loader

only Forth definitions



