((
        MONIO.FTH

        Author: J Lee

        Date started:   13/12/89
        Last modified:  13/08/91

        I/O services provided for Application use. These services are 
        called via a fixed entry point.


        MicroProcessor Engineering
        133 Hill Lane
        Shirley
        Southampton SO1 5AF
        tel (+44) 703 631441
))


\ This file contains the i/o services:
\
\     EMIT, KEY, KEY?, and .
\
\ The equate values given should be used when the
\ application requests any of the i/o services, by making a call
\ to address 0210 hex. See APP for Application use.




\ I/O service equates ...................          Jon 13/12/89
\

decimal

0 equ key?-service   ( -- t/f )
1 equ key-service    ( -- c )
2 equ emit-service   ( c -- )
3 equ .-service      ( n -- )
4 equ type-service   ( addr len -- )


\ key? key emit .
\ set i/o services handler ( I/O-SERVICE compiled at 0210(hex) )
\
: I/O-Service	( pars .. n -- ; select i/o service required )
  ibc@ >r   selcpr		\ preserve user flags and data access
  Case
    key?-service  Of  key?-cmnd>h  send-message  Endof
    key-service   Of  key-cmnd>h  send-message   Endof
    emit-service  Of  emit-cmnd>h  send-message  Endof
    .-service     Of  .-cmnd>h  send-message     Endof
    type-service  Of  type                       Endof
    kick-off
  EndCase
  r> ibc!  ;			\ restore user flags




\ Emit Type Cr
\

Hex

: Emit		\ char --
  emit-service i/o-service  ;

: Type		\ addr len --
   ibc@ >r  selcpr		\ preserve flags, set code page access for (?DO)
  bounds
  ?do
    i seldpr c@ selcpr emit
  loop
  r> ibc!  ;			\ restore flags (data access code/data page)

((
: Typel		\ page addr len --
  dpr@ >r	\ preserve data page
  rot dpr!	\ set data page of $
  bounds ?do  i c@ emit  loop	\ emit $
  r> dpr!  ;	\ restore original data page
))

: Cr		\ --
  0A emit  0D emit  ;




\ Count (.")
\

hex

: Count         \ addr -- addr' len
  dup 1+ swap c@  ;

: (.")          \ -- ; displays in-line data
  dpr@				\ preserve data page
  ibc@  seldpr	     \ preserve flags and select data access mode	
  ipr@ 0f and			\ get callers page
  dpr!				\ and set as new data page
  r> count  over over +  1+ 0fffe and >r  type
  ibc!				\ restore flags
  dpr!  ;			\ restore original data page
