((
        MPEPBIO.FTH

        Author: S Pelc

        Date started:   11/06/88
        Last Modified:  14/08/91

        MPE RTX-2000 PowerBoard I/O handlers.


        Copyright (C) 1988 MicroProcessor Engineering

        Released for use with the MPE/Nautilus Cross Compiler by:

        MicroProcessor Engineering
        133 Hill Lane
        Shirley
        Southampton SO1 5AF
        England

        tel: (+44) 703 631441
))



\ base addresses
\

hex
0FFF8 equ cs8254           \ 8254 timer
0FFF0 equ cs8530           \ 8530 2-channel serial chip
0FFE8 equ cs8255           \ 8255 parallel i/o
0FFE0 equ cs5380           \ 5380 SCSI chip
0FFD8 equ csdack           \ 5380 DACK pin
0FFD0 equ cseop            \ 5380 EOP pin



\ 8254 timer                                       sfp 28/07/88
\

hex

cs8254 7 + equ control-8254
cs8254 5 + equ ch2-8254
cs8254 3 + equ ch1-8254
cs8254 1 + equ ch0-8254

: settle-8254
  08 for next  ;                        \ settling time



\ init-8254                                        sfp 19/04/90
\

hex

: init-8254     \ -- ; channels 0,2 as 9600 baud, 1 as 1ms
  036 control-8254 c!  settle-8254      \ select timer channel
  ch0-lo-value ch0-8254 c!  settle-8254 \ low timer value
  ch0-hi-value ch0-8254 c!  settle-8254 \ high timer value
  076 control-8254 c!  settle-8254      \ channel 1, mode 3
  041 ch1-8254 c!  settle-8254          \
  00 ch1-8254 c!  settle-8254
  0B6 control-8254 c!  settle-8254      \ channel 2, mode 3
  010 ch2-8254 c!  settle-8254          \ /10000 = /02710h
  027 ch2-8254 c!  settle-8254  ;




\ 8255 parallel i/o                                sfp 11/06/88
\

hex

cs8255 7 + equ control-8255             \ identify ports
cs8255 5 + equ pc-8255
cs8255 3 + equ pb-8255
cs8255 1 + equ pa-8255

: settle-8255   \ -- ; lets 8255 setlle down
  010 for next  ;

: init-8255     \ -- ; Mode 0, PA o/p, PB o/p, PCH i/p, PCL o/p
  08A control-8255 c!  settle-8255
  07 pc-8255 c!  settle-8255  ;




\ 8530 i/o                                         sfp 11/06/88
\

cs8530 1 + equ cmd-b
cs8530 3 + equ cmd-a
cs8530 5 + equ data-b
cs8530 7 + equ data-a

: settle-8530   \ -- ; settling delay - NEEDED!
  010 for next  ;                       \ settle

HEX

: WRAREG	( data reg -- )
  0F AND cmd-a c!  settle-8530          \ put reg num in wr0
  cmd-a c!  settle-8530  ;              \ put data in reg

: RDAREG	( reg -- data )
  0F AND cmd-a c!  settle-8530          \ put reg num in wr0
  cmd-a c@  0FF AND  settle-8530   ;    \ get data, & mask it

: WRBREG	( data reg -- )
  0F AND  cmd-b c!  settle-8530         \ put reg num in wr0
  cmd-b c!  settle-8530  ;              \ put data in reg

: RDBREG	( reg -- data )
  0F AND  cmd-b c!  settle-8530         \ put reg num in wr0
  cmd-b c@  0FF AND  settle-8530   ;    \ get data, & mask it

: init-8530-a	\ -- ; initialise channel A
  0C6 09 WRAREG				\ hardware reset
  04E 04 WRAREG				\ *16 8s  2 stop bit
  0C1 03 WRAREG				\ 8 bits per char en rx
  0EA 05 WRAREG				\ 8 bits per char en tx
  000 06 WRAREG
  000 07 WRAREG
  000 0A WRAREG
  005 0B WRAREG				\ set clocks
  006 0C WRAREG				\ low time constant
  000 0D WRAREG				\ top time constant
  0A0 0E WRAREG  ;			\ clock sources

: init-8530-b	\ -- ; hardware reset done by INIT-82530-A
  04E 04 wrbreg				\ *16 8s  2 stop bit
  0C1 03 wrbreg				\ 8 bits per char en rx
  0EA 05 wrbreg				\ 8 bits per char en tx
  000 06 wrbreg
  000 07 wrbreg
  000 0A wrbreg
  005 0B wrbreg				\ set clocks
  006 0C wrbreg				\ low time constant
  000 0D wrbreg				\ top time constant 19200 Baud
  0A0 0E wrbreg  ;			\ clock sources




\ 82530 SCC interface
\

HEX

: TXA?          \ -- t/f ; true when ready for another character
  cmd-a c@ 4 AND  ;

: RXA?          \ -- t/f ; true when character available
  cmd-a c@ 1 AND  ;

: txchara       \ char -- ; sends character - N.B. not wait
  data-a c!  ;

: TXA           \ char -- ; sends character, waits first
  begin  TXA?  until
  txchara  ;

: rxchara       \ -- char ; reads last character received
  data-a c@ 0FF AND  ;

: RXA           \ -- char ; waits for next character
  begin  RXA?  until
  rxchara  ;

: TXB?          \ -- t/f
  cmd-b c@ 4 AND  ;

: RXB?          \ -- t/f
  cmd-b c@ 1 AND  ;

: TXB           \ char --
  begin  TXB?  until
  data-b c!  ;

: RXB           \ -- c
  begin  RXB?  until
  data-b c@ 0FF AND  ;




\ Init-Hardware                                    sfp 19/04/90
\

hex

: Init-Hardware         \ --
  07fff for  noop noop noop  next       \ let hardware settle
  init-8254  init-8255                  \ initialise hardware
  init-8530-a  init-8530-b  ;

: read-character        \ -- n
  rxa  ;

: send-character        \ n --
  txa  ;
