((
        STEMONIO.FTH

        Author: S Pelc

        Date started:   01/09/90
        Last modified:  13/08/91


        MPE RTX-2001 STE PowerBoard I/O handlers

        Copyright (C) 1988 MicroProcessor Engineering

        Released for use with the MPE/Nautilus Cross Compiler by:

        MicroProcessor Engineering
        133 Hill Lane
        Shirley
        Southampton SO1 5AF
        England
       
        tel: (+44) 703 631441
))


Only Forth Definitions




\ 2691 drivers - register allocation
\

hex

0FFF1
  dup      equ cs2691
  dup 0 +  equ 2691-mr1/2
  dup 2 +  equ 2691-sr          dup 2 + equ 2691-csr
  dup 4 +  equ 2691-cr
  dup 6 +  equ 2691-rhr         dup 6 + equ 2691-thr
  dup 8 +  equ 2691-acr
  dup A +  equ 2691-isr         dup A + equ 2691-imr
  dup C +  equ 2691-ctu
  dup E +  equ 2691-ctl
drop




\ init-2691                                        sfp 01/09/90
\

hex

: settle-2691   \ -- ; 2691 requires delays after some writes
  080 for next  ;

: init-2691     \ -- ; initialise UART
  010 2691-cr c!        settle-2691     \ reset
  008 2691-acr c!       settle-2691     \ enable oscillator
  013 2691-mr1/2 c!     settle-2691     \ modes 1, 8 bits, Np
  00F 2691-mr1/2 c!     settle-2691     \ modes 2, 2 stops
  0CC 2691-csr c!       settle-2691     \ >> 38k4 baud rate <<
  000 2691-imr c!       settle-2691     \ interrupts off
  075 2691-cr c!        settle-2691  ;  \ enable RX & TX




\ (emit-2691)                                      sfp 01/09/90
\

: (emit-2691)   \ char --
  begin  2691-sr c@  04 and  until      \ wait for space
  2691-thr c!  ;                        \ send character


: (emit)        \ char --
  begin  2691-sr c@  04 and  until      \ wait for space
  2691-thr c!  ;                        \ send character




\ (key?-2691)
\

: (key?-2691)   \ -- t/f
  2691-sr c@  01 and                    \ test receive bit
  if  -1  else  0  endif  ;             \ return flag




\ (key-2691)
\

: (key-2691)    \ -- char
  begin  2691-sr c@  01 and  until      \ test receive bit
  2691-rhr c@  ;                        \ read buffer



\ baud 

: baud          \ rate --
  case
    38400 of  $0CC  endof
     9600 of  $0BB  endof
     4800 of  $009  endof
     2400 of  $008  endof
     1200 of  $006  endof
      300 of  $004  endof
      110 of  $001  endof
              $0BB swap			\ default to 9600 baud
  endcase
  2691-csr c!  settle-2691		\ set baud rate
;

\ Init-Hardware                                    sfp 01/09/90
\

hex

: Init-Hardware \ -- ; board and peripheral initialisation
  07fff for  noop noop noop  next       \ let hardware settle
  init-2691                             \ initialise hardware
  0efff for  r@ c@  r@ c!  next         \ copy ROM into RAM
  00010 3 g!  noop                      \ turn ROM off
  BAUD-RATE baud                      \ set selected baud rate
  ;


: read-character  ( -- b )
  (key-2691)  ;


: send-character  ( b -- )
  (emit)  ;
































