((

        SUPPORT.FTH

        Author: S Pelc, P Galliene

        Date started:   1989
        Last modified:  13/08/91


        SUPPORT contains secondaries needed by the monitor.


        Copyright (c) 1989, 1990, 1991

        MicroProcessor Engineering Ltd.
        133 Hill Lane
        Southampton SO1 5AF
        England

        tel: (+44) 703 631441
))



\ TRUE FALSE .. J Lee 13/08/91
\

decimal

-1 constant TRUE
 0 constant FALSE




\ Off Bounds Rot ?Dup 2Dup Pick
\

: Bounds	( start len -- end start )
  over + swap  ;

: Off		( addr -- )
  0 swap !  ;

: Rot		( n1 n2 n3 -- n2 n3 n1 )
  >r swap r> swap  ;

: pick          \ n1 -- n2              ; only for the sake of compatibility
  dup
  if  md@ >r  sr@ >r
      dup md!
      begin  swap >r 1- dup  while repeat	\ while repeat = until 
      drop
      dup sr!
      md@
      begin  r>  swap 1- dup  while repeat	\ while repeat = until
      drop
      sr@
      r> sr!  r> md!
  else  drop  dup
  endif  ;




\ I (?Do) (Loop) .. Jon 31/10/90
\

: I		( -- n )
  ipr@ r>  r>  r@ md!  >r >r ipr! md@  ;

: (?Do)		( n1 n2 -- )
  over over =                   \ loop parameters the same?
  If                            \ y:
    drop drop  FALSE            \   discard parameters, FALSE for ?BRANCH
    EXIT
  Endif
  ipr@ sr! r> md!  >r >r  md@ >r sr@ ipr!       \ put parms. on Return stack
  TRUE  ;                       \ TRUE for ?BRANCH


: (Loop)	( -- )
  ipr@ r>                               \ preserve Page,Address
  1  r> dup md!  r> dup sr!             \ get parmaters
  swap -  over over  + 
  over xor and 0<  			\ end of loop?
  If                                    \ y:
    drop  >r ipr!  TRUE  EXIT           \   discard, return to Page,Address
  Endif                                 \   leaving TRUE for ?BRANCH
  sr@ + >r  md@ >r  >r ipr!             \ n: 
  FALSE  ;                              \   return parms, return to Page,Addr
                                        \   leaving FALSE for ?BRANCH




\ (Case) (Of) .. Jon 13/08/91
\

: (Case)        ( -- )
  ;


: (Of)          ( n n'--  | n )
  over = dup            \ items match?
  If  nip  Endif  ;     \ y:  TRUE for ?BRANCH, n: 'n', FALSE for ?BRANCH




\ ?Negate Abs
\

: ?Negate       ( n1 n2 -- -n1|n1 )
  0<
  If  negate Exit  Endif  ;

: Abs           ( n1 -- |n1| )
  Dup 0< if Negate Exit  endif  ;




\ DNegate ?DNegate DAbs
\

: DNegate       ( d -- -d )
  swap 0 swap -  swap 0 swap -c  ;

: ?DNegate      ( d n -- -d|d )
  0<
  If  dnegate  Endif  ;

: DAbs          ( d -- +d )
  dup ?dnegate  ;




\ < Max
\

: <             \ n1 n2 -- t/f
  [ $0aac1 ,code ]
  If  [ $0ae61 ,code ]  Endif
  [ $0ac41 ,code ]  ;

: max           \ n1 n2 -- n1|n2
  2dup <
  if swap endif
  drop  ;




\ um* *
\

decimal

: UM*           \ u1 u2 -- ud
  md!					\ set up MD
  0					\ initialise TOS
  0+					\ clear CR0
  2*'					\ clear CR1
  u*' u*' u*' u*'  u*' u*' u*' u*'	\ 16 steps of u*'
  u*' u*' u*' u*'  u*' u*' u*' u*'  ;

: *             \ n1 n2 -- n3
  um* drop  ;				\ see RTX Prog Ref



\ um/mod m/mod /mod /
\

decimal

: um/mod        ( ud u -- urem uquot )
  md!  0+ d2* 
  u/1'  u/' u/' u/' u/'  u/' u/' u/' u/'  u/' u/' u/' u/'  u/' u/'  u/"
  swap  ;

: m/mod         ( d1 n2 -- rem quot )
  ?dup
  if  dup >r 2dup xor >r >r dabs r@ abs um/mod
      swap r> 0< ?negate
      swap r> 0<
      if  negate over
          if  1- r@ rot - swap  endif
      endif
      r> drop
  endif   ;

: /mod          ( n1 n2 -- rem quot )
  >r s>d r> m/mod   ;

: /             ( n1 n2 -- quot )
  /mod nip ;




\ = <> u>
\

: =             ( w1 w2 -- t|f )
  xor
  If  0 Exit  Endif
  -1  ;                                 \ get true

: <>            ( w1 w2 -- t|f )
  xor
  If  -1 Exit  Endif                    \ get true and leave
  0  ;

: U>            \ u1 u2 -- t|f
  Swap - c2/ 0<
  IF  0 Exit  THEN
  -1  ;




\ Cmove
\

: CMove         ( source dest len -- )
  Dup                                   \ if something
  If  1-
      For  over c@ over c!              \ copy a byte
           swap 1+  swap 1+             \ step on
      Next                              \ till done
   Else  drop                           \ lose len
  Endif
  drop drop  ;                          \ lose addresses




\ Long memory operators
\

: @l		\ addr page -- n
  dpr@ >r  dpr!  
  seldpr @ selcpr
  r> dpr!  ;

: c@l		\ addr page -- b
  dpr@ >r  dpr!  
  seldpr c@ selcpr
  r> dpr!  ;

: !l		\ n addr page --
  dpr@ >r  dpr!  
  seldpr ! selcpr
  r> dpr!  ;

: c!l		\ b addr page --
  dpr@ >r  dpr!  
  seldpr c! selcpr
  r> dpr!  ;


\ (Init) to initialise Forth

: (Init)        ( -- )
  RAM-PAGE dpr!				\ set monitor data page
  0 9 g!  ;                             \ reset stacks

