\ MPE RTX-2010 low level target code               J Lee 17/09/91
pto

Released for use with the MPE Forth Cross Compiler by:

MicroProcessor Engineering
133 Hill Lane
Shirley
Southampton SO1 5AF
England

tel: (+44) 703 631441
fax: (+44) 703 339691

\ >>n <<n >>8 <<8                                  sfp 12/04/90

: >>n		                \ 16b n -- 16b
  1 - Of( U2/ [\\]			\ Shift Right n Bits
;

: <<n		                \ 16b n -- 16b
  1 - Of( 2*  [\\]			\ Shift Left n Bits
;

: >>8		                \ n1 -- n2
  7 Of( u2/  [\\]  
;

: <<8		                \ n1 -- n2
  7 Of( 2*  [\\]  
;

\ Stack Ops .......................................sfp 13/04/88

: Rot		                \ n1 n2 n3 -- n2 n3 n1
  >R Swap R> Swap			\
;

: 2Drop		                \ n1 n2 --
  Drop Drop				\
;

: 2Dup		                \ n1 n2 -- n1 n2 n1 n2
  Over Over				\
;

: 2Swap		                \ n1..n4 -- n3 n4 n1 n2
  >r >r md! sr!  r> r> sr@ md@  
;

: 2Over		                \ n1..n4 -- n1..n4 n1 n2
  >r >r over over md! sr!  r> r> sr@ md@  
;

: -Rot		                \ n1 n2 n3 -- n3 n1 n2
  Swap >R  Swap R>			\
;

: Tuck		                \ n1 n2 -- n2 n1 n2
  Swap Over				\
;

: ?Dup		                \ n -- n n | n -- n
  Dup					\
  if
    Dup Exit
  endif
;

\ pick                                             Jon 12/07/89

: pick		                \ n1 -- n2 ; only for the sake of compatibility
  dup
  if
    dup md!
    begin
      swap >r 1- dup 0=
    until
    drop
    dup sr!
    md@
    begin
      r>  swap 1- dup 0=
    until
    drop
    sr@
  else
    drop  dup
  endif
;

\ roll                                             sfp 27/09/88

: roll		                \ n1 -- n2 ; only for the sake of compatibility
  dup
  if
    dup md!
    begin
      swap >r  1- dup 0=
    until
    drop
    sr!
    md@
    begin
      r>  swap 1- dup 0=
    until
    drop
    sr@
  else
    drop
  endif
;

\ sp@ sp! rp@ rp!                                  sfp 03/09/90
hex

: sp@		                \ -- n ; get parameter stack pointer
  9 g@ 0FF and				\ some oddities
;

: sp!		                \ n -- ; set parameter stack pointer
  0FF and  9 g@ 0FF00 and  or  9 g!  
;

: rp@		                \ -- n ; get return stack pointer
  9 g@ 0100 - >>8			\ 1 for RP@
;

: rp!		                \ n -- ; set return stack pointer
  1+  <<8				\ return will decrement
  9 g@ 1-  0FF and  or  9 g!		\ n already on stack
;

\ stack-top                                      J Lee 03/12/92
\ this value is used in ?STACK for error checking
$F8 equ Stack-Top

\ +! C+! 2! 2@                                     sfp 13/04/88

: +!		                \ n a --
  >R R@ @ + R> !			\
;

: C+!		                \ n a --
  >R R@ C@ + R> C!			\
;

: 2!		                \ d a --
  !++ !					\
;

: 2@		                \ a -- d
  @++ @ swap				\
;

\ Incr Decr                                        RTX 15/04/88

: Incr		                \ a --
  >r  r@ @  1+  r> !			\
;

: Decr		                \
  >r  r@ @  1-  r> !			\
;

\ here allot ,                                     RTX 13/04/88

: Here		                \ -- a
  DP @					\
;

: Allot		                \ n --
  DP +!					\
;

: ,		                \ n --
  Here  2 Allot  !			\
;

: C,		                \ n --
  Here  1 Allot  C!			\
;

\ even align                                     RTX 14/04/88
Hex

: even		                \ addr -- addr'
  1+ 0FFFE and				\
;

: align		                \ --
  Here 1 and				\
  if
    0 c,
  endif
;

\ s>d                                              sfp 03/09/90
hex

: S>D		                \ n -- d
  dup 0<  
;

\ um* *                                          J Lee 17/09/91
decimal

: UM*		                \ u1 u2 -- ud
  mulu mlr@ mhr@  
;

: *		                \ n1 n2 -- n3
  muls mlr@ nip  
;

\ m*                                             J Lee 17/09/91
hex

: m*		                \ n1 n2 -- d
  muls mlr@ mhr@  
;

\ um/mod dsqrt sqrt                              J Lee 17/09/91
decimal

: um/mod	                \ ud u -- urem uquot
  md! 0+ d2*
  u/1' u/' u/' u/'  u/' u/' u/' u/'
  u/' u/' u/' u/'  u/' u/' u/' u/"
  swap  
;
hex

: dsqrt		                \ ud -- u ; see RTX Prog Ref p109
  0 md! 8000 sr!
  d2* s1' s' s' s' s' s' s' s' s' s' s' s' s' s' s' s' s"
  d2/ drop  
;

: sqrt		                \ u1 -- u2 ; square root of single number
  0 dsqrt  
;

\ um/mod m/mod                                     sfp 12/04/90
decimal

: m/mod		                \ d1 n2 -- rem quot
  ?dup
  if
    dup >r  2dup xor >r  >r dabs r@ abs um/mod
    swap r> 0< ?negate
    swap r> 0<
    if
      negate over
      if
        1- r@ rot - swap
      endif
    endif
    r> drop
  endif
;

\ /mod / mod */mod */                              sfp 13/04/88

: /mod		                \ n1 n2 -- rem quot
  >r s>d r> m/mod			\
;

: /		                \ n1 n2 -- quot
  /mod nip				\
;

: mod		                \ n1 n2 -- rem
  /mod drop				\
;

: */MOD		                \ n1 n2 n3 -- r q
  >R  M*  R> M/MOD			\
;

: */		                \ n1 n2 n3 -- q
  */MOD Nip				\
;

\ mu/mod ?negate abs                               sfp 03/09/90

: MU/MOD	                \ ud1 ud2 -- u3 ud4
  >R 0 R@ UM/MOD R> SWAP >R UM/MOD R>	\
;

: ?Negate	                \ n1 n2 -- -n1|n1
  0<					\
  if
    negate exit
  endif
;

: Abs		                \ n1 -- |n1|
  Dup 0<				\
  if
    negate exit
  endif
;

\ Arithmetic Ops .................................. \  30/07/91

: MAX		                \ n n -- n
  Over Over <				\
  if
    Nip Exit
  endif					\
  Drop					\
;

: MIN		                \ n n -- n
  Over Over <				\
  if
    Drop Exit
  endif					\
  Nip					\
;

\ d+ d-                                            sfp 13/04/88

: D+		                \ d1 d2 -- d1+d2
  >R Swap >R  +  R> R> +c		\
;

: D-		                \ d1 d2 -- d1+d2
  >R Swap >R  -  R> R> -c		\
;

\ DNegate ?DNegate DAbs                            sfp 13/04/88

: DNegate	                \ d1 -- -d1
  swap 0 swap -  swap 0 swap -c		\
;

: ?DNegate	                \ d n -- -d|d
  0<					\
  if
    DNegate
  endif
;

: DAbs		                \ d -- +d
  Dup ?DNegate				\
;

\ 0> 0= 0<>                                      J Lee 17/09/91

: 0>		                \ n -- t|f
  dup 0= swap 0< or not
\  negate 0<				\ faster... but works for range
					\ -32767..32768 not -32768 to 32767
;

\ : 0=                                    \ n -- t|f
\  if  0 Exit  endif                      \
\  -1  ;                                 \

: 0<>		                \ n -- t|f
  if
    -1 Exit
  endif					\ get true (-1) & leave
  0					\
;

\ = <>                                             sfp 13/04/88

: =		                \ w1 w2 -- t|f
  XOR					\
  if
    0 Exit
  endif					\
  -1					\ get true
;

: <>		                \ w1 w2 -- t|f
  XOR					\
  if
    -1 Exit
  endif					\ get true and leave
  0					\
;

\ Relational Ops ................................. sfp 03/09/90

: U<		                \ u1 u2 -- t|f
  - c2/ 0<				\
  if
    0 Exit
  endif					\
  -1					\
;

: U>		                \ u1 u2 -- t|f
  Swap - c2/ 0<				\
  if
    0 Exit
  endif					\
  -1					\
;

\ < >                                              sfp 01/10/90
hex

: <		                \ n1 n2 -- t/f
  [ 0AAC1 ,Code ]
  if
    [ 0AE61 ,Code ]
  endif
  [ 0AC41 ,Code ] 
;

: >		                \ n1 n2 -- t/f
  [ 0AAC1 ,Code ]
  if
    [ 0AF61 ,Code ]
  endif
  [ 0A441 ,Code ]  
;

\ <= >= within?                                    sfp 01/10/90

: <=		                \ n1 n2 -- t|f
  > 0= 
;

: >=		                \ n1 n2 -- t|f
  < 0= 
;

: Within?	                \ n low high -- t|f
  >R  Over >  Swap R> >  Or 0=		\ inclusive & signed
;

\ set-bit reset-bit toggle-bit test-bit            sfp 25/10/88

: Set-Bit	                \ mask addr --
  >r  r@ C@  Or  r> C!			\
;

: Reset-Bit	                \ mask addr --
  >r  Not  r@ C@ And  r> C!		\
;

: Toggle-Bit	                \ mask addr --
  >r  r@ C@  Xor  r> C!			\
;

: Test-Bit	                \ mask addr -- n
  C@ And				\
;

\ On Off                                           sfp 13/04/88

: ON		                \ a --
  -1 Swap !				\ ! true
;

: OFF		                \ a --
  0 Swap !				\
;

\ Bounds Count (("))                             J Lee 12/03/91
hex

: Bounds	                \ a len -- a+len a
  Over + Swap				\
;

: Count		                \ a -- a+1 len
  Dup 1+ Swap C@			\
;

: (("))		                \ -- a
  R>					\ save return address
  R>					\ get caller's return
  dup  count + Even			\ address of string end
  >r					\ modify caller's return
  Swap >R				\ restore return address
;

\ Upc Upper                                      J Lee 12/03/91
Hex

: Upc		                \ c -- c'
  Dup  ascii a ascii z Within?		\
  if
    0DF and
  endif
;

: Upper		                \ a len --
  bounds				\
  ?do
    i c@ upc i c!
  loop
;

\ Digit                                          J Lee 02/12/92
decimal

: Digit		                \ char base -- n t|f
  Swap  upc  Ascii 0 - DUP 0<		\ chars<'0'is invalid
  if
    2Drop 0  Exit
  endif					\ so quit
  Dup 09 >				\ range 0..9 ?
  if
    7 -  Dup #10 <			\ No! was char >= 'A'?
    if
      2Drop 0  Exit
    endif				\ No! bad char quit
  endif					\ -- base n
  Swap Over >				\ base > n?
  if
    -1 Exit
  endif					\ Yes, Success quit
  Drop 0				\ Failed!!
;

\ scan                                             sfp 12/04/90

: Scan		                \ addr len char -- addr len
  >r					\ stash character
  begin
    dup					\ if any characters left
  while
    over c@ r@ =			\ see if same
    if
      r> drop exit
    endif				\ exit if same
    swap 1+  swap 1-			\ step on
  repeat
  r> drop  
;

\ skip                                             RTX 13/04/88

: Skip		                \ addr len char -- addr len
  >r					\ stash character
  begin
    dup					\ if any characters left
  while
    over c@ r@ <>			\ see if different
    if
      r> drop exit
    endif				\ exit if different
    swap 1+  swap 1-			\ step on
  repeat
  r> drop  
;

\ S=                                               sfp 13/04/88

: s=		                \ addr1 addr2 len -- t/f
  >r  -1 -rot  r>			\ assume success
  0					\ for all characters
  ?do
    over c@ over c@ <>			\ if not the same
    if
      rot 1+ -rot  leave
    endif				\ set false; -1 -> 0
    swap 1+  swap 1+			\ increment addresses
  loop					\
  2drop					\ remove addresses
;

\ Cmove                                            sfp 13/04/88

: CMove		                \ a1 a2 n --
  ?Dup					\ if something
  if
    1-					\
    for
      Over C@ Over C!			\ copy a byte
      Swap 1+  Swap 1+			\ step on
    next				\ till done
  endif					\
  2Drop					\ lose addresses
;

\ Cmove>                                           sfp 13/04/88

: CMove>	                \ a1 a2 n --
  ?Dup					\ if something
  if
    >r  swap r@ +  swap r@ +  r>	\ a1+n a2+n n --
    1-					\
    for
      Swap 1-  Swap 1-			\ Step back
      Over C@ Over C!			\ copy a byte
    next				\ till done
  endif					\
  2Drop					\ lose addresses
;

\ move fill                                        RTX 14/04/88

: Move		                \ addr1 addr2 count -- ; intelligent cmove
  >R					\ hide count value
  2DUP U<				\ compare addresses
  if
    r> CMOVE>				\ move down
  else
    r> CMOVE				\ move up
  endif
;

: Fill		                \ a1 len b --
  -Rot Bounds				\
  ?do
    Dup I C!
  loop					\
  Drop					\
;

\ ($+)                                             sfp 13/04/88

: ($+)		                \ a1 len a2 --
  Swap					\ get len on top
  ?dup 0=
  if
    2Drop Exit
  endif					\ get out if len=0
  1-					\ dec for FOR
  for
    Over C@				\ get Ith byte from a1
    Over Count + c!			\ stick at end of a2
    1 over c+!				\ in count byte of a2
  next					\
  2Drop					\
;

\ /string                                          RTX 14/04/88

: /string	                \ addr len offset -- a+o l-o
  >r  swap r@ +  swap r> -  
;

\ Name> >name immediate?                           RTX 15/04/88
hex

: Name>		                \ nfa -- cfa
  Count 01F and +			\ end of string
  Even					\ word aligned
;

: >Name		                \ cfa -- nfa
  begin					\ chars have no parity
    1- Dup C@ 080 And			\ so if word has
  until
;
\ top bit set its nfa.

: Immediate?	                \ nfa -- -1=is| 1=not
  C@ 040 AND				\ is it immediate?
  if
    1 Exit
  endif					\ yes
  -1					\ no
;

\ Names= ......................................... Jon 12/12/88
HEX					\

: Names=	                \ a-text a-thread -- t|f
  Over C@  Over C@ 03F AND  =		\ lengths =?
  if
    Over C@ >R				\ Yes, get count
    1+ Swap 1+				\ bypass counts
    R> S= Exit				\ Check words & quit
  endif					\
  Drop Drop 0				\ No, leave false
;

\ Lookup ......................................... Jon 12/12/88

: Lookup	                \ '$ 'Thread --
\      '$ f | cfa (-1|1)
  begin					\
    @ dup				\ Get next NFA
  while					\ while not end of list
    Over Over Names=			\ Names = ?
    if
      Nip Dup Name>			\ Yes, chuck name
      Swap Immediate?  Exit		\
    endif				\
    2-					\
  repeat
;

\ v-find ......................................... Jon 13/12/88

: V-Find	                \ '$ a --
\  cfa 1 | cfa -1 | '$ 0
  dup					\ Voc exists?
  if
    Hash-Thread  Lookup Exit		\ yes, look up name
  endif					\
;

\ Constants & Variables - RAM versions             sfp 03/09/90
Hex

: Variable	                \ --
  Create 0 ,				\ RAM only version
;

: Constant	                \ --
  Create  -2 Allot			\ build header
  0DE20 ,  ,  \\			\ lay code and data
;

: User		                \ --
  Create  ,
  Does> @ User-base @ +
;

\ DoDoes                                           sfp 13/04/88

: DoDoes	                \ --
  Compile R>  \\			\
;

\ (does>) does>                                    sfp 13/04/88

: (Does>)	                \ --
  R> U2/  Latest Name> !		\
;

: Does>		                \ --
  Compile (Does>)  Compile R>  \\	\
; IMMEDIATE				\

\ : and other magic                                sfp 02/08/88
target-only

: :		                \ starts new word
  ?Exec  !Csp  ( Current @ Context ! )	\ error protection
  Create  -2 Allot			\ header N.B. no CFA
  Smudge  C-Loop			\ call compiler
;
host&target

\ Deferred Words - RAM version                     sfp 03/09/90

: Crash		                \ --
  1 Abort" Uninitialised deferred word"	\
;

: Defer		                \ --
  Create  -2 Allot			\ Build header
  State @  State On			\
  Compile Crash  Compile Exit		\
  State !				\
;

\ Deferred Words - RAM Version                     Jon 10/07/89

: Assign	                \ -- a
  ' U2/  State @			\
  if
    [Compile] Literal
  endif
; IMMEDIATE				\

: (To-Do)	                \ Exec-Code --
  r> dup 2+ >r  @ !			\
;

: To-Do		                \
  State @				\
  if
    Compile (To-Do)  ' ,		\
  else
    ' !					\
  endif
; IMMEDIATE				\

\ mem-top >data                                     \  20/11/90
variable ram-top			\ holds top of RAM

: mem-top	                \ -- addr
  ram-top @
;

: >data
  >body
;

