\ MPE PowerForth control file PDC-2001-8 PC comms card

pto

Copyright (c) 1989, 1990, 1994
MicroProcessor Engineering Ltd.
133 Hill Lane
Southampton SO1 5AF
England

tel: (+44) 703 631441
fax: (+44) 703 339691
net: mpe@cix.compulink.co.uk

\ Compiler Directives for RTX Power Forth .......J Lee 08/11/90

only forth definitions decimal

Hex 0320 Emu-Base                     \ Set I/O address
e27256 16bit output-emulator          \ Type and Bus Width


\ Configure compiler to appropriate processor
  all from-file rtx2001.def

Floats				\ turn on floating point

CROSS-COMPILE                   \ turn compiler on

ALIGN                           \ target is word aligned

no-log				\ no progress log

only forth definitions          \ initial search order

\ Define target configuration here. These flags define whether certain
\ files are loaded, and whether certain initialisation words are included
\ in COLD. Note that selection of the multitasker is defined by the value
\ set for #TASKS on the next page.
\
1 equ romforth?				\ true to load romforth extensions
0 equ paged?				\ true if target is paged
0 equ softfp?				\ true if target needs floating point


\ Memory layout                                  J  \  21/11/90

HEX

	00000 0efff kernel PDC-8	\ kernel area
	00000 00000 0 data-page DUMMY	\ data is dummy because RAM target

\        $0000 in-emulator PDC-8		\ kernel output to EPEM

use-code PDC-8
use-data DUMMY

$8000 equ appl-rom    		\ where ROMForth loads its code
$efff equ appl-rom-end


\ Clock rate and serial rate                        \  24/10/91

Decimal

 8000 equ clock-khz     \ clock speed in kHz

19200 equ serial-baud   \ serial line rate in baud


\ character equates                                sfp 12/04/90

HEX

20 Equ Abl
0D Equ Acr      2E Equ Adot
07 Equ Abell     8 Equ Bsin
08 Equ Bsout    0A Equ Alf
0C Equ Ffeed


\ interrupt handler equates

0 equ Int-Base          \ int vector base - must be 1Kb aligned


\ Buffer Defs                                      sfp 01/09/90

$0040 equ stack-size			\ size of RTX stack

$0001 Equ #tasks    			\ total number of tasks
$0100 Equ per-task			\ size of user area for eack task

#tasks per-task * Equ Us		\ total size of user area

\ Main kernel files

  Decimal all from-file startup.fth		\ Startup Code

  Decimal all from-file code2001.fth		\ Low Level Primitives
  Decimal all from-file kernel.fth		\ Main Forth Kernel
  Decimal all from-file rtx-tool.fth		\ Toolkit
  Decimal all from-file ucodertx.fth		\ RTX OpCodes
  decimal all from-file vectors			\ vector table
  decimal all from-file interupt		\ interrupt handler code
  decimal all from-file examples\ints.fth
  Decimal all from-file drivers\pdcio-i.fth	\ UART driver code

#tasks 1 > 
if(
  Decimal all from-file multirtx.fth		
)endif

softfp?
if(
  Decimal all from-file ..\softfp\fpramhi.fth	
  Decimal all from-file ..\softfp\softfp.fth	
)endif


\ the ROMForth files

romforth?
if(
  : relink  ;
  : empty-buffers  ;
  decimal all from-file ..\romforth\iodef     \ link i/o
\  decimal all from-file ..\romforth\link      \ relink code	
  decimal all from-file ..\romforth\filetran  \ ascii file u/l
\  decimal all from-file ..\romforth\bin-down  \ XMODEM dn/ld
\  decimal all from-file ..\romforth\hex-down  \ Intel Hex down
  decimal all from-file ..\romforth\textfile  \ XSHELL textfiles
\  decimal all from-file ..\romforth\blocks    \ XSHELL blocks
)endif


\ target sign on

internal

: .cpu 		\ --
  ." MPE RTX 2001 RAM PowerForth "  \ sign on
;
 
external

\ end of compilation                                \  07/08/91

only forth definitions                  \ restore search orders

: Forth-83  ;   Is-Fence


\ Application files here ...


\ The end

FINIS
