\ MPE RTX-2000 PowerBoard I/O handlers               sfp 25/05/89
pto

Copyright (C) 1989 MicroProcessor Engineering

Released for use with the MPE RTX Cross Compiler by:

MicroProcessor Engineering
133 Hill Lane
Shirley
Southampton SO1 5AF
England

tel: (+44) 703 631441
fax: (+44) 703 339691

\ pc-adaptor drivers                               sfp 11/08/90

Only Forth   Also I/O Definitions

\ command constants - Forth commands               sfp 11/08/90
decimal

0 constant f-noop
1 constant f-key?
2 constant f-key
3 constant f-emit
4 constant f-pbr
5 constant f-pbw
6 constant f-pbu
7 constant f-pbi
8 constant f-edit
9 constant f-fred
10 constant f-disconnect
11 constant f-mandel{
12 constant f-plot
13 constant f-}mandel
14 constant f-get-mode
15 constant f-set-mode

\ status constants                                 sfp 11/08/90

0       constant success
-1      constant bad-command
-2      constant no-scr-file
-3      constant eof
-4      constant write-truncated
-5      constant user-aborted

\ pc adaptor variables                             sfp 11/08/90
hex

variable pc-cmd				\ host commands executed by target
0F700 pc-cmd !				\  set default
variable rtx-cmd			\ target commands executed by host
0F780 rtx-cmd !				\  set default
variable pc-seg				\ buffer segment in PC space
0CC00 pc-seg !				\  set default
variable pc-offset			\ buffer address in PC space
00000 pc-offset !			\  set default
variable last-nmi			\ value of last reset/NMI message
00000 last-nmi !			\  set default

\ adaptor addresses                                APW 26/01/90
hex

\ : equ constant ;

0F000 equ io-buffer			\ disk transfer buffer
0F400 equ io-blk			\ current block number
0F402 equ io-high-blk			\ high portion
0F404 equ io-updated			\ update flag
0F406 equ io-rtx-sem			\ rtx semaphore
0F408 equ io-pc-sem			\ pc semaphore
0F40A equ io-dest-id			\ 0=pc, -1=rtx
0F40B equ io-dest-handle		\ see text
0406 equ io-buff-len			\ length of all data
\ to be cleared

\ constants                                        sfp 25/05/89
hex

0400 equ io-b/buf			\ transfer buffer length
0406 constant io-hdbt			\ length + flags

\ command                                          sfp 26/05/89
decimal

: opcode			\ 2 byte opcode, 0 = noop
;

: status        2 +		\ 2 byte status, 0 = success
;

: owned         4 +		\ ID of owning task(s)/semaphore(s)
;

: com-start     6 +		\ set to start execution
;

: com-completed 7 +		\ set when command completed
;

: AX            16 +		\ simulate 8086 registers for INT021
;

: BX            18 +  
;

: CX            20 +  
;

: DX            22 +  
;

: SI            24 +
;

: DI            26 +  
;

: DS            28 +
;

: ES            30 +  
;

32 constant command			\ length of command record

\ rtx-buff pc-buff command?                        sfp 26/05/89
hex

: rtx-buff	                \ -- addr ; address of RTX command buffer
  rtx-cmd @				\ command buffer addr
;

: pc-buff	                \ -- addr ; address of PC command buffer
  pc-cmd @				\ command buffer addr
;

: command?	                \ addr -- t/f ; true if command ready
  com-start @ 0100 =  
;

\ start-host                                       sfp 26/05/89
hex

: start-host	                \ -- ; set execute flag
  rtx-buff com-start			\ command flag address
  1 over c!				\ set command code
  begin
    dup c@ 0FF <>			\ wait until acknowledge
  while
    pause				\
  repeat				\
  drop					\
;

\ wait-completion end-command                      sfp 26/05/89
hex

: wait-completion                \ wait for command to finish
  begin
    rtx-buff com-completed c@		\
    0FF <>				\ check completed flag
  while
    pause				\ spin if not set
  repeat
;

: end-command	                \ mark command as ended
  0 rtx-buff com-start !  
;

\ set-opcode pc-command                            sfp 26/05/89

: set-opcode	                \ class/function --
  rtx-buff opcode !  
;

: pc-command	                \ class/function --
  set-opcode
  start-host wait-completion  
;

\ pc-noop                                          sfp 25/05/89
hex

: pc-noop	                \ -- ; perform noop
  f-noop pc-command			\ execute command
  end-command				\ clear it
;

: flip		                \ -- exchange bytes - N.B. RTX-2000 only
  0100 um* or  
;

\ pc-key?                                          sfp 26/05/89

: pc-key?	                \ -- t/f
  f-key? pc-command			\ execute command
  rtx-buff ax @ flip			\ retrieve
  end-command				\ done
;

: pc-key	                \ -- char
  f-key pc-command			\ execute command
  rtx-buff ax @ flip			\ retrieve
  end-command				\ done
;

: pc-emit	                \ char --
  flip rtx-buff ax !			\ lay data
  f-emit pc-command  end-command	\ do it
  1 out +!                     
;

\ adap-empty-buffers adap-init                     sfp 11/08/90
hex

: adap-empty-buffers                \ -- ; clear io-buffer
  io-buffer io-buff-len erase		\ reset data area
  -1 io-blk !				\ set current block
;

: adap-init	                \ -- ; initialise buffers
  rtx-buff command erase		\ commands from RTX
  pc-buff command erase			\ commands from PC
  adap-empty-buffers			\ i/o buffer
  io-rtx-sem 6 erase			\ erase semaphores
  0FF io-dest-handle c!			\ mark as unused
  io-buffer 07FC + @ last-nmi !		\ reset interrupts
;

\ pc-pbi

: pc-pbi	                \ --
  0 flip rtx-buff ax !			\ adaptor page
  io-buffer flip rtx-buff bx !		\ adaptor base address
  f-pbi pc-command			\ execute command
  rtx-buff bx @ flip pc-offset !	\ adaptor PC offset
  rtx-buff cx @ flip pc-seg !		\ adaptor PC segment
  end-command				\ finish off
;

\ pc-pbr pc-blk-read                               sfp 10/06/89
hex

: pc-pbr	                \ n -- status
  flip rtx-buff ax !			\ put in block number
  f-pbr pc-command			\ execute command
  rtx-buff status @ flip		\ return status
  end-command				\ finish off
;

: pc-blk-read	                \ addr blk --
  pc-pbr disk-error !			\ perform function
  io-buffer swap 0400 cmove		\ copy data
;

\ pc-pbw pc-blk-write
hex

: pc-pbw	                \ n -- status
  flip rtx-buff ax c!			\ put in block number
  f-pbw pc-command			\ execute command
  rtx-buff status @ flip		\ return status
  end-command				\ finish off
;

: pc-blk-write	                \ addr blk --
  swap io-buffer 0400 cmove		\ copy data
  pc-pbw disk-error !			\ perform function
;

\ pc-pbu

: pc-pbu	                \ -- status
  f-pbu pc-command			\ execute command
  rtx-buff status @ flip		\ return status
  end-command				\ finish off
;

\ pc-using
hex

: $pc-using	                \ $addr -- status
  count					\ form addr + len
  rtx-buff command +			\ destination
  dup 040 erase				\ clean destination
  swap 03F min  cmove			\ copy data
  pc-pbu				\ form result
;

: pc-using	                \ -- ; pc-using <filename>
  bl word $pc-using			\ attempt to open file
  abort" Can't open file: no file open"	\
;

\ pc-edit pc-fred                                  sfp 10/06/89

: pc-fred	                \ n -- ; use host editor
  flip  rtx-buff ax !			\ set screen number
  f-fred pc-command			\ execute command
  rtx-buff ax @ flip  scr !		\ put back screen #
  end-command				\
;

: pc-edit	                \ -- ; use host editor
  scr @ pc-fred  
;

\ pc-plot                                          sfp 11/08/90

: pc-plot  			\ -- 
  f-plot pc-command end-command  
;

\ pc-plot                                          sfp 11/08/90

: pc-mandel{  			\ --
  f-mandel{ pc-command end-command  
;

: pc-}mandel			\ --
  f-}mandel pc-command end-command  
;

\ pc-disconnect

: pc-disconnect	                \ n -- ; disconnect with code n
  flip  rtx-buff ax !			\ set disconnect code
  f-disconnect pc-command		\ execute command
  end-command				\
;

: pc-bye	                \ -- ; disconnect and terminate server
  1 pc-disconnect  
;

: pc-host	                \ -- ; disconnect and execute host Forth
  2 pc-disconnect  
;

\ pc-io serial-io pc-disk                          sfp 10/06/89

: pc-io
  assign pc-emit to-do emit
  assign pc-key? to-do key?
  assign pc-key to-do key  
;

: serial-io
  Assign (Emit-A) To-Do Emit
  Assign (Key-A?) To-Do Key?
  Assign (Key-A)  To-Do Key  
;

: pc-disk
  assign pc-blk-read to-do blk-read
  assign pc-blk-write to-do blk-write  
;

\ loader                                           sfp 11/08/90

: pc-signon
  adap-init				\ initialise adaptor
  pc-disk				\ use pc for disk server
  pc-io					\ use pc for i/o
;
assign pc-signon to-do loader

\ Main Forth definitions                           APW 26/01/90
Only Forth  Also I/O  Also Forth Definitions

defer $using    assign $pc-using to-do $using
defer using     assign pc-using to-do using

: host          pc-host  
;

: bye           pc-bye  
;

: edit          pc-edit  
;

: fred          pc-fred  
;

: connect       adap-init pc-disk pc-io  
;

: reconnect     pc-disk pc-io  
;

: mandel{       pc-mandel{  
;

: }mandel       pc-}mandel  
;

\ the end                                       R. G.  04/02/90
Only Forth Definitions
