\ MPE RTX-2001 STE PowerBoard I/O handlers
((
Copyright (C) 1988 MicroProcessor Engineering

Released for use with the MPE/Nautilus Cross Compiler by:

MicroProcessor Engineering
133 Hill Lane
Shirley
Southampton SO1 5AF
England

tel: (+44) 703 631441
))

\ 2691 drivers - register allocation
hex

Only Forth  Also I/O Definitions

0FFF1
  dup      equ cs2691
  dup 0 +  equ 2691-mr1/2
  dup 2 +  equ 2691-sr          dup 2 + equ 2691-csr
  dup 4 +  equ 2691-cr
  dup 6 +  equ 2691-rhr         dup 6 + equ 2691-thr
  dup 8 +  equ 2691-acr
  dup A +  equ 2691-isr         dup A + equ 2691-imr
  dup C +  equ 2691-ctu
  dup E +  equ 2691-ctl
drop

\ init-2691                                        sfp 01/09/90

hex
: settle-2691   \ -- ; 2691 requires delays after some writes
  080 for next  ;

: init-2691     \ -- ; initialise UART
  010 2691-cr c!        settle-2691     \ reset
  008 2691-acr c!       settle-2691     \ enable oscillator
  013 2691-mr1/2 c!     settle-2691     \ modes 1, 8 bits, Np
  00F 2691-mr1/2 c!     settle-2691     \ modes 2, 2 stops
  0CC 2691-csr c!       settle-2691     \ >> 38k4 baud rate <<
  000 2691-imr c!       settle-2691     \ interrupts off
  075 2691-cr c!        settle-2691  ;  \ enable RX & TX

\ (emit-2691)                                      sfp 01/09/90

: (emit-2691)   \ char --
  begin  2691-sr c@  04 and  until      \ wait for space
  2691-thr c!                           \ send character
  Out Incr  ;                           \ count it

: (emit)        \ char --
  begin  2691-sr c@  04 and  until      \ wait for space
  2691-thr c!  ;                        \ send character

\ (key?-2691)

: (key?-2691)   \ -- t/f
  2691-sr c@  01 and                    \ test receive bit
  if  -1  else  0  endif  ;             \ return flag

\ (key-2691)

: (key-2691)    \ -- char
  begin
    (key?-2691) 0=
  while
    [ also forth definitions ]
    pause
    [ previous definitions ]
  repeat
  2691-rhr c@  ;                        \ read buffer

\ emit key? key                                    sfp 01/09/90

only forth also i/o also Forth definitions

Defer Emit      Assign (Emit-2691) To-Do Emit
Defer Key?      Assign (Key?-2691) To-Do Key?
Defer Key       Assign (Key-2691)  To-Do Key

\ Model definitions - STE PowerBoard 		    sfp 01/09/90
\ Define serial i/o words in any suitable way

defer ser-emit  assign (emit-2691)  to-do ser-emit
defer ser-key   assign (key-2691)   to-do ser-key
defer ser-key?  assign (key?-2691)  to-do ser-key?

only forth also i/o definitions

\ (type) (cr)                                      sfp 12/06/89

Decimal

: (Type)        \ addr len -- ; in terms of EMIT
  bounds                                \
  ?Do  I C@ Emit  Loop  ;               \

: (CR)          \ -- ; in terms of EMIT
  13 emit  10 emit  Out Off  ;          \

\ type cr                                          sfp 01/09/90

only forth also i/o also Forth definitions

Defer Type      Assign (Type)      To-Do Type
Defer CR        Assign (CR)        To-Do CR

\ baud                                             sfp 01/09/90
decimal

: baud          \ rate --
  case  38400 of  $0CC  endof
         9600 of  $0BB  endof
         4800 of  $009  endof
         2400 of  $008  endof
         1200 of  $006  endof
          300 of  $004  endof
          110 of  $001  endof
              $0BB swap
  endcase
  2691-csr c!  settle-2691  ;           \ set baud rate

\ Init-Hardware                                    sfp 01/09/90
hex

: Init-Hardware \ -- ; board and peripheral initialisation
  07fff for  noop noop noop  next       \ let hardware settle
  init-2691                             \ initialise hardware
  0efff for  r@ c@  r@ c!  next         \ copy ROM into RAM
  00010 3 g!  noop                      \ turn ROM off
  baud-rate @ baud                      \ set selected baud rate
  ;

only forth definitions

