\ RTX-2000 Target Code                               sfp 20/04/90

pto

Released for use with the MPE Forth Cross Compiler by:

MicroProcessor Engineering
133 Hill Lane
Shirley
Southampton SO1 5AF
England

tel: (+44) 703 631441

\ ; ...............................................sfp 27/07/88
hex

: ;		\ --
  ?Comp ?Csp
  [Compile] Exit  Smudge
  State Off
  R> Drop
; IMMEDIATE

decimal

\ Vocabulary ..................................... Jon 08/12/88

: Vocabulary	\ --
  Create                                \ RAM only version
    here voc-link @ , body> voc-link !  \ lay & update voc-link
    #threads @ dup ,                    \ lay no. of threads
    0 ?Do  0 ,  Loop                    \ allot threads
  Does>                                 \
    body> context !                     \ CFA in context
;

\ Primary Vocabularies ........................... sfp 20/04/90

Vocabulary Forth
Vocabulary Root
Vocabulary System
Vocabulary I/O

\ \\ [\\]                                          sfp 27/07/88

: \\            \ -- ; breaks optimiser chain
  Optimising Off
;

: [\\]          \ -- ; Immediate version of \\
  \\
; IMMEDIATE

: ,Code         \ n -- ; lays down opcode
  Dup 0<                                \ top bit set if Prim.
  If  Here 'Last !  Optimising On       \ Primitive, enable opt.
  Else  \\                              \ High level, disable
  Endif                                 \
  ,					\ lay opcode
;

\ Head Modifiers ................................. Jon 08/12/88
hex

: Latest	\ -- a
  Last @
;

: Smudge	\ --
  020 Latest Toggle-Bit
;

: IMMEDIATE	\ --
  040 Latest Set-Bit
;

decimal

\ Compiler Security .............................. sfp 27/07/88
hex

: !Csp		\ --
  Sp@ Csp !
;

: ?Comp		\ --
  State @ 0=
  0B ?Error
;

: Compile	\ --
  ?Comp
  R> Dup 2+ >R
  @ ,Code
;

decimal

\ Constants ...................................... sfp 01/04/89
hex

020 Constant Bl                         \ Blank/Space
040 Constant C/L                        \ 64 = Antique
011 constant xon                        \ XON for flow control
013 constant xoff                       \ XOFF for flow control

INTERNAL

8 Constant #Vocs
#Vocs 2* Constant Vsize

EXTERNAL

decimal

\ Head Traversal ..................................Jon 13/12/88

: >Body		\ a -- a'
  2+
;

: Body>		\ a -- a'
  2-
;

: N>Link	\ a -- a'
  2-
; 		

: Link>N	\ a -- a'
  2+
;		

: >Link		\ a -- a'
  >name n>link
;

: Link>		\ a -- a'
  link>n name>
;

: >Voc-Link	\ a -- a'
  >body
;		

: Voc-Link>	\ a -- a'
  body>
;

: >#Threads  	\ a -- a'
  >body 2+
;		

: >Threads  	\ a -- a'
  >#threads 2+
;

\ Vocabulary Control ............................. Jon 12/12/88

Also Root Definitions

: Definitions	\ --
  Context @ Current !
;

: Only		\ --
  ['] Root
  Context Vsize 2-
  2Dup Erase
  + !
  Root
;

: Also		\ --
  Context Dup 2+
  Vsize 4 -
  cmove>
;

\ Vocabulary Control                               sfp 13/04/88

: Previous	\ --
  Context Dup 2+
  Swap Vsize 4 -
  CMove
  Context Vsize 4 -
  + Off
;

Previous Definitions

\ String Manipulation ............................ Rod 12/08/87

: $+		\ a1 a2 --
  >R Count R> ($+) 			\ add a1 to end OF a2
;

: $>Pad		\ a --
  Pad Off
  Pad $+  				\ copy $ to pad
;

\ String I/O ..................................... Rod 12/08/87

: $.		\ a --
  Count Type
;

: (.")		\ --
  ((")) $.
;

: (Abort") 	\ --
  ((")) Swap
  IF    $. Abort
  ELSE  Drop
  ENDIF
;

: (")		\ -- a
  (("))
;

\ Number Formatting ...............................RTX 15/04/88
hex

: Hold		\ c --
  Hld Decr
  Hld @ C!
;

: Sign		\ n +d --
  Rot 0<
  IF
    02D Hold
  ENDIF
;

: #		\ +d1 -- +d2
  Base @ Mu/Mod
  Rot 9 Over <
  IF
    7 +
  ENDIF
  030 + Hold
;

decimal

\ Number Formatting ...............................RTX 14/04/88

: #S		\ +d -- 0 0
  BEGIN
    # 2Dup Or
    0=
  UNTIL
;

: <#		\ --
  Pad Hld !
;

: #>		\ 32b -- a +n
  2Drop
  Hld @
  Pad Over -
;

\ I/O .............................................Jon 12/12/88

: Bell		\ --
  Abell Emit
  Out Decr
;

: Space		\ --
  Bl Emit
;

: Spaces	\ n --
  0 Max 0
  ?DO
    Space
  LOOP
;

\ I/O .............................................sfp 13/04/88

: Bs		\ --
  Out @
  IF
    Bsout Emit
    Space
    Bsout Emit
    -4 Out +!
  ELSE
     Bell
  ENDIF
;

: -Trailing	\ a +n1 -- a +n2
  Dup 0
  ?DO
    2Dup + 1- C@
    Bl <> ?LEAVE
    1-
  LOOP
;

\ I/O ............................................ sfp 20/04/90
decimal

: Y/N?		\ -- t|f
  Key Dup Emit
  Upc ASCII Y =
;

\ Numeric I/O .................................... Jon 12/12/88

: D.R		\ d n --
  >R Tuck Dabs
  <# #S Sign #>
  R> Over -
  Spaces
  Type
;

: D.		\ d --
  0 D.R Space
;

: .		\ n --
  S>D D.
;

: U.		\ u --
  0 D.
;

\ Numeric I/O .................................... sfp 27/07/88

: .R		\ n1 n2
  >R S>D R>
  D.R
;

: U.R		\ u --
  0 Swap D.R
;

;p

\ Depth .Depth                                      \  01/12/92

: Depth         \ -- n ; number of items on data stack
  Sp@ s0 @ -
;

: .Depth	\ --
  ."  ok"                               \ First part
  Depth ?Dup                            \ Anything on stack?
  IF
    ." -" .  				\ Yes, say how many
  ENDIF
;

\ Error Handlers ..................................sfp 20/04/90

: (Abort)       \ --
  Xon/Xoff Off  Echoing On              \ No Xon/Xoff, do Echo
  S0 @ SP!  Quit
;

Defer Abort   Assign (Abort) to-do Abort

\ Error Handlers                                   sfp 20/04/90

: (Error)	\ n --
  base @ swap				\ preserve base
  DECIMAL
  echoing on  xon/xoff off              \ turn off flow control
  Disp-Error 
  base !				\ restore base
  Abort
;

Defer Error   Assign (Error) to-do Error
Defer Block

: ?Error                                \ t|f n --
  Swap
  IF
    Error
  ELSE
    Drop
  ENDIF
;

\ Base Control ................................... RTX 14/04/88
decimal

: Hex		\ --
  16 Base !
;

: Decimal	\ --
  10 Base !
;

: Binary	\ --
  2 Base !
;

\ Recurse ASCII ...................................sfp 27/07/88

: Recurse	\ --
  Latest Name>
  U2/ ,Code
; IMMEDIATE

: ASCII		\ -- c [exec]| -- [comp]
  Bl Word 1+ C@
  State @
  IF
    [Compile] Literal
  ENDIF
; IMMEDIATE

\ Block Memory Ops ................................Rod 12/08/87

: Erase		\ a n --
  0 Fill
;

: Blank		\ a n --
  Bl Fill
;

\ Long memory operators

\ These all work by preserving the data page register,
\ setting it to the new value, temporarily setting data fetches 
\ to use the dpr register in order to perform the fetch from the 
\ page, and finally restoring everything back to how it was.

: @l		\ addr page -- n
  dpr@ >r  dpr!  
  seldpr @ selcpr
  r> dpr!  ;

: c@l		\ addr page -- b
  dpr@ >r  dpr!  
  seldpr c@ selcpr
  r> dpr!  ;

: !l		\ n addr page --
  dpr@ >r  dpr!  
  seldpr ! selcpr
  r> dpr!  ;

: c!l		\ b addr page --
  dpr@ >r  dpr!  
  seldpr c! selcpr
  r> dpr!  ;

\ Numeric Input .................................. RTX 14/04/88

INTERNAL

: SKIP-SIGN	\ addr1 len1 -- addr2 len2 t/f ; tru if sign=-ve
  OVER C@
  DUP ASCII + =
  SWAP ASCII - =  DUP >R
  OR
  IF
    1 /string
  ENDIF
  R>
;

EXTERNAL

\ Numeric Input .................................. Rod 04/02/88

INTERNAL

: +Digit		\ d1 n -- d2
  Swap Base @ Um* Drop                  \ accumulate into double
  Rot Base @ Um*  D+                    \
  #D Incr  Dpl @ 1+                     \ incr. #digits, double?
  IF
    Dpl Incr  		                \ yes, incr. after d.p.
  ENDIF
;

EXTERNAL

\ Numeric Input .................................. Rod 04/02/88

INTERNAL

: +Char		\ char -- t|f
  ASCII , = Dup                         \ not digit, try ","
  IF
    Drop
    Dpl @ 0<                    	\ is "," see IF allowed
    IF
      Dpl Off  2                  	\ yes, set up and flag
    ELSE
      0
    ENDIF                             	\ illegal, flag it
  ENDIF
  Dup #L !
;	

EXTERNAL

\ Numeric Input .................................. Rod 04/02/88

INTERNAL

: +Ascii-Digit	\ d1 c -- d2 t|f
  Dup Base @ Digit                      \ digit?
  IF
    Nip +Digit  #L @                	\ yes, accum into dbl
  ELSE
    +Char                           	\ not digit, try ","
  ENDIF
;

EXTERNAL

\ [integer] ..................................     sfp 13/04/88

: (INTEGER?)    \ addr len  -- d/n/- 2/1/0
  #D OFF
  -1 DPL !
  1 #L !
  SKIP-SIGN OVER
  IF
    >R  0, 2SWAP  BOUNDS
    DO
      I C@
      +ASCII-DIGIT 0= ?LEAVE
    LOOP
    R> ?DNEGATE
    #D @ 0=
    #L @ 0= OR
    IF
      #L OFF  2DROP
    ELSE
      #L @ 1 =
      IF
        DROP
      ENDIF
    ENDIF
  ELSE
    DROP 2DROP
    #L OFF
  ENDIF
  #L @
;

\ Numeric Input .................................. Rod 09/12/87

: Integer?	\ a -- d/n/- 2/1/0
  Count  ?Dup
  IF
    (Integer?)
  ELSE
    Drop
    #L Off  0
  ENDIF
;

\ Numeric Compilation............................. sfp 27/07/88
Hex

: #Literal	\ n1..nn n --
  ?Dup                                  \ put in dict n1 first
  IF
    Dup Lit-Count !                   	\ save number of literal
    begin 				\ Copy literals to R.Stk
      swap >r
      1- ?dup 0=
    Until
    Lit-Count @                       	\ get count again
    Begin
      R> Dup 0 01F Within?          	\ Short Literal?
      IF
        0BE40 or ,Code          	\ Yes, Lay Little
      ELSE
        0DE00 ,Code  ,			\ No, Lay lit and n
      ENDIF
      1- ?dup 0=
    Until
  ENDIF
;

\ Numeric Compilation............................. Rod 11/12/87

: Literal	\ n --
  1 #Literal
; IMMEDIATE

: Dliteral	\ d --
  2 #Literal
; IMMEDIATE

\ Numeric Input .................................. RTX 21/04/88
Decimal

Internal

: (>#)		\ n1 n2 c -- n3 n4
  Dup
  10 Digit
  IF
    Swap Emit
    Rot 10 * +
    Swap 1+
  ELSE
    8 =
    IF
      Dup
      IF
        Swap 10 /
        Swap 1-
        Bs
      ENDIF
    ELSE
      Bell
    ENDIF
  ENDIF
;

External

\ Numeric Input .................................. sfp 13/04/88
Decimal

: (#In)		\ -- n #chars
  0 0
  BEGIN
    Key Dup 13 <>
  WHILE
    (>#)
  REPEAT
  Drop
;

: #In		\ -- n
  0
  BEGIN
    Drop (#In)
  UNTIL
;

\ Printer Control .................................RTX 14/04/88
Decimal

66 Constant L/P                         \ lines per page
Defer Page                              \ throws a new page

: (Page)		\ --
  12 Emit
  Page# Incr
  Line# Off
;

Assign (Page) To-Do Page

\ Thread Hashing ..................................Jon 13/12/88
hex

internal

: hash-thread   \ $addr voc-addr -- $addr hash-addr
  over dup c@ swap 1+ c@ +              \ count & first char
  swap                                  \ get voc-cfa
  dup >#threads @ 1- rot and 2*         \ mask for #threads
  swap >threads +                       \ form thread addr
;

External

\ Trim ............................................Jon 14/12/88
decimal

internal

: Trim		\ nfa-to-forget voc-cfa --
  dup >threads swap >#threads @ 2*
  bounds                         	\ bound the threads
  Do
    i @                             	\ fetch top link
    Begin
      2dup u> 0=               		\ while nfa < link
    While
      n>link @               		\  try next one
    Repeat
    i !                             	\ update thread entry
  2 +Loop                             	\ step to next thread
  drop 					\ release nfa
;                             		

external

\ (forget) ........................................Jon 14/12/88
decimal

: (forget)      \ nfa -- ; forgets back to given nfa
  >r
  r@ FENCE @ U<
  21 ?ERROR
  VOC-LINK @
  BEGIN
    R@ OVER U<
  WHILE
    >voc-link @
    only forth definitions
  REPEAT
  dup voc-link !        		\ voc-link -- ; pointer to top voc
  BEGIN
    r@ over                     	\ -- v-l nfa v-l
    trim				\ -- v-l ; cut links
    >voc-link @ ?dup 0=			\ check end of chain
  UNTIL
  r> n>link dp !			\ reset DP
;

\ Forgetting ......................................Jon 13/12/88

: $Forget	\ $a -- ;
  Current @
  V-Find 0=
  0 ?Error
  >Name (Forget)
;

: Forget	\ --
  Bl Word
  Dup Count Upper
  $Forget
;

\ Find ............................................Jon 12/12/88

: Find		\ a1 -- a2 n
  Dup Count Upper
  Dup C@
  IF
    0 Context Vsize Bounds
    DO
      Drop                          	\ lose previous flag
      I @ V-Find                    	\ look in vocabulary
      Dup ?LEAVE                    	\ leave if found
      2 +LOOP
  ELSE
    0
  ENDIF
;

\ Queries .....................................     JL 03/12/92
hex

: ?Csp		\ --
  Sp@ Csp @ <>
  014 ?Error
;

: ?Exec         \ --
  State @
  012 ?Error
;

: ?Stack	\ --
  Depth 0 stack-top Within?
  0= 1 ?Error
;

decimal

\ ?bs ?emit save-char                              sfp 01/04/89

: ?bs           \ pos -- pos' step ; perform BS if pos non-zero
  dup 0<>
  echoing @ 0<>  and           		\ pos non-zero and echo
  if
    bs 1- -1                          	\ perform backspace
  else
    0                               	\ no
  endif
;

: ?emit         \ char -- ; emit if echoing enabled
  echoing @                             \ stash char, echo it?
  if				        \ process accordingly
    emit
  else
    drop
  endif
;

: save-ch       \ char addr -- ; save as required
  over ?emit
  c!
;

\ expect                                           sfp 20/04/90
hex

: (expect)      \ addr len -- ; read up to LEN chars into ADDR
  xon/xoff @
  if
    xon emit
  endif        				\ enable server
  0 -rot bounds                         \ form address limits
  ?do
    case key                         	\ get character
      008 of  ?bs                endof 	\ BS
      009 of  bl i save-ch 1+ 1  endof 	\ TAB, convert to space
      00A of  bl i save-ch 1+ 1  endof 	\ LF, convert to space
      00C of  bl ?emit  leave    endof 	\ FF, treat like CR
      00d of  bl ?emit  leave    endof 	\ CR
      07f of  ?bs                endof 	\ DEL
              i save-ch  1+ 1 0		\ stash char, echo it?
    endcase
  +loop
  xon/xoff @
  if
    xoff emit 				\ disable server
  endif
  span !                               	\ set length received
;					

\ Character Input ................................ RTX 14/04/88
hex
Defer Expect
Assign (Expect) To-Do Expect

: Tib		\ -- a
  'Tib @
;

: Query		\ --
  Tib 050 Expect
  Span @ #Tib !
  >In Off
;

decimal

\ place source parse-word word                     sfp 13/04/88
hex

: PLACE		\ addr1 len addr2 -- ; copies uncounted string to counted
  2DUP C!
  1+ SWAP MOVE
;

: SOURCE	\ -- addr len ; returns address and length of i/p buffer
  BLK @ ?DUP
  IF
    BLOCK 0400
  ELSE
    TIB #TIB @
  ENDIF
;

: PARSE-WORD	\ char -- addr len
  >R
  SOURCE TUCK >IN @ /STRING
  R@ SKIP
  OVER SWAP R> SCAN
  >R OVER -
  ROT R>
  DUP 0<> + -
  >IN !
;

: WORD		\ char -- addr
  PARSE-WORD
  here PLACE
  here DUP COUNT +
  BL SWAP C!
;

\ More?                                            sfp 03/11/88

: More?		\ addr -- t/f ; return false when out of input
  C@ Dup 0=
  Done-Flg !
;

: ;S            \ -- ; as if input has ended
  R> Drop
  Done-Flg On
;

\ Compiler/Interperter ............................Jon 12/12/88

: (I-Loop)	\ --
  State Off
  BEGIN
    ?Stack
    Bl Word More?	 		\ WHILE input lasts
  WHILE
    Here Find                      	\ see IF runnable
    IF
      Execute
    ELSE
       Number? 0=
       0 ?Error      			\  or might be number
    ENDIF
  REPEAT
;

Defer I-Loop
Assign (I-Loop) To-Do I-Loop

\ Compiler/Interperter ............................sfp 27/07/88

: (C-Loop)	\ --
  State On
  BEGIN
    ?Stack
    Bl Word More?
  WHILE
    Here Find ?Dup
    IF
      0>
      IF
        Execute
      ELSE
        U2/ ,Code
      ENDIF
    ELSE
      Number? ?Dup 0=
      0 ?Error
      #Literal
    ENDIF
  REPEAT
;

Defer C-Loop
Assign (C-Loop) To-Do C-Loop

\ Compiler/Interperter ............................RTX 16/04/88
Hex

: [		\ --
  R> drop
  ['] I-Loop @ 2*
  [ 0BEA7 , \\ ]
; -2 allot IMMEDIATE

: ]		\ --
  R> Drop
  ['] C-Loop @ 2*
  [ 0BEA7 , \\ ]
; -2 allot

: Interpret	\ --
  Begin
    State @                        \ select compile/interp
    IF
      C-Loop
    ELSE
      I-Loop
    ENDIF
    Done-Flg @                     \ leave when i/p run out
  Until
;

\ Compiler/Interperter ............................sfp 01/04/89

Defer Prompt
Assign .Depth To-Do Prompt

: (Quit)	\ --
  Blk Off
  State Off
  BEGIN
    R0 @ Rp!                      	\ reset return stack
    echoing @                     	\ if echoing enable
    if  cr  endif                 	\ issue new line
    Query Interpret               	\ get next line
    STATE @ 0=
    echoing @ 0<> and 			\ if intepreting & echo
    IF  Prompt  ENDIF             	\ issue prompt
  AGAIN
;

Defer Quit
Assign (Quit) To-Do Quit

\ Compiler/Interperter ............................sfp 20/04/90

: Disp-Error		\ n --
  Cr ." error # " .
  Space Here $.
  Cr ( Message )
  Blk @ ?Dup
  IF
    >In @ 2-
    C/L /Mod Rot
    Cr  ." Screen " .
    ."  Line " 1+ . Cr
  ENDIF
;

\ References ......................................RTX 21/04/88
Hex

Internal

: >Mark			\ -- a
  Here  0 ,  \\ ;

: >Resolve              \ a --
  Here Swap !  \\ ;

: <Mark                 \ -- a
  Here  \\ ;

: <Resolve              \ a --
  ,  \\ ;

: ?Pairs		\ n --
  - 013 ?Error ;

\ References ......................................RTX 21/04/88

: Lay-Dummy		\ --
  0 ,  \\				\ make a hole for an adr
;

: Resolve-Dummy 	\ a --
  Here 2- !  \\				\ resolve adr into dummy
;

\ mrk-jmp<                                         RTX 21/04/88
hex

: mark-jump<      	\ -- addr
  HERE  \\
;

: mark-jump>		\ -- addr
  HERE 2-  \\
;

\ >page# this                                      RTX 21/04/88
hex

: >Page# 		\ addr -- page
  0FC00 AND
;

: This                  \ -- page
  Here >Page#
;

\ This+1 this-1 Page? odd?                         RTX 21/04/88
Hex

: This+1		\ -- page
  Here >Page# 0400 +
;

: This-1		\ -- page
  Here >Page# 0400 -
;

: Page?                 \ -- page
  Over =
;

: Odd?			\ -- page
  1 AND 0<>
;

\ <Res-Jmp                                         sfp 11/08/90
Hex

: <Resolve-Jump	\ addr< --
  Dup Odd?
  022 ?Error                   			\ -- addr<
  CASE Dup >Page#                      		\ -- addr< page<
    0                     Page? ?OF  Drop  0400  ENDOF
    here    >page#        Page? ?OF  Drop  0000  ENDOF
    here    >page# 0400 - Page? ?OF  Drop  0600  ENDOF
                                021 Error
  ENDCASE
  Swap 03FF AND
  2/ OR
  Here 2- @ Or
  Here 2- !  \\
;

\ >res-jmp                                         sfp 11/08/90
hex

: >Resolve-Jump		\ addr --
  Here Odd?
  022 ?Error
  CASE  Dup 2+ >Page#                   \ -- addr page
    This     0 = ?OF  Drop 0400  ( -- addr n ) ENDOF
    This   Page? ?OF  Drop 0000  ENDOF
    This-1 Page? ?OF  Drop 0200  ENDOF
                 021 Error
  ENDCASE
  Here 03FF AND
  2/  OR		                 \ -- addr> >addr'
  Over @ OR
  Swap !  \\
;

\ Control Structures ............................. sfp 29/09/88

 1 Equ Until-Stat                       \ Define structure types
 2 Equ If-Stat
 3 Equ While-Stat
 4 Equ Case-Stat
 5 Equ Of-Stat
 6 Equ Do-Stat
 7 Equ For-Stat

\ Control structures ........................... J Lee 13/08/91

: Resolving	\ 0 a1..an --
  BEGIN                                 \ step thru list of
    ?Dup                                \ adresses storing here
  WHILE                                 \ in each.
   >Resolve
  REPEAT
;

: Resolving-Jumps	\ 0 a1..an --
  BEGIN                                 \ step thru list of
    ?Dup                                \ adresses merging here
  WHILE                                 \ with each.
   >Resolve-Jump
  REPEAT
;

\ Control structures ............................. RTX 21/04/88

: Insert>Mark	\ .. 3 .. -- .. a 3 ..
  0					\ add a forward branch
  BEGIN
    Over Do-Stat <>               	\ to be resolved, to the
  WHILE
    1+ Swap >R                   	\ list of leaving addrs
  REPEAT                                \ associated with the
  >Mark Rot Rot                         \ most recent Do loop.
  BEGIN
    Dup
  WHILE
    R> Swap 1-
  REPEAT
  Drop
;

\ Control structures ........................... J Lee 12/08/91

: Insert-Mark-Jump>	\ .. 3 .. -- .. a 3 ..
  0                                     \ add a forward branch
  BEGIN
    Over Do-Stat <> 			\ to be resolved, to the
  WHILE
    1+ Swap >R                   	\ list of leaving addrs
  REPEAT                                \ associated with the
  Mark-Jump> Rot Rot                    \ most recent Do loop.
  BEGIN
    Dup
  WHILE
    R> Swap 1-
  REPEAT
  Drop
;

\ Control Structures ............................. RTX 21/04/88

External

: BEGIN		\ -- a n
  ?Comp
  Mark-Jump< Until-Stat
; IMMEDIATE

: UNTIL		\ a n --
  Until-Stat ?Pairs
  Compile ?Branch
  <Resolve-Jump
; IMMEDIATE

: AGAIN		\ a n --
  Until-Stat ?Pairs
  Compile Branch
  <Resolve-Jump
; IMMEDIATE

: WHILE		\ n1 -- a n2
  Until-Stat ?Pairs
  Compile ?Branch Mark-Jump>
  While-Stat
; IMMEDIATE

: REPEAT	\ a1 a2 n --
  While-Stat ?Pairs
  Swap Compile Branch <Resolve-Jump
  >Resolve-Jump
; IMMEDIATE

\ Control Structures ............................. RTX 21/04/88

: IF		\ -- n
  Compile ?Branch Mark-Jump>
  If-Stat
; IMMEDIATE

: ENDIF		\ a n --
  ?Comp
  If-Stat ?Pairs
  >Resolve-Jump
; IMMEDIATE

: THEN		\ a n --
  [Compile] ENDIF
; IMMEDIATE

: ELSE		\ --
  If-Stat ?Pairs
  Compile Branch Mark-Jump>
  Swap >Resolve-Jump
  If-Stat
; IMMEDIATE

\ Control structures ........................... J Lee 12/08/91
hex

Internal

: (of)		\ n n'-- . t | n f
  over = dup                            \ Equal?
  If  nip  ENDIF 			\ drop n
;

: (Case)  	\ --
;

External

decimal

\ Control structures ........................... J  \  13/08/91
hex

: CASE          \ -- a 0 n
  Compile (case)                        \ marker for decompiler
  ?Comp Mark-Jump<                      \ mark for possible
  0 Case-Stat				\ next-case, 0 for end of addr list.
; IMMEDIATE

: OF            \ n1 -- a n2
  Case-Stat ?Pairs
  Compile (of)				\ In case? compile (of)
  compile ?BRANCH
  Mark-Jump> Of-Stat
; IMMEDIATE

: ?OF           \ n1 -- a n2
  Case-Stat ?Pairs                      \ In case? compile
  compile ?BRANCH
  Mark-Jump> Of-Stat
; IMMEDIATE

: ENDOF		\ a1 n1 -- a2 n2
  Of-Stat ?Pairs                        \ In of?
  compile BRANCH
  Mark-Jump> >R				\ BRANCH to END(-)CASE
  >Resolve-Jump R> Case-Stat		\ Note here to go from
; IMMEDIATE 				\ last faied of, reslve

: ENDCASE	\ a 0 a1..an n1 --
  Case-Stat ?Pairs
  Compile Drop				\ Drop tester
  Resolving-Jumps                       \ fix up branches
  Drop 					\ case start address
; IMMEDIATE

: END-CASE	\ a 0 a1..an n1 --
  Case-Stat ?Pairs
  Resolving-Jumps			\ Resolve and drop
  Drop 					\ case start address
; IMMEDIATE

: NEXT-CASE	\ a 0 a1..an n1 --
  Case-Stat ?Pairs
  Compile BRANCH
  resolving-jumps
  <Resolve-Jump
; IMMEDIATE

decimal

\ Control structures ........................... J  \  13/08/91
hex

: FOR		\ -- a n
  ?Comp Compile >R
  Mark-Jump< For-Stat
; IMMEDIATE

: NEXT		\ a n --
  For-Stat ?Pairs
  ?Comp
  09800 ,Code
  <Resolve-Jump
; IMMEDIATE

decimal

\ Control structures ........................... J Lee 13/08/91

internal

: (+Loop)         \ n -- t/f
  ipr@ R>                               \ get return address
  rot
  R> Dup MD! R> Dup SR!  		\ store E & I in regs
  Swap - Over Over +
  xor 0<				\ *** See note in glossary
  IF
    Drop
    >R  ipr!
    TRUE  Exit
  ENDIF
  SR@ + >R
  MD@ >R
  >R ipr!
  FALSE
;

external

\ Control structures ........................... gie 17/09/93

Internal

: (Loop)	\ -- t/f
  ipr@ R>
  1
  R> Dup MD!  R> Dup SR!		\ store E & I in regs
  Swap -  Over Over +
  over xor and 0<			\ boundary check?
  IF
    Drop
    >R ipr!
    TRUE  Exit
  ENDIF
  SR@ + >R
  MD@ >R
  >R ipr!
  FALSE
;

External

\ Control structures ........................... J Lee 13/08/91

: I		\ -- n
  ipr@ R> R>
  R@ MD! >R
  >R ipr!
  MD@
;

: J		\ -- n
  ipr@ R>
  R> R>
  R> R@ MD!
  >R  >R >R  >R
  ipr!  MD@
;

: LOOP		\ a a' 0 a1..an --
  Do-Stat ?Pairs
  Compile (Loop)        \
  Compile ?BRANCH
  resolving-jumps
  <Resolve-Jump
  >Resolve-Jump
; IMMEDIATE

: +LOOP		\ a a' 0 a1..an --
  Do-Stat ?Pairs
  Compile (+Loop)
  Compile ?BRANCH resolving-jumps
  <Resolve-Jump
  >Resolve-Jump
; IMMEDIATE

\ Control structures ........................... J Lee 13/08/91
hex

internal

: (Leave)         \ --
  ipr@ R>
  R> Drop R> Drop
  >R ipr!				\ Compile goto end
;

: (?Leave)        \ t|f -- t|f
  IF
    ipr@ R>
    R> Drop  R> Drop
    >R ipr!				\ FALSE for ?BRANCH
    FALSE  EXIT
  ENDIF					\ TRUE for ?BRANCH
  TRUE
;					

external

decimal

\ Control structures ........................... J  \  13/08/91

: LEAVE		\ --
  Compile (Leave)
  Compile BRANCH Insert-Mark-Jump>
; IMMEDIATE

: ?LEAVE	\ --
  Compile (?Leave)
  Compile ?BRANCH Insert-Mark-Jump>
; IMMEDIATE

\ Control Structures ........................... J Lee 13/08/91

Internal

: (Do)		\ n1 n2 -- TRUE
  IPR@ SR! R> MD!
  >r >r md@
  >r SR@
  IPR!  TRUE
;

: (?Do)		\ n1 n2 -- t/f
  Over Over =         			\ same start and end?
  IF
    Drop Drop  FALSE                 	\ y:
    EXIT				\   don't do loop
  ENDIF                                 \ n:
  ipr@ sr! r> md!
  >r >r  md@
  >r sr@
  ipr!  TRUE 				\ continue as normal
;

External

\ Control structures ........................... J  \  13/08/91

: DO		\ -- a 0
  Compile (Do)
  Compile ?BRANCH
  Mark-Jump>
  Mark-Jump<
  0  Do-Stat
; IMMEDIATE

: ?DO		\ -- a1 0 a2
  Compile (?Do)
  Compile ?BRANCH
  Mark-Jump>
  Mark-Jump<
  0  Do-Stat
; IMMEDIATE

\ Compiler Directives ............................ sfp 27/07/88

: '		\ -- a
  Bl Word Find 0=
  0 ?Error
;

: [']		\ --
  ' [Compile] Literal
; IMMEDIATE

: [Compile]	\ --
  ' U2/ ,Code
; IMMEDIATE

: Even,		\ --
  Here 1 and
  if  Bl C,  endif
;

\ Compiler Directives ............................ RTX 15/04/88

: (		\ --
  ASCII ) Word
  Drop
; IMMEDIATE

: \		\ --
  Blk @
  IF
    >In @
    C/L / 1+ C/L *
    >In !
  ELSE
    0 Word Drop
  ENDIF
; IMMEDIATE

: ",		\ --
  ASCII " Word
  C@ 1+ Allot
  Even,
;

\ Compiler Directives ............................ Rod 09/12/87

: ""		\ -- a | --
  State @
  IF
    Compile (")  ",
  ELSE
    ASCII " Word $>Pad
    Pad
  ENDIF
; IMMEDIATE

: Abort"	\ --
  Compile (Abort")
  ",
; IMMEDIATE

: .( 		\ --
  ASCII ) Word
  $.
; IMMEDIATE

\ ."                                               sfp 20/04/90

: ."		\ --
  State @
  IF
    Compile (.")  ",
  ELSE
    ASCII " Word $.
  ENDIF
; IMMEDIATE

\ ?                                                sfp 20/04/90

: ?             \ addr --
  @ .
;

\ Header Creation................................. Jon 13/12/88
hex

Internal

: Header        \ -- ; create dictionary header
  here 2+
  Current @ hash-thread nip      	\ find thread-addr
  dup @ ,                               \ lay old thread
  here swap !                           \ link this word
  here last !                           \ this is latest word
  here dup c@
  width @ min 1+ allot			\ reserve space
  even,
  080 swap set-bit  \\ 			\ set high bit
;

: DoCreate,     \ -- ; lay run-time action of create
  0BE27 ,  \\				\ Optimiser OFF
;

External

decimal

\ Header Creation................................. Jon 12/12/88

: $Create	\ addr --
  Here 2+
  Over C@ 1+ Even
  Move					\ copy string to HERE+2
  Header  Docreate,
;

: Create	\ --
  Bl Word  Dup Count Upper              \ fetch data from i/p
  Dup Current @ V-Find                  \ see IF name exists
  IF
    >Name Cr .Name ."  Is Redefined " 	\ yes, say so
  ELSE
    Drop  				\ no
  ENDIF
  $Create				\ make header and cfa
;

\ Halting ........................................ sfp 02/08/88
decimal

: Halt?		\ --
  Key? Dup                              \ key pressed
  IF
    Key
    Dup Bl =
    Swap 19 =  Or      			\ ctrl s or space?
    IF
      Drop                          	\ chuck previous flag
      Key                           	\ get second char
      Dup Bl <>
      Swap 17 <>  And    		\ NOT ctrl Q or space?
    ENDIF
  ENDIF
;

\ Misc Output .....................................Jon 09/12/88
Hex

: .Name		\ nfa --
  Count 01F And Type
;

: Tab           \ --
  C/L Out @ <=
  IF
    Cr
  ELSE
    Tab-Width @
    Out @
    Over Mod - Spaces
  ENDIF
;

: .Free		\ --
  ." Free Dictionary Space: "
  Mem-Top  Here - U. ." bytes"
;

\ Misc Output .....................................sfp 29/09/88
hex

: .Byte         \ b -- ; display as hex byte
  Base @ Hex  Swap                      \ preserve & set base
  0 <# # # #> Type                      \ display data
  Base !				\ restore base
;

: .Word         \ n -- ; display as hex word
  Base @ Hex  Swap                      \ preserve & set base
  0 <# # # # # #> Type                  \ display data
  Base !                                \ restore base
;	

: .Ascii        \ c -- ; display in printable form
  07F And  Dup 020 07E Within? 0=       \ b --
  IF   Drop 02E   ENDIF
  Emit
;

\ words using a thread table                       Jon 13/12/88

also root definitions

internal

: max-nfa       \ -- addr nfa ; returns addr and top nfa
  0 0                                   \ clear current set
  pad
  Context @ >#threads @ 2* bounds   	\ for all threads
  do
    i @  over u>                     	 \ if greater
    if
      2drop
      i  i @   				\ replace current set
    endif
  2 +loop				\ step on
;

external

\ words using a thread table cont................. Jon 13/12/88

: Words		\ --
  c/l out !                             \ soft CR
  Context @ >threads pad                \ source, destination
  Context @ >#threads @ 2* cmove        \ copy threads
  Begin
    max-nfa dup                         \ while there is a word
    halt? 0= and                        \ and no stop command
  While
    dup tab .name                       \ display name
    n>link @ swap !                     \ find next word
  Repeat
  2drop
;

previous definitions

\ Misc Output .....................................Rod 19/01/88

decimal

: .S            \ -- ; non-destructive stack dump
  Cr  Depth ?Dup
  IF
    Base @ Dup
    Decimal               		\ will display value
    Cr  ." Base = " .  ." (decimal)" 	\ display it
    Base !				\ restore base
    ."    Top"  Dup 0< 1 ?Error
    0
    DO
      Cr
      I Pick 16 U.R
      Halt? ?LEAVE
    LOOP
  ELSE
    ." Empty Stack"
  ENDIF
  Cr
;

\ dump                                             sfp 29/09/88
hex

: dump		\ addr len --
  BOUNDS                                \ get limits
  DO
    I CR  .WORD I  			\ print address
    010 0
    do
      i 7 and 0<> 2+ spaces		\ space every eight
      dup i + c@ .BYTE			\ print byte
    loop
    drop
    2 SPACES  				\ gap
    I 010 bounds
    DO
      I c@ .ASCII			\ ascii o/p
    LOOP
    HALT? ?LEAVE			\ quit or halt
  010 +LOOP                             \ until done
  CR
;

\ Deferred words ................................J  \  08/11/90
hex

Defer Pause     0A000           To-Do Pause     \ --
Defer Wait      0AE40           To-Do Wait      \ n --
Defer Number?   Assign Integer? To-Do Number?   \ -- n1

\ Vocabularies ....................................Jon 08/12/88

ALSO ROOT DEFINITIONS

: Seal		\ --
  ' Context Vsize Erase
  Context !
;

' FORTH Equ OLDFORTH

: FORTH		\ --
  [ Oldforth 2/ , ]			\ avoid self reference
;

\ Vocabularies ....................................Jon 08/12/88

internal

: .Voc		\ a --
  @ ?dup
  IF  >Name .Name Space
  ENDIF
;

external

: Order		\ --
  CR
  ." context: " Context Vsize Bounds
  DO
    I .voc
  2 +Loop
  CR ." current: " Current .Voc CR
;

\ Vocabularies ....................................Jon 13/12/88

: Vocs		\ --
  Voc-Link
  Begin
    @ ?dup
  While
    dup >name space .name
    >voc-link
  Repeat
;

previous definitions

\ (init)                                            \  20/11/90
decimal

INTERNAL

: (Init)	\ --
  Init-U0 User-Base !                   \ point to user area
  0 9 g!  0 s0 !  0 r0 !                \ reset stacks
  s0 @ sp! r0 @ rp!
  init-ibc ibc!				\ set int vector location
  16 #threads !                         \ set default #threads
  Init-Tib 'Tib !
  31 Width !
  Blk Off  Scr Off  State Off
  Init-Fence @ Fence !                  \ Read initial values of
  Init-DP @ DP !                        \ FENCE DP and VOC-LINK
  Init-Voc-Link @ Voc-Link !
  16 Tab-Width !
  only forth definitions  decimal
  Here 4 + (Forget)
;

EXTERNAL

\ Cold                                           \ gie 04/12/92

: Cold		\ -- ; cold start
  (init)				\ need to reset when user types cold!
  [ paged? ]				\
  if(					\
    init-pages				\
  )endif				\ initialise paging
  [ #tasks 1 > ] 			\
  if(					\
     init-multi				\
  )endif				\ start multi-tasker
  [ romforth? ]				\
  if(					\
    empty-buffers
    relink				\
  )endif				\ reset appl ROM
  Cr .cpu ." vx.yz"
  [ MPE-Rel here 4 - c!  MPE-Ver here 2- c!
    MPE-Bug here 1 - c! ]
  Cr Copyright $.                       \ print copyright
  Cr .Ram-Find                          \ find and show RAM
  Cr .Free                              \ show free space
  Cr  Prompt Abort			\ go
;

\ Warm                                             sfp 20/04/90

: Warm          \ -- ; system restart
  Cr  ." Warm Restart"  Cr              \ tell user
  [ romforth? ]				\
  if(					\
    empty-buffers
  )endif				\ reset appl ROM
  Abort 				\ go
;

\ System Startup & Preservation .................. sfp 20/04/90

Hex

l: strt ' cold ,

Internal

: StartUp	                \ --
  Init-Hardware				\ copy from rom to ram & initialise
  (init)				\ need to reset for all applications
  strt @ execute			\ Go do it!
;

External				\

: Freeze	\ --
  Fence @ Init-Fence !                  \ Set initial values of
  Here Init-DP !                        \ FENCE DP and VOC-LINK
  Voc-Link @ Init-Voc-Link !
;

\ .hex 2.hex                                       Jon 12/12/88
\ only necessary if the target is in a very bad way indeed
\ and even . will not work!!!
pto

hex
: .hex          \ n -- ; print n in hex
  3
  for
    dup 0B
    for   U2/   next			\ top 4 bits to bottom
    0F and  dup 9 >                  	\ mask, check 0..9,A..F
    if  7 +  endif                   	\  was A..F
    030 + emit                       	\ convert to ASCII
    2* 2* 2* 2*                      	\ get next 4 bits
  next
  drop  space				\ drop n
;
: 2.hex		\ d -- d ;
  cr 2dup  .hex .hex  space  ;

\ The End!

;p
