\ Z80/64180 ROM PowerForth - Multi-Tasker Example

\ 
\ Copyright (c) 1988-1991 to:
\ MicroProcessor Engineering Limited
\ 133 Hill Lane
\ Shirley
\ Southampton SO1 5AF
\ England
 
\ tel: (+44) 703 631441   ( international )
\ tel: 0703 631441        ( domestic )
 
\ example tasks                                    sfp 12/02/90
 

\ A task whose action is ACTION waits until a message is sent to it, 
\ and then displays the ID of itself, the ID of the sender, and the message.
\ The message is a number, which may be the message itself, the address of
\ a data block, or even the CFA of a word to EXECUTE.
\



: action        \ --
  decimal
  begin  get-message                    \ wait for message
         cr ." Task # " self .          \ show who received it
         swap                           \ swap message and task
         self 3 <> if
             dup self 1 + send-message      \ send message to next task
         endif
         ." received message # " u.     \ show message
         ." from task # " .             \ and task
         cr                             \
  again  ;                              \ go get next message


\
\ The event handler for the example tasks just displays that it has
\ been triggered. Note that the event run flag is not reset by this
\ event handler. The task will thus wake up because this bit is never
\ reset. Add CLR-EVENT-RUN to reset the event run flag in the task status.
\



: eventful      \ -- ; just shows triggered task number
  cr  ." Event handler for task # " self . cr  ;


  
\
\ DO-TASKS sets up the actions and event handlers of all the tasks,
\ and starts everything running.
\


: do-tasks      \ --
  init-multi  multi			\ set up
  #tasks 1				\ for all defined tasks
  ?do  assign action i to-task		\ set up task action
       assign eventful i to-event	\ and event handler
       i activate			\ launch task
  loop                                  \
  assign eventful 0 to-event  ;         \ event handler 0


  
\
\ Now you can use SEND-MESSAGE and SET-EVENT, e.g.
\
\ n SET-EVENT
\ message n SEND-MESSAGE
\
\ all done

: tst-tasking
  do-tasks
  10 0 ?do
     i 1 send-message
     ." Sending message to first task " cr
     10000 wait
  loop ;


decimal


