((
	********************************************
	***                                      ***
	*** VECTORS.FTH                          ***
	***                                      ***
	*** Description:                         ***
	*** Interrupt vectors for RTX2000/1/10	 ***
	*** ROM Target.			 	 ***
	***                                      ***
	*** History:                             ***
	***   V1.000 J Lee 12/8/93               ***
	***   Original release.                  ***
	***                                      ***
	********************************************
))


only forth definitions
decimal


((
****************************************************
****						****
**** 	HOST CODE for aligning vector table	****
****						****
****************************************************
))


host-compilation

#32 constant boundary                  \ start on 32 byte boundary

also c-c also forth definitions

: >boundary		( -- ; move to boundary )
  boundary here(t) over mod - allot(t) \ force boundary alignment
;                                      

target-compilation


((
****************************************************
****						****
**** 	TARGET CODE - the vector table		****
****						****
****************************************************
))


\
\ interrupt vector table must be aligned on 1 Kbyte boundary
\ this must be set in bits 10-15 of IBC
\

here			\ preserve current dictionary pointer

int-base ORG

	 					>boundary	\ reserved
						>boundary	\ reserved
] save-int swi-isr restore-int EXIT [		>boundary	\ swi         
] save-int ei5-isr restore-int EXIT [		>boundary	\ EI5         
] save-int ei4-isr restore-int EXIT [  		>boundary	\ EI4         
] save-int ei3-isr restore-int EXIT [	  	>boundary	\ EI3         
] save-int timer2-isr restore-int EXIT [	>boundary	\ timer2         
] save-int timer1-isr restore-int EXIT [	>boundary	\ timer1         
] save-int timer0-isr restore-int EXIT [	>boundary	\ timer0
] save-int ei2-isr restore-int EXIT [		>boundary	\ EI2         
] save-int rsv-isr restore-int EXIT [		>boundary	\ rsv         
] save-int psv-isr restore-int EXIT [		>boundary	\ psv
] save-int rsu-isr restore-int EXIT [		>boundary	\ rsu
] save-int psu-isr restore-int EXIT [		>boundary	\ psu
] save-int ei1-isr restore-int EXIT [		>boundary	\ EI1         
] save-int nmi-isr restore-int EXIT [		>boundary	\ NMI         
\ ] save-int phantom-isr restore-int EXIT [	>boundary	\ phantom
] EXIT [					>boundary	\ phantom

org			\ restore dictionary pointer