\ RTX ROM Power Forth Control File                   sfp 03/09/90
pto

Copyright (c) 1989, 1990
MicroProcessor Engineering Ltd.
133 Hill Lane
Southampton SO1 5AF
England

tel: (+44) 703 631441
fax: (+44) 703 339691

\ Compiler Directives for RTX Power Forth .......J  \  23/07/91

only forth definitions decimal		\

\ file: rtx.log
\ Hex 0320 Emu-Base                     \ Set emulator base addr
\ e27512 16bit output-emulator          \ Type and bus width

\ compiler control                               J  \  25/11/92
\ Configure compiler to appropriate processor

all from-file rtx2010.def		\ processor specifics

floats

CROSS-COMPILE				\ turn compiler on

no-optimize				\ tail-opt
align					\ word aligned data
\ no-log				\ no progress log

only forth definitions			\ initial search order

\ Define target configuration here. These flags define whether certain
\ files are loaded, and whether certain initialisation words are included
\ in COLD. Note that selection of the multitasker is defined by the value
\ set for #TASKS on the next page.
\
1 equ romforth?				\ true to load romforth extensions
0 equ paged?				\ true if target is paged
1 equ softfp?				\ true if target needs floating point

\ memory layout                                  J  \  23/07/91
hex
rom-target

00000 07FFF kernel pb2010-8
08000 0EFFF 0 kernel-ram ROM-DATA
\  00000 in-emulator pb2010-8

use-code pb2010-8
use-data ROM-DATA

0C000 equ appl-rom			\ for ROM PowerForth

\ Clock rate and serial rate                        \  23/11/92
decimal

8000 equ clock-khz			\ clock speed in kHz
38400 equ serial-baud			\ serial line rate in baud

\ interrupt handler equates

0 equ Int-Base          \ int vector base - must be 1Kb aligned

\ character equates                                sfp 12/04/90
hex

20 equ abl
0d equ acr      2e equ adot
07 equ abell     8 equ bsin
08 equ bsout    0a equ alf
0c equ ffeed

\ Buffer Defs                                      sfp 01/09/90

$0100 equ stack-size    		\ size of RTX stack

$0004 Equ #tasks			\ total number of tasks
$0100 Equ per-task			\ size of user area for eack task

#tasks per-task * Equ Us		\ total size of user area

\ main files                                     J Lee 23/11/92

  decimal all from-file startup			\

  decimal all from-file code2010		\
  decimal all from-file kernel 			\
  decimal all from-file drivers\rtx-pbrd	\
  decimal all from-file ucodertx		\
  decimal all from-file vectors			\ vector table
  decimal all from-file interupt		\ interrupt handler code
  decimal all from-file examples\ints.fth

  Decimal all from-file drivers\scsi.fth 	\ SCSI driver code

#tasks 1 > 
if(
  Decimal all from-file multirtx.fth		
)endif

softfp? 
if(
  Decimal all from-file ..\softfp\fpromhi.fth	
  Decimal all from-file ..\softfp\softfp.fth	
)endif

\ The ROMForth files

romforth?
if(
  decimal all from-file ..\romforth\link	\ appl. rom link
  decimal all from-file ..\romforth\iodef	\ link i/o
  decimal all from-file ..\romforth\filetran	\ ascii file u/l
  decimal all from-file ..\romforth\bin-down	\ XMODEM dn/ld
  decimal all from-file ..\romforth\hex-down	\ Intel Hex down
  decimal all from-file ..\romforth\textfile	\ XSHELL textfiles
  decimal all from-file ..\romforth\blocks	\ XSHELL blocks	
)endif
  
decimal

\ target sign on

internal

: .cpu 		\ --
  ." MPE RTX 2010 ROM PowerForth "	\ sign on
;
 
external

\ End of compilation
only forth definitions			\ restore search order

: Forth-83 ;

Is-Fence

\ The End...
	 	  
FINIS

