\ MicroCode functions for MPE RTX-2000 PowerForth  RTX 15/04/88
pto

Copyright (C) 1988

MicroProcessor Engineering
133 Hill Lane
Shirley
Southampton SO1 5AF

tel: 0703 631441        (Inside U.K.)
     (+44) 703 631 441  (International)

\ Opcode Generator                                 sfp 31/08/90
Only Forth Definitions  Hex		\
target-only				\

: opcode	                \ n -- ;
  create				\
  ,  0A020 ,  IMMEDIATE			\ usage: n opcode <name>
  does>					\ sys -- sys
  state @				\ compiling?
  if
    @ ,Code				\ Yes, comma it in
  else
    execute				\ No, xeq it
  endif
;
host&target				\

\ opcodes                                          sfp 31/08/90
Hex
08800 OpCode ?Branch
09000 OpCode BRANCH
09800 OpCode (NEXT)
0A000 OpCode NOOP			\ made high level so no opt.
0B8C0 OpCode 0+
0B8C1 OpCode 1+
0B8C2 OpCode 2+
0B4C1 OpCode 1-
0B4C2 OpCode 2-

\ opcodes cont.                                    sfp 31/08/90
Hex
0A040 OpCode NIP
0A008 OpCode N2*
0A009 OpCode N2*c
0A00A OpCode D2*
0A00B OpCode D2*c
0A00C OpCode cUD2/
0A00D OpCode cD2/
0A00E Opcode UD2/
0A00F OpCode D2/

\ opcodes cont.                                    sfp 31/08/90
0A0C0 OpCode DUP
0AE40 OpCode DROP
0AE80 OpCode SWAP
0AEC0 OpCode OVER

\ opcodes cont.                                    sfp 31/08/90
0BE00 OpCode R@
0BE01 OpCode R>
0BE03 OpCode CF@
0BE04 OpCode MD@
0BE05 OpCode SQ@
0BE06 OpCode SR@
0BE07 OpCode PC@
0BE81 OpCode >R
0BE83 OpCode CF!
0BE84 OpCode MD!
0BE85 OpCode SQ!
0BE86 OpCode SR!

\ opcodes cont.                                    sfp 31/08/90
hex
0DE00 OpCode LIT
0EE00 OpCode @
0EE80 OpCode !
0FE00 OpCode C@
0FE80 OpCode C!

\ opcodes cont.                                  J Lee 12/03/91
hex
0A100 Opcode NOT
0BCC0 Opcode NEGATE
0BE82 Opcode Times
0BE82 Opcode Of(
0BE87 Opcode Execute

\ Code Generator                                   RTX 21/04/88
Vocabulary Optimiser
only forth also Optimiser definitions

\ Optimise? Last@ Last! Set-In-Last                sfp 04/01/90
Hex

: Last@		                \ -- opcode ; returns last opcode laid
  'Last @ @  
;

: Last!		                \ n -- ; rewrites last opcode
  'Last @ !  
;

: Set-In-Last	                \ n -- ; sets bits in last opcode
  Last@ or Last!  
;

: Optimise?	                \ -- t/f ; true if optimising enabled
  Optimising @ 0<>  Last@ 08000 And 0<>  And  
;

\ short-lit?                                       RTX 21/04/88
hex

: short-lit?	                \ -- t/f
  Last@ 0FFE0 and  0BE40 =		\ all but last 5 bits
;

: short-value	                \ -- n
  Last@ 01F And				\ Extract value
;

: Short-Lit-Op?	                \ -- t/f
  Last@ 0F040 And  0B040 =		\ any short literal
;

\ short-lit-op                                   J Lee 10/10/90
hex

: short-lit-op	                \ opcode --
  create  ,  Immediate			\ store opcode
  does>  @				\ retrieve it
  ?Comp					\ Only when compiling
  Short-Lit? 0= 022 ?error		\ must be short literal
  Short-Value or Last!			\ put back optimised
;

\ g@ g! u@ u!
hex
only forth also Optimiser  also Forth Definitions
0BE00 short-lit-op G@
0BE80 short-lit-op G!
0C000 short-lit-op U@swap
0CE80 short-lit-op U!

: U@
  [Compile] U@swap  [Compile] Swap    Immediate
;

\ Exit optimisations                               sfp 31/08/90
Hex

: Exit		                \ -- ; set Exit bit
  State @
  If
    Optimise?
    If
      Last@  0F000 And >R		\ extract opcode class
      R@ 0A000 =			\ can only merge A
      R> 0C000 0F000 within? OR		\  C..F
      Short-Lit-Op? OR			\ any short literal
      If
        0020 Set-In-Last		\ so merge it
      Else
        0A020 ,Code			\ or compile opcode
      Endif
    Else
      0A020 ,Code
    Endif \\
  Else
    R> Drop
  Endif
;
Immediate

\ ?subtract                                        RTX 21/04/88
Hex
Only Forth  Also Optimiser Definitions

: ?subtract	                \ opcode -- opcode'
  dup 0600 and  0400 =			\ ALU op = subtract ?
  if
    0800 xor
  endif
;
\ yes, change order*

: Long-Lit-Op?	                \ -- t/f
  Last@ 0DE00 =  
;

\ ALUop                                            sfp 28/07/88
Hex

: ALU+SLit	                \ alu-op -- opcode'
  0F00 And  ?Subtract			\ Extract Operator
  Short-Value Or			\ Add literal
  0B0C0 Or				\ Insert opcode L-OP-T
;

: ALU+LLit	                \ alu-op -- opcode'
  0F00 And  ?Subtract			\ Extract Operator
  0D080 Or				\ Insert opcode D-OP-T
;

\ ALUop                                            sfp 31/08/90
Hex

: Alu-Dyad-Op	                \ n -- ; -- [child]
  Create  ,  0A020 ,  Immediate  Does>	\ get opcode
  State @
  If
    @  Optimise?
    If
      Short-Lit?			\ short literal before?
      If
        ALU+SLit Last! Exit
      Endif				\ merge
      Long-Lit-Op?			\ long literal before?
      If
        ALU+LLit Last! Exit
      Endif				\ merge
    Endif
    ,Code
  Else
    Execute
  Endif
;

\ Dyadic ALU Ops                                   sfp 31/08/90
only forth  also Optimiser  also Forth Definitions
0A240 ALU-Dyad-Op AND
0A640 ALU-Dyad-Op OR
0A840 ALU-Dyad-Op +
0A940 ALU-Dyad-Op +c
0AA40 ALU-Dyad-Op XOR
0AC40 ALU-Dyad-Op -
0AD40 ALU-Dyad-Op -c
only forth  also c-c definitions

\ ALU-Op?                                          RTX 21/04/88
Only Forth  also Optimiser definitions  Hex

: ALU-Op?	                \ -- t/f ; true for 1-cycle ALU ops
  Last@
  Dup 0F0F0 And  0A040 =
  Swap 0F00 And  0200 0D00 Within?  And  
;

: Shifted?	                \ -- t/f ; true if shift field used
  Last@ 000F And 0<>  
;

\ Shift-Op                                         sfp 31/08/90
Hex

: Shift-Op
  Create  ,  0A020 ,  Immediate  Does>
  State @
  If
    @  Optimise?
    if
      ALU-Op? Shifted? 0= And
      if
        000F And  Set-in-Last  Exit
      endif
    endif
    ,Code
  Else
    Execute
  Endif
;

\ shift-ops                                        sfp 31/08/90
only forth  also Optimiser  also Forth definitions
0A001 Shift-Op 0<
0A002 Shift-Op 2*
0A003 Shift-OP 2*c
0A004 Shift-Op cU2/
0A005 Shift-Op c2/
0A006 Shift-Op U2/
0A007 Shift-Op 2/
only Forth definitions

