\ ROM Forth XMODEM file upload tool                  sfp 15/05/88
pto

Copyright (c) 1988  MicroProcessor Engineering

Released for use with the MPE/Nautilus Cross Compiler by:

MicroProcessor Engineering
133 Hill Lane
Shirley
Southampton SO1 5AF
England

tel: 0703 631441        (inside U.K.)
     (+44) 703 631441   (international)
   
\ Constants & Variables                            sfp 12/09/89
internal				\

hex					\

01 constant SOH				\ File transfer
04 constant EOT				\   constants

decimal					\

variable BLK#				\ Current Block No.
variable CUR-ADDRESS			\ Current host address
variable LAST-BYTES			\ #bytes mod 128 decimal

\ X-buffer To-Buffer                               sfp 26/03/90
decimal					\

: x-buffer	                \ -- addr
  here 64 +				\ just above here
;

: To-Buffer	                \ -- ;
  CUR-ADDRESS @ X-buffer 128 cmove	\ Move 128 bytes from
  128 cur-address +!			\ memory pointed to by
;

\ CUR-ADDRESS into buff

: ?Ack		                \ --
  ser-key ACK <>			\ wait for response
  IF
    EOT ser-emit			\ flag end of XMODEM
    1 abort" File Transfer error"	\ MUST be ACK
  ENDIF
;					\

\ Send-Block ...........................           sfp 12/09/89
Decimal

: Send-Block	                \ Blk# -- ;
  SOH ser-emit				\ Start of header
  dup ser-emit				\ Block Number
  not ser-emit				\ 1's complement Block#
  0  X-buffer 128 bounds		\ Send 128 byte Block
  DO
    i c@				\ get byte from buffer
    dup ser-emit			\ transmit it
    + 255 and				\ Add to Check-Sum
  LOOP					\
  ser-emit				\ Send Check-Sum
  ?Ack					\ wait response
;

\ Calc-Last-Bytes, Send-Last-Blk .......           sfp 12/09/89
Decimal					\

: Calc-Last-Bytes                \ #cells -- #blks
  0 128 um/mod				\ use 128 byte chunks
  swap LAST-BYTES !			\ No. of remaining bytes
  1 BLK# !				\ start with block 1
;

: Send-Last-Blk	                \ -- ;
  LAST-BYTES @ ?dup			\ Any bytes left ?
  IF
    X-buffer 128 blank			\ erase buffer
    CUR-ADDRESS @ X-buffer rot cmove	\ copy last bits to buff
    BLK# @ send-block			\ send block
  ENDIF
;					\

\ Bin-Down .............................           sfp 12/09/89
External

: Bin-Down	                \ addr #bytes --
  cr cr ." Start XMODEM receiver - [PgDn],1 with ProComm" cr
  swap CUR-ADDRESS !			\ Start from addr
  calc-last-bytes			\ This is for last Block
  BEGIN
    ser-key NAK =
  UNTIL					\ Wait for receiver ...
  1+ 1					\ block numbers from 1
  ?DO
    to-buffer				\ Transfer mem to buffer
    i send-block			\ Send this block
    1 BLK# +!				\ Count blocks sent
  LOOP					\
  send-last-blk				\ Check for last Block
  EOT ser-emit  ?Ack			\ terminate XMODEM
  cr ." File transfer successful" cr	\
;

