\ Target block words for use with XSHELL
pto

(c) MicroProcessor Engineering Ltd
    133 Hill Lane
    Southampton
    SO1 5AF

  (0703) 631 441
  (+44)  703 631 441

\ variables and space allocation                 J Lee 29/11/90
decimal

$400 2+ equ block-size				\ first 2 bytes contain flags				 

rom?
if(    
  there constant first block-size allot-ram	\ in ram space
)else( 
  create first block-size allot			\ or dictionary space
)endif 

0 first !					\ 1st element is block# 

 
((
VARIABLE FIRST				\ -- addr ; first element is block no.
1024					\ size of block buffer
Rom?
if(     allot-ram			\ separate RAM space
)else(  allot				\ or in dictionary space
)endif
))

\ ser-blk-read                                     sfp 20/04/90
decimal

: SER-BLK-READ	                \ addr blk# --
  ^R ser-emit				\ send read code
  synch-to-host				\
  send-block#				\ send block no.
  1023					\ 1024 bytes
  For
    ser-key over c!  1+			\ store and inc. address
  Next					\
  Drop  ACK ser-emit			\ send ack to complete transfer
  Wait-Ack/Nack Disk-error !		\ get status response
;

\ ser-blk-write                                    sfp 20/04/90
Decimal

: SER-BLK-WRITE	                \ addr blk# --
  ^W ser-emit				\ send write code
  synch-to-host				\
  send-block#				\ send block no.
  1023					\ 1024 bytes
  For
    Dup C@ Ser-emit  1+			\ send byte & incr. address
  Next					\
  Drop					\ drop address
  Wait-Ack/Nack Disk-Error !		\ wait for ack
;

\ Blk-Read Blk-Write Serial-disc                   sfp 20/04/90

Defer Blk-Write				\ addr blk# --
Assign Ser-Blk-Write  To-Do Blk-Write

Defer Blk-Read				\ addr blk# --
Assign Ser-Blk-Read   To-Do Blk-Read

: serial-disc	                \ -- ; set up to use serial disc
  Assign Ser-Blk-Write To-Do Blk-Write
  Assign Ser-Blk-Read  To-Do Blk-Read 
;

\ save-buffers, empty-buffers, update, flush        R. sfp 26/01/90
HEX

: SAVE-BUFFERS	                \ -- ;
  FIRST @ 0<				\ buffer marked as changed?
  IF					\ if so....
    FIRST 2+				\   leave buffer address
    FIRST @ 07FFF AND			\   clear update flag
    DUP FIRST !				\   buffer-addr blk# --
    BLK-WRITE				\   write this changed block
  endif					\ or else don't save it
;					\

: EMPTY-BUFFERS	                \ -- ;
  FIRST block-size ERASE 		\ clear buffer to zeroes
  07FFF FIRST !				\ clear resident block number
;

: UPDATE	                \ -- ;
  FIRST @  08000 OR			\
  FIRST !				\ mark resident block as changed
;

: FLUSH		                \ -- ;
  SAVE-BUFFERS  EMPTY-BUFFERS		\ flush any changes to disk
;

\ block                                         R. sfp 26/01/90
HEX

: (BLOCK)		                \ blk# -- address ;
  DUP  FIRST @ 07FFF AND  =		\ already in ?
  IF
    DROP				\ yes, discard
  ELSE
    SAVE-BUFFERS			\ no, save current buffer
    FIRST 2+ OVER BLK-READ		\ read new
    FIRST !				\ set blk#
  ENDIF					\
  FIRST 2+				\ return addr (fixed)
;
	 
assign (block) to-do block

\ cls (line) .line ? loading                       R. sfp 26/01/90
hex

: CLS		                \ -- ;
  03 ser-emit				\ send a ^C to trigger host CLS
;

: (LINE)	                \ line# blk# -- addr #chars ;
  >R 040 0400 */MOD R> +		\
  BLOCK + 040				\ step line by line through block
;					\ buffer

: .LINE		                \ line# blk# -- ;
  (LINE)  -TRAILING  TYPE		\ show contents of line
;

: ?LOADING	                \ -- ; error if input from console
  BLK @ 0=				\ BLK==0 : console
  016 ?ERROR				\ error if not loading
;

\ list                                          R. sfp 26/01/90
hex

: LIST		                \ blk# -- ;
  CLS DUP SCR !				\ clear screen, set variable
  ." Screen " .				\ print header
  010 0					\ the number of lines
  DO
    CR  I 1+ 3 .R SPACE			\ for each line print line no.
    I SCR @ .LINE			\ and line from block
    KEY?
    IF
      LEAVE
    endif				\ check if early finish
  LOOP
  CR					\ new line
;

\ Misc Output .....................................sfp 01/09/90
hex

: L		                \ --
  Scr @ List  
;

: N		                \ --
  Scr @ 1+  07FFF and  List  
;

: P		                \ --
  Scr @ 1-  0 max  List  
;

\ Misc Output .....................................sfp 20/04/90
Decimal

: Index		                \ n1 n2 -- ; list top lines in range of screens
  Cr  1+ Swap				\
  ?DO
    I Block Drop			\
    Halt? Disk-Error @ Or ?LEAVE	\
    Cr I 3 .R Space  0 I .Line		\
  LOOP
;					\

: Qx		                \ --
  0 32767 Index  
;

\ Misc Output .....................................sfp 20/04/90
INTERNAL				\

Variable Quit-Flag			\

EXTERNAL				\

: Triad		                \ n -- ; list 3 screens starting with n
  Dup 3 + Swap				\
  DO
    I Block Drop			\
    Disk-Error @ Halt? Or		\
    Dup Quit-Flag !  ?LEAVE		\
    Cr I List				\
  LOOP
;					\

\ Misc Output .....................................sfp 01/09/90
Decimal

: Show		                \ n1 n2 --
  2Dup > 69 ?Error			\
  Quit-Flag Off  Page# Off  1+ Swap	\
  DO
    Page  Cr				\
    10 Spaces				\
    I Triad				\
    L/P 4 -  Line# @ -  0 Max  0	\
    ?DO
      Cr
    LOOP				\
    ." MPE ROM PowerForth"		\
    22 Spaces  ." Page " Page# ?	\
    Quit-Flag @ ?LEAVE			\
  3 +LOOP
;

\ listing .........................................sfp 20/04/90
Decimal

: Listing	                \ --
  0 32767 Show  
;

\ load thru -->                                   R. sfp 11/08/90
hex

\ These words provide control within a file, same as host words

: LOAD		                \ blk# -- ;
  BLK @ >R  >IN @ >R			\ preserve blk# & input position
  0 >IN !  BLK !			\ set up for this block number
  ?LOADING				\ can't load from block 0
  INTERPRET				\ interpret from this block
  R> >IN !  R> BLK !			\ finished: restore pointers
;

: THRU		                \ blk#from blk#to -- ;
  1+ SWAP				\ form limit & index
  DO
    I LOAD				\ load the index number block
  LOOP
;

: -->		                \ -- ;
  ?LOADING				\ must be loading
  0 >IN !  1 BLK +!			\ step to next block
; immediate				\ this word is immediate:
					\ a word may cover 2+ screens

\ $using using                                  R. sfp 26/01/90

\ NB $USING in this implementation does not return a t/f flag
\ as the host version does. The host takes care of creating
\ non existent files.

: $using	                \ $addr -- ;
  ^u send$				\ send string to host
;

: using		                \ <file> -- ;
  bl word				\ get string from keyboard
  $using				\ open it on host
;

